<?php

// You may replace $redux_opt_name with a string if you wish. If you do so, change loader.php
// as well as all the instances below.

if ( !function_exists( "fastwp_add_metaboxes" ) ){
    function fastwp_add_metaboxes( $metaboxes ) {
        // Section Team
    $boxSectionPost = $boxSectionsTeam = $boxSectionsGalleryPost = $boxSectionsVideoPost =  $boxSectionsPage = $boxSectionsPortfolio = $boxSectionsSections = $metaboxes = array();

    $boxSectionsSections[] = array(
            'title'         => esc_html__( ' Section Options', 'conrad' ),
            'fields'        => array(
            array(
                'id'        => 'background',
                'type'      => 'color',
                'title'     => esc_html__( 'Section Background', 'conrad' ),
                'subtitle'  => esc_html__( 'Select icon color - default #232323', 'conrad' ),
                'transparent' => false,
                'validate'  => 'color',
            )
            )
    );

    $boxSectionPost[] = array(
            'icon'          => 'el-icon-wrench',
            'icon_class'    => 'icon_large',
            // 'title'         => esc_html__( 'General', 'conrad' ),
            'fields'        => array(
            array(
                 'id'       => 'hero_image',
                 'type'     => 'media',
                 'title'    => esc_html__( 'Hero Background', 'conrad' ),
                 'subtitle' => esc_html__( 'Image background used as hero title. Recommended size: 1250 x 500', 'conrad' )
            ),
			array(
                 'id'       => 'nav_img',
                 'type'     => 'media',
                 'title'    => esc_html__( 'Navigation Background', 'conrad' ),
                 'subtitle' => esc_html__( 'Image background like a preview for this post (appear in navigation). Recommended size: 555 x 100', 'conrad' )
            )
            )
    );

    // Post template with hero image

    $boxSectionsPortfolio[] = array(
            'icon'          => 'el el-bookmark',
            'icon_class'    => 'icon_large',
            'title'         => esc_html__( 'Portfolio Header/Footer', 'conrad' ),
            'fields'        => array (
              array(
                            'id'        => 'fwp_navigation_style',
                            'type'      => 'select',
                            'title'     => esc_html__( 'Navigation Style', 'conrad' ),
                            'options'   => array(
                                                ''  => 'Inherit',
                                                '0' => 'Default',
                                                '1' => 'Transparent',
                                                '2' => 'Tall',
                                                '3' => 'Right aligned items',
                                                '4' => 'Sticky After First Section',
                                                ),
                            'default'   => ''
                    ),
                    array(
                        'id'        => 'fwp_prefooter',
                        'type'      => 'switch',
                        'title'     => esc_html__( 'Display Prefooter', 'conrad' ),
                        'default'   => 1,
                        'on'        => 'Default',
                        'off'       => 'Disabled'
                    ),
            )
        );


    $boxSectionsPortfolio[] = array(
            'icon'          => 'el-icon-screen',
            'icon_class'    => 'icon_large',
            'title'         => esc_html__( 'Portfolio Hero Section', 'conrad' ),
            'fields' => array(
                array(
                   'id'       => 'nav_img',
                   'type'     => 'media',
                   'title'    => esc_html__( 'Project Navigation Image', 'conrad' ),
                   'subtitle' => esc_html__( 'Image background like a preview for this project (appear in navigation). Recommended size: 555 x 100. If none is provided project thumbnail is used', 'conrad' ),
                ),
                array(
                    'id'       => 'project_hero_switch',
                    'type'     => 'button_set',
                    'title'    => esc_html__( 'Project hero', 'conrad' ),
                    'subtitle' => esc_html__( 'Choose the type of project hero. ', 'conrad' ),
                        'options' => array(
                                'hero' => 'Static Hero',
                                'none' => 'None',
                             ),
                    'default'  => 1,
                ),
                array(
                   'id'       => 'project_hero_image',
                   'type'     => 'media',
                   'title'    => esc_html__( 'Project Background Image', 'conrad' ),
                   'subtitle' => esc_html__( 'Hero Image background, recommended size: 1250 x 500', 'conrad' ),
                   'required'  => array('project_hero_switch','equals','hero')
                ),
                array(
                    'id'        => 'project_hero_title',
                    'type'      => 'text',
                    'title'     => esc_html__( 'Project title', 'conrad' ),
                    'subtitle'  => esc_html__( 'If empty, will use Project title', 'conrad' ),
                    'default'   => '',
                    'required'  => array('project_hero_switch','equals','hero')
                ),
                array(
                    'id'        => 'project_hero_bgcolor',
                    'type'      => 'color',
                    'title'     => esc_html__( 'Background color', 'conrad' ),
                    'subtitle'  => esc_html__( 'Default #e62739 This will be used when no project image or thumbnail available.', 'conrad' ),
                    'transparent' => false,
                    'default'   => '#e62739',
                    'validate'  => 'color',
                    'required'  => array('project_hero_switch','equals','hero')
                ),
                array(
                    'id'        => 'project_hero_txtcolor',
                    'type'      => 'color',
                    'title'     => esc_html__( 'Text color', 'conrad' ),
                    'subtitle'  => esc_html__( 'Default #FFFFFF. Use this to change hero title color depending on background', 'conrad' ),
                    'transparent' => false,
                    'default'   => '#FFFFFF',
                    'validate'  => 'color',
                    'required'  => array('project_hero_switch','equals','hero')
                ),
                array(
                'id'       => 'project_hero_height',
                'type'     => 'button_set',
                'title'    => esc_html__( 'Hero image section style', 'conrad' ),
                'subtitle' => esc_html__( 'Her section size - tall / small. Default : small', 'conrad' ),
                    'options' => array(
                            '1' => 'Small',
                            '2' => 'Tall'
                         ),
                'default'  => 1,
                'required'  => array('project_hero_switch','equals','hero')
                ),
            )
    );

    $boxSectionsPortfolio[] = array(
            'icon'          => 'el-icon-wrench',
            'icon_class'    => 'icon_large',
            'title'         => esc_html__( 'General', 'conrad' ),
            'fields'        => array(
			array(
                 'id'       => 'portfolio_url',
                 'type'     => 'text',
                 'title'    => esc_html__( 'Target URL', 'conrad' ),
                 'subtitle' => esc_html__( 'Default target url is project url. You can override here user for example : http://themes.fastwp.net/conrad ', 'conrad' )
            ),
            array(
                'id' => 'portfolio_caption_html',
                'type' => 'textarea',
                'title' => esc_html__( 'Caption text', 'conrad' ),
                'subtitle' => esc_html__( 'To use caption instead of project title on portfolio grid fill this field', 'conrad' ),
                'default' => '',
            ),
			array(
                'id'        => 'portfolio_wide_2x2',
                'type'      => 'select',
                'title'     => esc_html__( 'Large', 'conrad' ),
                'subtitle'  => esc_html__( 'Make an image wide (double row width and columns - 2x2), should be used for masonry layout', 'conrad' ),
				'options'   => array(
						'no'=>'No',
						'yes'=>'Yes'
                ),
                'default'   => 'no'
            ),
            array(
                'id'        => 'portfolio_wide_2x1',
                'type'      => 'select',
                'title'     => esc_html__( 'Wide', 'conrad' ),
                'subtitle'  => esc_html__( 'Make an image wide (double row width - 2x1), should be used for masonry layout', 'conrad' ),
                'options'   => array(
                        'no'=>'No',
                        'yes'=>'Yes'
                ),
                'default'   => 'no'
            ),
			array(
                'id'        => 'portfolio_tall_1x2',
                'type'      => 'select',
                'title'     => esc_html__( 'Tall', 'conrad' ),
                'subtitle'  => esc_html__( 'Make an image taller (double row height - 1x2), should be used for masonry layout', 'conrad' ),
				'options'   => array(
						'no'=>'No',
						'yes'=>'Yes'
                ),
                'default'   => 'no'
            )
            ),
            array(
                'id' => 'portfolio_caption_html',
                'type' => 'textarea',
                'title' => esc_html__( 'Caption text', 'conrad' ),
                'subtitle' => esc_html__( 'To use caption instead of project title on portfolio grid fill this field', 'conrad' ),
                'default' => '',
            ),
        );

        $boxSectionsPortfolio[] = array(
            'icon'          => 'el el-adjust-alt',
            'icon_class'    => 'icon_large',
            'title'         => esc_html__( 'Styling', 'conrad' ),
            'fields'        => array(
             array(
                'id'       => 'portfolio_hover_switch',
                'type'     => 'button_set',
                'title'    => esc_html__( 'Portfolio image overlay type', 'conrad' ),
                'subtitle' => esc_html__( 'Choose the type of portfolio image overlay.', 'conrad' ),
                    'options' => array(
                            '1' => 'Custom',
                            '2' => 'None',
                         ),
                'default'  => 1,
            ),
            array(
                'id'        => 'portfolio_overlay_type',
                'type'      => 'select',
                'title'     => esc_html__( 'Choose overlay effect', 'conrad' ),
                'desc'      => esc_html__( 'Choose from predefined overlay effects', 'conrad' ),
                'options'   => array(
                        'overlay-fade-in'           => 'Overlay Fade In',
                        'img-scale-in'              => 'Image Scale In',
                        'overlay-fade-img-scale-in' => 'Overlay Fade Image Scale In',
                        'overlay-fade-img-scale-out'=> 'Overlay Fade Image Scale Out',
                        'overlay-slide-in-top'      => 'Overlay Slide in From Top',
                        'overlay-slide-in-left'     => 'Overlay Slide in From Left',
                        'overlay-slide-in-right'    => 'Overlay Slide in From Right',
                        'overlay-slide-in-bottom'   => 'Overlay Slide in From Bottom',
                        'overlay-img-slide-up'      => 'Image Slide Up',
                        'overlay-img-slide-left'    => 'Image Slide Left',
                        'overlay-img-slide-right'   => 'Image Slide Right',
                        'overlay-img-slide-down'    => 'Image Slide Down',
                        'overlay-scale-in'          => 'Overlay Scale In',
                        'overlay-scale-in img-scale-in' => 'Overlay and Image Scale In',
                ),
                'default'   => 'no',
                'required'  => array('portfolio_hover_switch','not','2')
            ),
            array(
                'id'        => 'portfolio_overlay_easing',
                'type'      => 'select',
                'title'     => esc_html__( 'Choose overlay effect easing', 'conrad' ),
                'desc'      => esc_html__( 'Choose from predefined easing effects, example here https://api.jqueryui.com/easings', 'conrad' ),
                'options'   => array(
                        'linear'            => 'linear',
                        'swing'             => 'swing',
                        'easeInOut'			=> 'easeInOut',
                        'easeInQuad'        => 'easeInQuad',
                        'easeOutQuad'       => 'easeOutQuad',
                        'easeInOutQuad'     => 'easeInOutQuad',
                        'easeInCubic'       => 'easeInCubic',
                        'easeOutCubic'      => 'easeOutCubic',
                        'easeInOutCubic'    => 'easeInOutCubic',
                        'easeInQuart'       => 'easeInQuart',
                        'easeOutQuart'      => 'easeOutQuart',
                        'oeaseInOutQuart'   => 'oeaseInOutQuart',
                        'oeaseInQuint'      => 'oeaseInQuint',
                        'oeaseOutQuint'     => 'oeaseOutQuint',
                        'easeInExpo'        => 'easeInExpo',
                        'easeOutExpo'       => 'easeOutExpo',
                        'easeInOutExpo'     => 'easeInOutExpo',
                        'easeInSine'        => 'easeInSine',
                        'easeOutSine'       => 'easeOutSine',
                        'easeInOutSine'     => 'easeInOutSine',
                        'easeInOutQuint'    => 'easeInOutQuint',
                        'easeInCirc'        => 'easeInCirc',
                        'easeOutCirc'       => 'easeOutCirc',
                        'easeInOutCirc'     => 'easeInOutCirc',
                        'easeInOutQuint'    => 'easeInOutQuint',
                        'easeInElastic'     => 'easeInElastic',
                        'easeOutElastic'    => 'easeOutElastic',
                        'easeInOutElastic'  => 'easeInOutElastic',
                        'easeInBack'        => 'easeInBack',
                        'easeOutBack'       => 'easeOutBack',
                        'easeInOutBack'     => 'easeInOutBack',
                        'easeInOutBounce'   => 'easeInOutBounce'
                ),
                'default'   => 'no',
                'required'  => array('portfolio_hover_switch','not','2')
            ),
            array(
                'id'        => 'portfolio_overlay_color',
                'type'      => 'color',
                'title'     => esc_html__( 'Overlay color', 'conrad' ),
                'subtitle'  => esc_html__( 'Default #000', 'conrad' ),
                'transparent' => false,
                'default'   => '#000',
                'validate'  => 'color',
                'required'  => array('portfolio_hover_switch','not','2')
                ),
            array(
                'id'        => 'portfolio_hover_speed',
                'type'      => 'slider',
                'title'     => esc_html__( 'Overlay hover speed', 'conrad' ),
                'subtitle'  => esc_html__( 'Default 700, in ms', 'conrad' ),
                "min"       => 0,
                "step"      => 100,
                "max"       => 5000,
                'display_value' => 'text',
                'default'   => '700',
                'required'  => array('portfolio_hover_switch','not','2')
                ),
            array(
                'id'        => 'portfolio_overlay_opacity',
                'type'      => 'slider',
                'title'     => esc_html__( 'Overlay opacity', 'conrad' ),
                'subtitle'  => esc_html__( 'Default 0.8', 'conrad' ),
                "min"       => 0,
                "step"      => .1,
                "max"       => 1,
                'resolution' => 0.1,
                'display_value' => 'text',
                'default'   => '0.8',
                'required'  => array('portfolio_hover_switch','not','2')
                ),
            )
       );

        // Video Post
        $boxSectionsVideoPost[] = array(
        	//'title' => esc_html__( ' Settings', 'conrad' ),
        	'icon' => 'el-icon-screen',
        	'fields' => array(
        		array(
        			'id'        => 'post-video-url',
        			'type'      => 'text',
        			'title'     => esc_html__( 'Video URL', 'conrad' ),
        			'subtitle'  => esc_html__( 'YouTube or Vimeo video URL', 'conrad' ),
        			'default'   => '',
        		),
        		array(
        			'id' => 'post-video-html',
        			'type' => 'textarea',
        			'title' => esc_html__( 'Embedded video', 'conrad' ),
        			'subtitle' => esc_html__( 'Use this option when the video does not come from YouTube or Vimeo', 'conrad' ),
        			'default' => '',
        		),
        	)
        );

        // Gagllery Post
        $boxSectionsGalleryPost[] = array(
        	//'title' => esc_html__( ' Settings', 'conrad' ),
        	'icon' => 'el-icon-screen',
        	'fields' => array(
        		array(
        			'id'        => 'post-gallery',
        			'type'      => 'slides',
        			'title'     => esc_html__( 'Gallery Slider', 'conrad' ),
        			'subtitle'  => esc_html__( 'Upload images or add from media library.', 'conrad' ),
        			'placeholder'   => array(
        				'title'         => esc_html__( 'Title', 'conrad' ),
        			),
        			'show' => array(
        				'title' => true,
        				'description' => false,
        				'url' => false,
        			)
        		),
        	)
        );

        // Audio Post
        $boxSectionsAudioPost = array();
        $boxSectionsAudioPost[] = array(
        	//'title' => esc_html__( ' Settings', 'conrad' ),
        	'icon' => 'el-icon-screen',
        	'fields' => array(
        		array(
        			'id'        => 'post-audio-url',
        			'type'      => 'text',
        			'title'     => esc_html__( 'Audio URL', 'conrad' ),
        			'subtitle'  => esc_html__( 'Audio file URL in format: mp3, ogg, wav.', 'conrad' ),
        			'default'   => '',
        		),
        	)
        );

        // Page template with hero image
        $boxSectionsPage[] = array(
            'icon'          => 'el el-bookmark',
            'icon_class'    => 'icon_large',
            'title'         => esc_html__( 'Page Header/Footer options', 'conrad' ),
            'fields'        => array(
            array(
                'id'        => 'fwp_navigation_style',
                'type'      => 'select',
                'title'     => esc_html__( 'Navigation Style', 'conrad' ),
                'options'   => array(
                                    ''  => 'Inherit',
                                    '0' => 'Default',
                                    '1' => 'Transparent',
                                    '2' => 'Tall',
                                    '3' => 'Right aligned items',
                                    '4' => 'Sticky After First Section',
                                    ),
                'default'   => ''
            ),
            array(
                'id'        => 'fwp_prefooter',
                'type'      => 'switch',
                'title'     => esc_html__( 'Display Prefooter', 'conrad' ),
                'default'   => 1,
                'on'        => 'Default',
                'off'       => 'Disabled'
            ),
            )
        );
        $boxSectionsPage[] = array(
            'title'     => esc_html__( 'Page Hero Settings', 'conrad' ),
            'subtitle'  => esc_html__( 'Use this in order to set hero page styling. Note: this is only for page with hero template', 'conrad' ),
            'icon' => 'el-icon-screen',
            'fields' => array(
                array(
                    'id'        => 'page_hero_title',
                    'type'      => 'text',
                    'title'     => esc_html__( 'Page title', 'conrad' ),
                    'subtitle'  => esc_html__( 'If empty, will use page title set on editor', 'conrad' ),
                    'default'   => '',
                ),
                array(
                    'id'        => 'page_hero_bgcolor',
                    'type'      => 'color',
                    'title'     => esc_html__( 'Background color', 'conrad' ),
                    'subtitle'  => esc_html__( 'Choose Hero section background color, Default #e62739. This will be used when no project image or thumbnail available.', 'conrad' ),
                    'transparent' => false,
                    'default'   => '#e62739',
                    'validate'  => 'color',
                ),
                array(
                    'id'        => 'page_hero_txtcolor',
                    'type'      => 'color',
                    'title'     => esc_html__( 'Text color', 'conrad' ),
                    'subtitle'  => esc_html__( 'Default #FFFFFF', 'conrad' ),
                    'transparent' => false,
                    'default'   => '#FFFFFF',
                    'validate'  => 'color',
                ),
                array(
                    'id'       => 'page_hero_height',
                    'type'     => 'button_set',
                    'title'    => esc_html__( 'Hero image section style', 'conrad' ),
                    'subtitle' => esc_html__( 'Default : small', 'conrad' ),
                        'options' => array(
                                '1' => 'Small',
                                '2' => 'Tall'
                             ),
                    'default'  => 2,
                ),
                 array(
                    'id'       => 'page_hero_retina_image',
                    'type'     => 'media',
                    'title'    => esc_html__( 'Retina Hero Image', 'conrad' ),
                    'value'    => '',
                    'default'  => '',
                    'subtitle' => esc_html__( 'Hero Image used for Retina Devices', 'conrad' ),
                    'output'   => '.footer .footer-bottom'
                ),
            )
        );

        // Page template with full height sections

        $boxSectionsPage[] = array(
            'icon' => 'el-icon-screen',
            'title'     => esc_html__( 'Full Screen Section Options', 'conrad' ),
            'fields' => array(
                array(
                    'id'        => 'fwp_section_chromatic',
                    'type'      => 'button_set',
                    'title'     => esc_html__( 'Section Style', 'conrad' ),
                    'subtitle'  => esc_html__( 'Default: White', 'conrad' ),
                    'options'   => array(
                                '1' => 'White',
                                '0' => 'Dark'
                             ),
                    'default'   => '1'
                ),
                array(
                'id'       => 'fwp_has_full_height',
                'type'     => 'button_set',
                'title'    => esc_html__( 'Full height sections', 'conrad' ),
                'subtitle' => esc_html__( 'Default : No', 'conrad' ),
                    'options' => array(
                            '0' => 'No',
                            '1' => 'Yes'
                         ),
                'default'  => '0',
            ),
                array(
                'id'       => 'fwp_has_bullet_nav',
                'type'     => 'button_set',
                'title'    => esc_html__( 'Bullet navigation', 'conrad' ),
                'subtitle' => esc_html__( 'Default : No', 'conrad' ),
                    'options' => array(
                            '0' => 'No',
                            '1' => 'Yes'
                         ),
                'default'  => '0',
            ),
            array(
                'id'       => 'fwp_fs_section_image',
                'type'     => 'media',
                'title'    => esc_html__( 'Full Screen Image', 'conrad' ),
                'subtitle' => esc_html__( 'Image background for presentation page. Recomanded size 1920x1200px', 'conrad' )
            ),
            array(
                    'id'        => 'fwp_fs_section_color',
                    'type'      => 'color',
                    'title'     => esc_html__( 'Background Color', 'conrad' ),
                    'subtitle'  => esc_html__( 'Background color for presentation page. ', 'conrad' ),
                    'transparent' => false,
                    'default'   => '',
                    'validate'  => 'color',
            ),
            array(
                    'id'        => 'fwp_fs_section_mobile_color',
                    'type'      => 'color',
                    'title'     => esc_html__( 'Inner Content', 'conrad' ),
                    'subtitle'  => esc_html__( 'Background color for inner content on mobile', 'conrad' ),
                    'transparent' => false,
                    'default'   => '',
                    'validate'  => 'color',
            ),
            array(
                    'id'        => 'fwp_fs_extra_class',
                    'type'      => 'text',
                    'title'     => esc_html__( 'Extra Class', 'conrad' ),
                    'subtitle'  => esc_html__( 'Fill an extra class for this page', 'conrad' ),
                    'transparent' => false,
                    'default'   => ''
            ),
            )
        );

        // Declare your metaboxes

        $metaboxes[] = array(
            'id'            => 'sidebar',
            'title'         => esc_html__( 'Post Options', 'conrad' ),
            'post_types'    => array( 'post' ),
            'position'      => 'advanced', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionPost,
        );
        $metaboxes[] = array(
            'id'            => 'sidebar',
            'title'         => esc_html__( 'Options', 'conrad' ),
            'post_types'    => array( 'fwp_fs_sections' ),
            'position'      => 'normal', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionsSections,
        );
        $metaboxes[] = array(
            'id'            => 'sidebar',
            'title'         => esc_html__( 'Options', 'conrad' ),
            'post_types'    => array( 'fwp_portfolio' ),

            'position'      => 'normal', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionsPortfolio,
        );
        $metaboxes[] = array(
		    'id' => 'video-post-options',
            'title'         => esc_html__( 'Options', 'conrad' ),
            'post_types'    => array('post'),
            'position'      => 'normal', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionsVideoPost,
            'post_format'   => array('video'),
        );
         $metaboxes[] = array(
		    'id' => 'gallery-post-options',
            'title'         => esc_html__( 'Options', 'conrad' ),
            'post_types'    => array('post'),
            'position'      => 'normal', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionsGalleryPost,
            'post_format'   => array('gallery'),
        );
        $metaboxes[] = array(
            'id' => 'audio-post-options',
            'title'         => esc_html__( 'Conrad Options', 'conrad' ),
            'post_types'    => array('post'),
            'post_format'   => array('audio'),
            'position'      => 'normal', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionsAudioPost,
        );
        $metaboxes[] = array(
            'id' => 'page-options',
            'title'         => esc_html__( 'Conrad Options', 'conrad' ),
            'post_types'    => array('page'),
            'position'      => 'advanced', // normal, advanced, side
            'priority'      => 'high', // high, core, default, low - Priorities of placement
            'sections'      => $boxSectionsPage,
        );

        return $metaboxes;
    }

  add_action("redux/metaboxes/fastwp_conrad_data/boxes", 'fastwp_add_metaboxes');

}