<?php

/*
* The template for displaying Comments
*
* The area of the page that contains comments and the comment form.


/*
 * If the current post is protected by a password and the visitor has not yet
 * entered the password we will return early without loading the comments.
 */

if (post_password_required() || (!have_comments() && !comments_open())) return;

do_action('fastwp-conrad-output-comment-number-markup');

?>

<?php if ( have_comments() ) { ?>

<div id="comments" class="post-comments">

<div class="post-comments-aside">
    <span class="comments-title"><?php printf( '%s %s', get_comments_number(), esc_html__( 'Comments','conrad' ) ); ?></span>
</div>

<div class="comments-inner">
<div class="comments">
	<ul class="comment-list">

    <?php

    wp_list_comments( array( 'callback' => 'fastwp_conrad_comment', 'end-callback' => 'fastwp_conrad_comment_close_tag', 'style' => '' ) );

    // Are there comments to navigate through?
    if ( get_comment_pages_count() > 1 && get_option( 'page_comments' ) ) {

    }

    ?>

	</ul>
</div>
</div>
</div>

<div class="row">
    <div class="column width-6">
        <?php previous_comments_link( __('<span class="icon-arrow-left"></span> Previous Comments','conrad') ); ?>
    </div>
    <div class="column width-6 right">
        <?php next_comments_link( __('Next Comments <span class="icon-arrow-right"></span>','conrad') ); ?>
    </div>
</div>


<?php if ( !comments_open() && get_comments_number() ) { ?>
    <p class="no-comments"><?php esc_html_e('Comments are closed.', 'conrad'); ?></p>
<?php } ?>

<?php } ?>

<div id="leave-comment" class="post-comment-respond">
    <?php fastwp_conrad_comment_form(); ?>
</div>