<?php

/**
The default template for displaying content
Used for both single and index/archive/search.
*/

// load all the options
$fastwp_conrad_options = fastwp_conrad_get_option( array( 'fwp_blog_category_meta', 'fwp_blog_date_meta', 'fwp_blog_name_meta' ) );

?>

<article class="post">
    <div class="post-media">
        <div class="thumbnail img-scale-in" data-hover-easing="easeInOut" data-hover-speed="500" data-hover-bkg-color="000000" data-hover-bkg-opacity="0.6">
        <a class="overlay-link" href="<?php the_permalink(); ?>">
            <?php if( has_post_thumbnail() ) the_post_thumbnail( 'full' ); ?>
        	<span style="transition-duration: 500ms; background-color: rgba(0, 0, 0, 0.6);" class="overlay-info">
    			<span>
                <?php if( empty( $fastwp_conrad_options['fwp_blog_category_meta'] ) ) { ?>
    				<span>
    					<?php esc_html_e( 'In', 'conrad' ); ?> <?php echo fastwp_conrad_get_category_list(true, ', '); ?>
    				</span>
                <?php } ?>
    			</span>
        	</span>
        </a>
        <div class="post-info post-info-over center show hide-on-mobile">
        	<div class="post-info-inner">
                <?php if( empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) { ?>
        		<div class="post-date">
                    <span class="day"><?php echo get_the_time( 'd' ); ?></span>
                    <span class="month-year"><?php echo get_the_time( 'M' ); ?> '<?php echo get_the_time( 'y' ); ?></span>
                </div>
                <?php } ?>
        	</div>
        </div>
        </div>
    </div>

    <div class="post-content">
        <h2 class="post-title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
        <div class="post-info">
            <?php if( empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) { ?>
        <span class="post-date hide show-on-mobile"><?php echo get_the_time( get_option( 'date_format' ) ); ?> /</span>
            <?php } ?>
            <?php if( empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) { ?>
    	    <span class="post-date hide show-on-mobile"><?php echo get_the_time( get_option( 'date_format' ) ); ?> /</span>
            <?php }
            if( empty( $fastwp_conrad_options['fwp_blog_name_meta'] ) ) { ?>
            <span class="post-autor"><?php esc_html_e( 'By', 'conrad' ); ?> <?php the_author_posts_link(); ?></span>
            <?php }
            if( function_exists( 'zilla_likes' ) ) echo zilla_likes( '%likes', '', '/ <span class="post-love">', '</span>' ); ?>
        </div>
        <p><?php the_excerpt(); ?></p>
    </div>
</article>