<?php

/**
The default template for displaying content
Used for both single and index/archive/search.
*/

// load all the options
$fastwp_conrad_options = fastwp_conrad_get_option( array( 'fwp_blog_category_meta', 'fwp_blog_date_meta', 'fwp_blog_comments_meta', 'fwp_blog_name_meta' ) );

?>

<article class="post">
    <div class="post-media">
        <div class="thumbnail img-scale-in" data-hover-easing="easeInOut" data-hover-speed="500" data-hover-bkg-color="000000" data-hover-bkg-opacity="0.6">
        	<a class="overlay-link" href="<?php the_permalink(); ?>">
        		<?php if( has_post_thumbnail() ) the_post_thumbnail( 'full' ); ?>
        		<span class="overlay-info">
        			<span>
                    <?php if( empty( $fastwp_conrad_options['fwp_blog_category_meta'] ) ) { ?>
        				<span>
        					<?php esc_html_e( 'In', 'conrad' ); ?> <?php echo fastwp_conrad_get_category_list(true, ', '); ?>
        				</span>
                    <?php } ?>
        			</span>
        		</span>
        	</a>
        	<div class="post-info post-info-over show hide-on-mobile">
        		<div class="post-info-inner">
                <?php if( empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) { ?>
        			<div class="post-date">
                        <span class="day"><?php echo get_the_time( 'd' ); ?> </span>
                        <span class="month-year"><?php echo get_the_time( 'M' ); ?> '<?php echo get_the_time( 'y' ); ?></span>
                    </div>
                <?php } ?>
        		</div>
        	</div>
        </div>
    </div>
    <div class="post-info post-info-aside">
    <div class="post-info-inner">
        <?php if( empty( $fastwp_conrad_options['fwp_blog_name_meta'] ) ) { ?>
    	    <span class="post-autor"><?php the_author_posts_link(); ?></span>
        <?php }
        if( empty( $fastwp_conrad_options['fwp_blog_comments_meta'] ) ) {
        $fastwp_conrad_comments = wp_count_comments( get_the_ID() )->approved; ?>
        <span class="post-comment"><a href="<?php the_permalink(); ?>#comments"><?php echo ( $fastwp_conrad_comments > 0 ? sprintf( esc_html__( '%s Comments', 'conrad' ), $fastwp_conrad_comments ) : esc_html__( 'No Comments', 'conrad' ) ); ?></a></span>
        <?php } ?>
    </div>
    <?php if( function_exists( 'zilla_likes' ) ) echo zilla_likes( '%likes', '', '<div class="post-love">', '</div>' ); ?>
    </div>
    <div class="post-content">
        <h2 class="post-title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
        <div class="post-info">
            <?php if( empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) { ?>
        	    <span class="post-date hide show-on-mobile"><?php echo get_the_time( get_option( 'date_format' ) ); ?> /</span>
            <?php }
            if( empty( $fastwp_conrad_options['fwp_blog_name_meta'] ) ) { ?>
            <span class="post-autor hide show-on-mobile"><?php the_author_posts_link(); ?></span>
            <?php }
            if( empty( $fastwp_conrad_options['fwp_blog_comments_meta'] ) ) { ?>
            <span class="post-comment hide show-on-mobile">/ <a href="<?php the_permalink(); ?>#comments"><?php echo wp_count_comments( get_the_ID() )->approved; ?><?php echo ( $fastwp_conrad_comments > 0 ? sprintf( esc_html__( '%s Comments', 'conrad' ), $fastwp_conrad_comments ) : esc_html__( 'No Comments', 'conrad' ) ); ?></a></span>
            <?php } ?>
            <span class="post-love hide show-on-mobile"><?php if( function_exists( 'zilla_likes' ) ) echo '/ ' . zilla_likes( '%likes', '', '<div class="post-love">', '</div>' ); ?></span>
        </div>
        <p><?php the_excerpt(); ?></p>
        <div class="post-read-more">
        	<a class="animated-link read-more" href="<?php the_permalink(); ?>"><?php esc_html__( '<span class="text-line bkg-charcoal"></span> Read More', 'conrad' ); ?></a>
        </div>
    </div>
</article>