<?php

if ( ! function_exists( 'fastwp_conrad_get_category_list' ) ) {
	function fastwp_conrad_get_category_list($strip_tags = false, $separator = ' / ')
	{
		$categories_list = get_the_category_list( $separator );
		if( $strip_tags == true ) {
			return strip_tags( $categories_list );
		} else {
			return $categories_list;
		}
	}
}

if ( ! function_exists( 'fastwp_conrad_posts' ) ) :
	function fastwp_conrad_posts( $layout = 'blog-list' ) {
    global $fastwp_conrad_last_post_id, $fastwp_conrad_first_post_id;

    $posts_args = apply_filters( 'fastwp_conrad_blog_args', '' );
    if( is_array( $posts_args ) ) {
        query_posts( $posts_args );
    }

    if ( have_posts() ) {

        $i = 1;
    	while ( have_posts() ) {
    	the_post();
        if( $i == 1 ) {
            $fastwp_conrad_first_post_id = get_the_ID();
        }
        $fastwp_conrad_last_post_id = get_the_ID();

    	do_action('fastwp_conrad_before_post_content');

    	if ($layout == 'blog-columns') {
    		echo '<div class="grid-item'.($i==1 ? ' grid-sizer' : '').'">';
    	}

    	get_template_part('extend-helpers/' . $layout);

    	if ($layout == 'blog-columns') {
    		echo '</div>';
    	}

    	do_action('fastwp_conrad_after_post_content');
    	$i++;

    	}

    	} else {
    		get_template_part('extend-helpers/content', 'none');
    	}

        //wp_reset_query();

	}
endif;

if ( ! function_exists( 'post_link_attributes' ) ) :
    add_filter('next_post_link', 'post_link_attributes');
    add_filter('previous_post_link', 'post_link_attributes');
    function post_link_attributes($output) {
        return str_replace('<a href=', '<a class="animsition-link" href=', $output);
    }
endif;

if ( ! function_exists( 'fastwp_conrad_get_category_list' ) ) :
function fastwp_conard_get_category_list($id = null, $separator = ' / '){
	$id = ($id != null)? $id : get_the_ID();
	$tl = wp_get_object_terms($id, 'portfolio-category');
	$cats 		= array();
	foreach($tl as $term){
		$cats[] = $term->name;
	}
	return implode($separator, $cats);
}

endif;

if ( ! function_exists( 'fastwp_conrad_video_post' ) ) :
function fastwp_conrad_video_post( $url, $html = '' ) {
    if( !empty( $html ) ) {
        return $html;
    }
	if( substr_count( $url, 'vimeo.com' ) == 1 ){
        $videoURL = str_replace( 'vimeo.com/','player.vimeo.com/video/', $url );
	} else if( substr_count($url, 'youtu.be') == 1 ||substr_count($url, 'youtube.com') == 1){
        $videoURL = str_replace( '/watch?v=','/embed/', $url );
	} else $videoURL = '';

    if( !empty( $videoURL ) ) {
        echo '<iframe src="'. esc_html( $videoURL ) .'" webkitallowfullscreen="" mozallowfullscreen="" allowfullscreen="" frameborder="0" height="463" width="825"></iframe>';
    }
	return;
}
endif;

if ( ! function_exists( 'fastwp_search_form' ) ) :
function fastwp_search_form( $form ) {
    $form = '
		<form role="search" method="get" id="searchform" class="form-inline form"  action="' . esc_url( home_url( '/' ) ) . '" >
		   <div class="input-group">
			    <input type="text" name="s" value="' . get_search_query() . '" class="form-control" placeholder="'.esc_html__( 'SEARCH...', 'conrad' ).'"  />
			    <span class="input-group-addon">
			    	<button class="btn" type="submit" title="' . esc_html__( 'Start Search', 'conrad' ) . '">' . esc_html__( 'Search', 'conrad' ) . '</span></button>
			    </span>
		    </div>
	    </form>
   ';
    return $form;
}
add_filter( 'get_search_form', 'fastwp_search_form' );
endif;

if( !function_exists( 'fastwp_conrad_comment_form' ) ) :

	function fastwp_conrad_comment_form() {

		global $post;
		if( !isset( $post->ID ) ) return;

		$commenter = wp_get_current_commenter();
		$req = get_option( 'require_name_email' );
		$user_identity = esc_attr( $commenter['comment_author'] );
		$aria_req = ( $req ? " aria-required='true'" : '' );
		$required_text = '';
		$args = array(
		    'id_form'           => 'contact_form',
		    'id_submit'         => 'submit',
		    'class_submit'     =>  'form-submit button rounded border-grey-light border-hover-charcoal color-grey-light color-hover-charcoal no-margin-bottom',
		    'title_reply'       => esc_html__( 'Leave a comment', 'conrad' ),
		    'title_reply_to'    => esc_html__( 'Leave a Reply to %s', 'conrad' ),
		    'cancel_reply_link' => esc_html__( 'Cancel Reply', 'conrad' ),
		    'label_submit'      => esc_html__( 'Post Comment', 'conrad' ),

		    'comment_field' =>  '<div class="row">
    		    <div class="column width-12">
        		  <div class="field-wrapper">
                    <textarea id="comments" name="comment" cols="45" rows="8" class="comment-field form-message form-element" aria-required="true" placeholder="'.esc_html_x( 'Comment', 'noun', 'conrad' ).'"></textarea><span class="border"></span>
                  </div>
                </div>
            </div>',

		    'must_log_in' => '<p class="large-12 columns must-log-in">' .
		    sprintf(
		    __( 'You must be <a href="%s">logged in</a> to post a comment.', 'conrad' ),
		      wp_login_url( apply_filters( 'the_permalink', get_permalink() ) )
		    ) . '</p>',

		    'logged_in_as' => '<p class="large-12 columns logged-in-as">' .
		    sprintf(
		    __( 'Logged in as <a href="%1$s">%2$s</a>. <a href="%3$s" title="Log out of this account">Log out?</a>', 'conrad' ),
		      admin_url( 'profile.php' ),
		      $user_identity,
		      wp_logout_url( apply_filters( 'the_permalink', get_permalink( ) ) )
		    ) . '</p>',


		    'comment_notes_before' => '<p> ' .
    		    esc_html__( 'Your email address will not be published.', 'conrad' ) . ( $req ? ' ' . $required_text : '' ) .
		    '</p>',

		    'fields' => apply_filters( 'comment_form_default_fields', array(

            'author' =>
                '<div class="row">

		        <div class="column width-4">
    		        <div class="field-wrapper">
        		        <input id="name" class="name-field form-name form-element" name="author" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" size="30"' . $aria_req . '  placeholder="'. esc_html__( 'Name', 'conrad' ).'" /><span class="border"></span>
                    </div>
                </div>',

		    'email' =>
		        '<div class="column width-4">
    		        <div class="field-wrapper">
        	            <input id="email" class="email-field form-email form-element" name="email" type="text" value="' . esc_attr(  $commenter['comment_author_email'] ) . '" size="30"' . $aria_req . ' placeholder="' . esc_html__( 'Email', 'conrad' ) . '" /><span class="border"></span>
                    </div>
                </div>',

		    'url' =>
		        '<div class="column width-4">
    		        <div class="field-wrapper">
		                <input id="website" name="url" class="website-field form-website form-element"  type="text" value="' . esc_attr( $commenter['comment_author_url'] ) .'" size="30" placeholder="' .  esc_html__( 'Website', 'conrad' ) . '" /><span class="border"></span>
                    </div>
                </div>

                </div>'

            )
		  )
		);

        return comment_form( $args, $post->ID );

	}

endif;

if( !function_exists( 'fastwp_pre_comment_text' ) ) :

function fastwp_pre_comment_text() {
	//echo '<div>';
}
    add_action( 'comment_form_top', 'fastwp_pre_comment_text' );

endif;

if( !function_exists( 'fastwp_after_comment_text' ) ) :

function fastwp_after_comment_text() {
	//echo '</div>';
}
    add_action( 'comment_form', 'fastwp_after_comment_text' );

endif;

if( !function_exists( 'fastwp_conrad_comment_form_submit_button' ) ) :

function fastwp_conrad_comment_form_submit_button( $button ) {
	$button = '<input name="submit" type="submit" class="submit btn btn-default btn-black"  id="[args:id_submit]" value="[args:label_submit]" />' . get_comment_id_fields();
	return $button;
}
    apply_filters('comment_conrad_form_submit_button', 'fastwp_conrad_comment_form_submit_button');

endif;

if( !function_exists( 'fastwp_conrad_move_comtextarea' ) ) :

    function fastwp_conrad_move_comtextarea( $fields ) {
        $comment_field = $fields['comment'];
        unset( $fields['comment'] );
        $fields['comment'] = $comment_field;
        return $fields;
    }

    add_filter( 'comment_form_fields', 'fastwp_conrad_move_comtextarea' );

endif;

if ( ! function_exists( 'fastwp_conrad_comment' ) ) :

function fastwp_conrad_comment( $comment, $args, $depth ) {

global $post;

if( !isset( $post->ID ) ) return;

$GLOBALS['comment'] = $comment;

switch ( $comment->comment_type ) :

case 'pingback' :
case 'trackback' :
// Display trackbacks differently than normal comments.
?>

<p><?php esc_html_e( 'Pingback:', 'conrad' ); ?> <?php comment_author_link(); ?> <?php edit_comment_link( esc_html__( 'Edit', 'conrad' ), ' / <i class="edit-link">', '</i>' ); ?></p>

<?php
break;
default :
?>


<li id="li-comment-<?php comment_ID(); ?>">
    <article class="comment">
    <div class="user-avatar">
    	<?php echo get_avatar( $comment, 90 ); ?>
    </div>
    <div class="comment-content">
    	<h5 class="name"><?php echo get_comment_author();?></h5>
    	<div class="comment-meta">
    		<span class="comment-time"><?php printf( esc_html__( '%s by %s', 'conrad' ), get_comment_date('F j, Y'), get_comment_author() ); ?></span>
            <?php edit_comment_link( esc_html__( 'Edit', 'conrad' ), ' / <i class="edit-link">', '</i>' ); ?>
            <span class="animated-link comment-reply-link scroll-link pull-right">
                <?php echo comment_reply_link( array_merge( $args, array( 'reply_text' => '<span class="text-line bkg-charcoal"></span>' . esc_html__( 'Reply', 'conrad' ), 'before' => '', 'after' => '', 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
            </span>
        </div>
    	<p>
        <?php if ( '0' == $comment->comment_approved ){
            esc_html_e( 'Your comment is awaiting moderation.', 'conrad' );
        } else {
            comment_text();
        } ?>
        </p>
    </div>
    </article>
</li>

<?php

break;

endswitch; // end comment_type check

}

endif;

/* Post pagination */

if( !function_exists( 'fastwp_conrad_post_navigation' ) ) :

function fastwp_conrad_post_navigation() {

$prev_post = get_previous_post();
$next_post = get_next_post();

if( !empty( $prev_post ) || !empty( $next_post ) )

?>

<div class="section-block pagination-5">
    <div class="row">
        <div class="column width-12">
            <ul>

                <?php

                if( !empty( $prev_post ) ) {

                $img = '';
                $meta = fastwp_conrad_meta::get( $prev_post->ID, 'nav_img' );

                if( !empty( $meta[0]['url'] ) ) {
                    $img = $meta[0]['url'];
                } else {
                    $thumb = wp_get_attachment_image_src( get_post_thumbnail_id( $prev_post->ID ), 'full' );
                    if( !empty( $thumb[0] ) ) {
                        $img = $thumb[0];
                    }
                }

                ?>
                <li>
                    <a class="pagination-previous animated-link left" href="<?php echo get_permalink( $prev_post->ID ); ?>">
                        <span class="text-line bkg-charcoal"></span>
                        <span><?php echo $prev_post->post_title; ?></span>
                    </a>
                    <div class="pagination-image post-1-previous<?php echo !empty( $img ) ? '" style="background-image: url(\'' . $img . '\') !important;"' : ' bkg-charcoal"'; ?>></div>
                </li>
                <?php } else {
                    echo '<li></li>';
                }

                if( !empty( $next_post ) ) {

                $img = '';
                $meta = fastwp_conrad_meta::get( $next_post->ID, 'nav_img' );

                if( !empty( $meta[0]['url'] ) ) {
                    $img = $meta[0]['url'];
                } else {
                    $thumb = wp_get_attachment_image_src( get_post_thumbnail_id( $next_post->ID ), 'full' );
                    if( !empty( $thumb[0] ) ) {
                        $img = $thumb[0];
                    }
                }

                ?>
                <li>
                    <a class="pagination-next animated-link right" href="<?php echo get_permalink( $next_post->ID ); ?>">
                        <span class="text-line bkg-charcoal"></span>
                        <span><?php echo $next_post->post_title; ?></span>
                    </a>
                    <div class="pagination-image post-1-next'<?php echo !empty( $img ) ? '" style="background-image: url(\'' . $img . '\') !important;"' : ' bkg-charcoal"'; ?>')></div>
                </li>
                <?php } else {
                    echo '<li></li>';
                } ?>

            </ul>
        </div>
    </div>
</div>

<?php

}

endif;

/* Blog Pagination */

if ( ! function_exists( 'fastwp_conrad_blog_pagination' ) ) :

function fastwp_conrad_blog_pagination( $args = array() ) {
    global $wp_query, $fastwp_conrad_last_post_id, $fastwp_conrad_first_post_id;

	if( $wp_query->max_num_pages < 2 ) return;

    $nextpostlink =  explode( '"', get_next_posts_link() );
	$nextpostlink =  isset( $nextpostlink[1] ) ? $nextpostlink[1] : false;
	$previouspostlink = explode( '"', get_previous_posts_link() );
 	$previouspostlink = isset( $previouspostlink[1] ) ? $previouspostlink[1] : false;

    echo '<div class="section-block pagination-5">
        	<div class="row">
        		<div class="column width-12">
        			<ul>';

                        echo '<li>';
                        if( $previouspostlink ) {

                        global $post;
                        $post = $fastwp_conrad_first_post_id;
                        $prev_post = get_next_post();

                        $img = '';
                        $meta = fastwp_conrad_meta::get( $prev_post->ID, 'nav_img' );

                        if( !empty( $meta[0]['url'] ) ) {
                            $img = $meta[0]['url'];
                        } else {
                            $thumb = wp_get_attachment_image_src( get_post_thumbnail_id( $prev_post->ID ), 'full' );
                            if( !empty( $thumb[0] ) ) {
                                $img = $thumb[0];
                            }
                        }

             				echo '<a class="pagination-next animated-link left" href="' . $previouspostlink . '"> <span class="text-line bkg-charcoal"></span><span>' . esc_html__( 'Previous Posts', 'conrad' ) . '</span></a>
            					<div class="pagination-image' . ( !empty( $img ) ? '" style="background-image: url(\'' . $img . '\') !important;"' : ' bkg-charcoal"' ) . '></div>';
                        } else {

                        }
                        echo '</li>';

                        echo '<li>';
                        if( $nextpostlink ) {

                        global $post;
                        $post = $fastwp_conrad_last_post_id;
                        $next_post = get_previous_post();

                        $img = '';
                        $meta = fastwp_conrad_meta::get( $next_post->ID, 'nav_img' );

                        if( !empty( $meta[0]['url'] ) ) {
                            $img = $meta[0]['url'];
                        } else {
                            $thumb = wp_get_attachment_image_src( get_post_thumbnail_id( $next_post->ID ), 'full' );
                            if( !empty( $thumb[0] ) ) {
                                $img = $thumb[0];
                            }
                        }

             				echo '<a class="pagination-next animated-link right" href="' . $nextpostlink . '"> <span class="text-line bkg-charcoal"></span><span>' . esc_html__( 'Next Posts', 'conrad' ) . '</span></a>
            					<div class="pagination-image' . ( !empty( $img ) ? '" style="background-image: url(\'' . $img . '\') !important;"' : ' bkg-charcoal"' ) . '></div>';
                        } else {
            				echo '<a class="pagination-next animated-link right disabled" href="#"> <span class="text-line bkg-charcoal"></span><span>' . esc_html__( 'No More Posts', 'conrad' ) . '</span></a>
            					<div class="pagination-image"></div>';
                        }
                        echo '</li>';

        			echo '</ul>
        		</div>
        	</div>
	        </div>';

}

endif;

if(!function_exists('fastwp_conrad_comment_close_tag')):
	function fastwp_conrad_comment_close_tag(){
	// </div></div>
}
endif;

if(!function_exists('fastwp_conrad_widgets_init')):
function fastwp_conrad_widgets_init() {
	register_sidebar( array(
		'name'          => esc_html__( 'Main Widget Area', 'conrad' ),
		'id'            => 'sidebar-2',
		'description'   => esc_html__( 'Appears on posts and pages in the sidebar.', 'conrad' ),
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'fastwp_conrad_widgets_init' );
endif;
