<?php
add_filter('fastwp_conrad_page_class', array('fastwp_conrad_extend_filters', 'page_class'),10,2);
add_filter('fastwp_conrad_page_section_class', array('fastwp_conrad_extend_filters', 'page_section_class'));
add_filter('fastwp_conrad_onepage_container_class', array('fastwp_conrad_extend_filters', 'onepage_container_class'));

class fastwp_conrad_extend_filters {

	static function page_class($objClass, $page_id = 0){
		global $fastwp_conrad_meta, $fastwp_conrad_custom_shortcode_css;
		$private_meta = $fastwp_conrad_meta;
		
		if(is_page()){
			$page_id = ($page_id != 0)? $page_id : get_the_ID();
			if(!isset($private_meta['s_padding_tpl'])){
				$private_meta  	= fastwp_conrad_meta::get( $page_id );
			}
			$customClass 	= (isset($private_meta['s_padding_tpl']))? $private_meta['s_padding_tpl'] : 'none';
			$objClass 	   .= ($customClass != 'none')? ' fwp-'.esc_attr($customClass) : '';

			if(isset($private_meta['s_padding_override']['top'])){
				$customClassID = 'fwp_setting_class'.rand(1000,9999);
				$css = '';
				foreach(array('top','rigt','bottom','left') as $loc){
					if(!isset($private_meta['s_padding_override'][$loc]) || empty($private_meta['s_padding_override'][$loc])) {
						continue;
					}
					$css .= sprintf('padding-%s: %s;', $loc, $private_meta['s_padding_override'][$loc]);
				}
				$fastwp_conrad_custom_shortcode_css .= sprintf(' .%s { %s }', $customClassID, $css); 
				$objClass .= ' '.$customClassID;
			}

			$meta = fastwp_conrad_meta::get ( $page_id );
        
			$hasFullSections 	= isset( $meta['fwp_has_full_height'] ) ? $meta['fwp_has_full_height'] : '' ;
			$hasBulletNav 		= isset( $meta['fwp_has_bullet_nav'] ) ? $meta['fwp_has_bullet_nav'] : '' ;
			$sectionChromatic 	= isset( $meta['fwp_section_chromatic'] ) ? $meta['fwp_section_chromatic'] : '' ;
			$extra_class 	    = isset( $meta['fwp_fs_extra_class'] ) ? $meta['fwp_fs_extra_class'] : '' ;

			if($hasBulletNav){
				$objClass .= ' section-block';
			}

			if($hasFullSections){
				$objClass .= ' fullscreen-section content-below-on-mobile no-overlay';
			}

			if($sectionChromatic === '0'){
				$objClass .= ' nav-dark';
			}
            if( !empty( $extra_class ) ) {
                $objClass .=  ' ' . esc_attr( $extra_class );
            }
		}
		return $objClass;
	}

	static function onepage_container_class($class){

		$hasBulletNav = fastwp_conrad_meta::get ( get_the_ID (), 'fwp_has_bullet_nav' );

		if($hasBulletNav){
			$class .= ' fullscreen-sections-wrapper';
		}
		return $class;
	}
	static function page_section_class($class){
	//	fwp_section_chromatic
		return $class;
	}

}
