<?php
if(!class_exists('fastwp_conrad_theme_shortcodes_complex')){
	class fastwp_conrad_theme_shortcodes_complex extends fastwp_conrad_theme_shortcodes_basic {

		static function ConradPortfolio($atts, $content){

	        extract(shortcode_atts(array(
	        	'type'	            => 'grid',
	        	'columns'           => "3",
	        	'navigation'        => "left",
	        	'filters_title'     => "SORT PROJECTS:",
	        	'name_on_hover'     => "true",
	        	'include'           => '',
	        	'exclude'           => '',
	        	'include_cats'      => '',
	        	'exclude_cats'      => '',
	        	'cat_orderby' 	    => 'count',
			  	'hide_empty'	    => 1,
	            'show_filters'      => true,
	            'filters_pos'       => 1,
	            'default_category'  => '*',
	            'container_classes' => 'no-padding-top ',
                'filters_padding_top'=> true,
                'filters_padding_bottom'=> true,
                'portfolio_type'    => 1,
	            'extra_class'       => ''
	        ), $atts));

			$args = array(
				'numberposts' 		=> '-1',
				'posts_per_page' 	=> '-1',
				'post_status' 		=> 'publish',
				'post_type'			=> 'fwp_portfolio',
				'suppress_filters'	=> '0',
				);

			if( $include != '' ) {
				$args['include'] = $include;
	            $args['orderby'] = 'post__in';
			}

			if( $exclude != '' ) {
				$args['exclude'] = $exclude;
			}

	        if( !empty( $exclude_cats ) && empty( $include_cats ) ) {
	        $args['tax_query'] = array(
	          array(
	            'taxonomy' => 'portfolio-category',
	            'field'    => 'ids',
	            'terms'    => array_filter( explode( ',', $exclude_cats ) ),
	            'operator' => 'NOT IN'
	          )
	        );
	        }

	        if( !empty( $include_cats )  ) {
	        $args['tax_query'] = array(
	          array(
	            'taxonomy' => 'portfolio-category',
	            'field'    => 'ids',
	            'terms'    => array_filter( explode( ',', $include_cats ) )
	          )
	        );
	        }

	        $items = get_posts( $args );

			if( !is_array( $items ) || ( is_array( $items ) && count( $items ) == 0 ) ) {
				return fastwp_conrad_ui::alert( 'warning', esc_html__('Used [fwp_conrad_portfolio] shortcode but no items are mathching. Please add at least one item before using this shortcode.', 'conrad' ) );
			}


        $cats = $isotope = $class = array();
		$excluded_cats	= !empty( $exclude_cats ) ? explode( ',', trim( $exclude_cats ) ) : array();
		$included_cats	= !empty( $include_cats ) ? explode( ',', trim( $include_cats ) ) : array();
        $top_filters    = (boolean) $show_filters && (int) $filters_pos === 1 ? true : false;
        $left_filters   = (boolean) $show_filters && (int) $filters_pos === 2 ? true : false;
        $portfolio_type = in_array( $portfolio_type, array( '1', '5' ) ) ? $portfolio_type : 1;

        if( (boolean) $show_filters ) {

        $all_label      = !empty( $all_label ) ? esc_html( $all_label ) : esc_html__( 'All', 'conrad' );
        $cats['*']      = $all_label;
        $categories     = get_terms( 'portfolio-category', array( 'orderby' => $cat_orderby, 'hide_empty' => $hide_empty ) );

		if( count( $categories ) > 0 ) {
			foreach ( $categories as $category ) {
				if( isset( $category->term_id ) && in_array( $category->term_id, $excluded_cats ) && empty( $include_cats ) ) continue;
                if( !empty( $include_cats ) && !in_array( $category->term_id, $included_cats ) ) continue;
                $cats['.' . $category->slug] = $category->name;
			}
		}

        }

        $default_category           = in_array( $default_category, array_keys( $cats ) ) ? $default_category : '*';
		$class[] = $portfolio_id    = 'fwp-portfolio-' . rand( 1000, 9999 );

		if( !empty( $container_classes ) ) {
			$container_classes = explode(',', $container_classes );
		}

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $portfolio_overlay_type = $portfolio_overlay_easing = $portfolio_easing_speed = $portfolio_overlay_color = $portfolio_overlay_opacity = '';
			
			$portfolioModel = '<div class="section-block portfolio-%s%s%s">
					<div class="row">
						<div class="column width-12">
							<div class="row content-grid-%s masonry-grid fade-in-progressively">%s</div></div></div></div>';

			$projectModelDefault = '<div class="grid-item %s">
        	<div class="thumbnail %s" data-hover-easing="%s" data-hover-speed="%s" data-hover-bkg-color="%s" data-hover-bkg-opacity="%s">
        		<a class="overlay-link" href="%s">
        			<img class="portfolio__image-src" src="%s" alt=""/>
        			<span class="overlay-info"><span><span>%s</span></span></span>
        		</a>
        	</div>
        	%s
            </div>';
            $projectModelCaptioned = '<div class="grid-item %s">
        	<div class="thumbnail %s" data-hover-easing="%s" data-hover-speed="%s" data-hover-bkg-color="%s" data-hover-bkg-opacity="%s">
        		<img class="portfolio__image-src" src="%s" alt=""/>
        		%s
        	</div>
        	%s
            </div>';
            
			$projectTitleModel = '<span class="project-title">%s</span>';
			$projectTitleHolderModel = '<span class="overlay-info"><span><span>%s</span></span></span>';
        	$projectCaptionModel = '<div class="caption-over-outer"><div class="caption-over-inner"><div class="row"><div class="column width-8 offset-2"><p class="lead color-white">%s</p><a href="%s" class="animated-link fade-location color-white"><span class="text-line bkg-white"><!-- --></span>View Full Portfolio</a></div></div></div></div>';
			$projectDescriptionModel = '<div class="item-description"><h5 class="project-title">%s</h5></div>';
			$htmlItems = array();
            $i = 1;
			foreach($items as $item){
				$meta = fastwp_conrad_meta::get($item->ID);
				$item_cats          = array();
                $item_cats[] 				= $i == 1 ? 'grid-sizer' : '';
				$portfolio_overlay_type 	= isset($meta['portfolio_overlay_type'] ) ? esc_html( $meta['portfolio_overlay_type'] ) : '';
				$item_cats[] 				= isset($meta['portfolio_wide_2x2']) && $meta['portfolio_wide_2x2'] == 'yes' ? 'fwp_large' : '';
				$item_cats[]  				= isset($meta['portfolio_tall_1x2']) && $meta['portfolio_tall_1x2'] == 'yes' ? 'fwp_tall' : '';
				$item_cats[]  				= isset($meta['portfolio_wide_2x1']) && $meta['portfolio_wide_2x1'] == 'yes' ? 'fwp_wide' : '';
				$portfolio_overlay_easing	= isset($meta['portfolio_overlay_easing'] ) ? esc_html( $meta['portfolio_overlay_easing'] ) : 'easeInOut';
				$portfolio_hover_speed	 	= isset($meta['portfolio_hover_speed'] ) ? esc_html( $meta['portfolio_hover_speed'] ) : '700';
				$portfolio_overlay_color 	= isset($meta['portfolio_overlay_color'] ) ? esc_html( substr($meta['portfolio_overlay_color'], 1 ) ) : '';
				$portfolio_overlay_opacity 	= isset($meta['portfolio_overlay_opacity'] ) ? esc_html( $meta['portfolio_overlay_opacity'] ) : '';
				$portfolio_caption_html 	= isset($meta['portfolio_caption_html'] ) ? esc_html( $meta['portfolio_caption_html'] ) : '';
				$is_captioned = false;

                $link = get_permalink( $item->ID );

                $custom_link = get_post_meta( $item->ID, 'portfolio_url', true );
                if( !empty( $custom_link ) ) {
                    $link = esc_url( $custom_link );
                }

				if($name_on_hover == "true"){
					$description = '';
					if($portfolio_caption_html != ""){
						$is_captioned = true;
						$title = sprintf($projectCaptionModel, $portfolio_caption_html, $link);
					} else {
						$title = sprintf($projectTitleModel, $item->post_title);
					}
				} else {
					$description = sprintf($projectDescriptionModel, $item->post_title);
					$title = esc_html__( 'View', 'conrad' );
				}
				$permalink = $link;
				$image = wp_get_attachment_image_src( get_post_thumbnail_id($item->ID), 'full' );
				$image = (isset($image[0]) && !empty($image[0]))? $image[0] : 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7';
				$project_css_class = '';


				$item_terms         = wp_get_object_terms( $item->ID, 'portfolio-category' );
				$icats = array();
				foreach( $item_terms as $item_cat ) {
		    		if( in_array( $item_cat->term_id, $excluded_cats ) ) continue;
		    		$icats[$item_cat->slug] = $item_cat->name;
				}

				$item_cats[] = implode( ' ', array_keys( $icats ) );

				$htmlItems[] = ($is_captioned)? sprintf($projectModelCaptioned, implode( ' ', array_filter( $item_cats ) ), $portfolio_overlay_type, $portfolio_overlay_easing, $portfolio_hover_speed, $portfolio_overlay_color, $portfolio_overlay_opacity, $image, $title, $description) : sprintf($projectModelDefault, implode( ' ', array_filter( $item_cats ) ), $portfolio_overlay_type, $portfolio_overlay_easing, $portfolio_hover_speed, $portfolio_overlay_color, $portfolio_overlay_opacity, $permalink, $image, $title, $description);
                $i++;
            }

	        // do_action('fastwp_conrad_enqueue_script', '');

	        $category_selector_html = '<div class="section-block portfolio-filter-menu%s %s">
					<div class="row">
						<div class="column width-12">
							<ul>
								%s
								%s
							</ul>
						</div>
					</div>
				</div>';

			$items_markup = '';

			foreach( $cats as $cat_filter => $cat_name ) {
                $items_markup .= sprintf( '<li><a data-filter="%s"%s>%s</a></li>', $cat_filter, ( $cat_filter == $default_category ? ' class="active"' : '' ), $cat_name );
            }

			$category_selector = sprintf($category_selector_html, ( ! (boolean) $filters_padding_top ? ' no-padding-top' : '' ) . ( ! (boolean) $filters_padding_bottom ? ' no-padding-bottom' : '' ), esc_attr( $navigation ), ($filters_title != '' && $show_filters == true )? sprintf('<li>%s</li>', $filters_title) : '', $items_markup);

	        return $category_selector . sprintf( $portfolioModel, $portfolio_type, ( is_array( $container_classes ) ? ' ' . esc_html( implode( ' ', $container_classes ) ) : '' ), ( !empty( $extra_class ) ? ' ' . esc_attr( $extra_class ) : '' ), esc_attr( $columns ), implode('', $htmlItems) );

	    }

		static function ConradLatestPosts($atts, $content){

	        extract(shortcode_atts(array(
	        	'columns'			=> "3",
	        	'include'			=> '',
	        	'exclude'			=> '',
	        	'include_cats'		=> '',
	        	'exclude_cats'		=> '',
	        	'cat_orderby' 	    => 'count',
			  	'hide_empty'	    => 1,
	            'container_classes' => 'padding-top',
	            'extra_class' => ''
	        ), $atts));

			$args = array(
        				'numberposts' 		=> '-1',
        				'posts_per_page' 	=> '-1',
        				'post_status' 		=> 'publish',
        				'post_type'			=> 'post',
        				'suppress_filters'	=> '0',
        				);

			if( $include != '' ) {
			    $args['post__in'] = explode( ',', $include );
                $args['orderby'] = 'post__in';
			}

			if( $exclude != '' ) {
				$args['post__not_in'] = explode( ',', $exclude );
			}

	        if( !empty( $exclude_cats ) && empty( $include_cats ) ) {
    	        $args['category__not_in'] = explode( ',', $exclude_cats );
	        }

	        if( !empty( $include_cats )  ) {
    	        $args['category__in'] = explode( ',', $include_cats );
	        }

            $the_query = new WP_Query( $args );

			if( !$the_query->have_posts() ) {
				return fastwp_conrad_ui::alert( 'warning', esc_html__('Used [fwp_conrad_latest_posts] shortcode but no items are mathching. Please add at least one item before using this shortcode.', 'conrad' ) );
			}


            $cats = $isotope = $class = array();
    		$excluded_cats	= !empty( $exclude_cats ) ? explode( ',', trim( $exclude_cats ) ) : array();
    		$included_cats	= !empty( $include_cats ) ? explode( ',', trim( $include_cats ) ) : array();
    		$class[] = $portfolio_id    = 'fwp-portfolio-' . rand( 1000, 9999 );

    		if( !empty( $container_classes ) ) {
    			$container_classes = str_replace( ',', ' ', $container_classes );
    		}

            if( !empty( $extra_class ) ) {
                $class[] = esc_attr( $extra_class );
            }


    		$LatestPostsWrapper = '<div class="content-inner blog-masonry %s">
    										<div class="row">
    											<div class="column width-12">
    												<div class="row content-grid-%s masonry-grid fade-in-progressively clearfix">%s</div>
    											</div>
    										</div>
    									</div>';

            $FinalPostItems = $author_link = $post_author_url = '';

            $i = 1;

            while ( $the_query->have_posts() ) {
             $the_query->the_post();

                $FinalPostItems .='<div class="grid-item'.($i==1 ? ' grid-sizer' : '').'">';
            	$FinalPostItems .= fastwp_conrad_utils::get_template_part( 'extend-helpers/blog-columns' );
            	$FinalPostItems .='</div>';

            $i++;

            }


            wp_reset_postdata();

            // do_action('fastwp_conrad_enqueue_script', '');

	        return sprintf( $LatestPostsWrapper, 'bacgroundcolorclass', esc_attr( $columns ), $FinalPostItems);

	    }
	}
}
