<?php

class fastwp_conrad_theme_shortcodes extends fastwp_conrad_theme_shortcodes_complex {

static function ConradListContainer($atts, $content){

		extract(shortcode_atts(array(
			'extra_class'	=> ''
		), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $markup = '<ul class="list-group%s">%s</ul>';

		return sprintf( $markup, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), do_shortcode( $content ) );

    }

static function ConradListItem($atts, $content){

		extract(shortcode_atts(array(
            'title'         => '',
            'list'          => '',
            'visibility'    => true,
            'extra_class'   => ''
		), $atts));

        if( ! (boolean) $visibility ) return '';

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $title_markup = $list_markup = '';
        if( !empty( $title ) ) {
            $title_markup .= sprintf( '<strong>%s</strong>', esc_html( $title ) );
        }

        $items = explode( "<br />", $list );
        if( count( $items ) > 0 ) {
            foreach( $items as $item ) {
                $list_markup .= esc_html( $item ) . '<br />';
            }
        }

        $markup = '<li%s>
					%s
					<p>%s</p>
				</li>';

		return sprintf( $markup, ( !empty( $class ) ? ' class="' . implode( ' ', $class ) . '"' : '' ), $title_markup, $list_markup );

    }

static function ConradTabsContainer($atts, $content){

        global $fastwp_conrad_shortcode_tabs_type;
		extract(shortcode_atts(array(
            'type'          => 'h-tabs',
            'align'         => '',
			'extra_class'	=> ''
		), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( !empty( $align ) && in_array( $align, array( 'center', 'right' ) ) ) {
            $class[] = $align;
        }



        $container = '';

        if( $type == 'v-tabs' ) {
            $container .= '<div class="tabs vertical rounded%s">
    		                <ul class="tab-nav">%s</ul>
                            <div class="tab-panes">
									<div class="tab-animate">
										<div class="tab-content">
											<p>ss</p>
										</div>
									</div>
								</div>';
            $fastwp_conrad_shortcode_tabs_type = 'v-tabs';
        } else {
            $container .= '<div class="tabs horizontal rounded%s">
    		                <ul class="tab-nav">%s</ul>
                            <div class="tab-panes">
									<div class="tab-animate">
										<div class="tab-content">
											<p>ss</p>
										</div>
									</div>
								</div>';
            $fastwp_conrad_shortcode_tabs_type = 'h-tabs';
        }

        $container .= ' </div>';

		return sprintf( $container, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), do_shortcode( $content ) );

    }

static function ConradTabsAccordionContainer($atts, $content){

        global $fastwp_conrad_shortcode_tabs_type;
		extract(shortcode_atts(array(
            'type'          => 'accordion',
			'extra_class'	=> ''
		), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $container = '';

        if( $type == 'multi_open_tabs' ) {
            $container .= '<div class="accordion rounded%s" data-toggle-icon="" data-toggle-multiple="">
                            <ul>%s</ul>';
            $fastwp_conrad_shortcode_tabs_type = 'multi_open_tabs';
        } else {
            $container .= '<div class="accordion rounded%s">
                            <ul>%s</ul>';
            $fastwp_conrad_shortcode_tabs_type = 'accordion';
        }

        $container .= ' </div>';

		return sprintf( $container, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), do_shortcode( $content ) );

    }

static function ConradTabsItem($atts, $content){

		global $fastwp_conrad_custom_shortcode_css, $fastwp_conrad_shortcode_tabs_type;
		extract(shortcode_atts(array(
            'title'         => '',
            'active'        => false,
            'visibility'    => true,
            'color'         => '#999',
            'hov_color'     => '#666666',
            'active_color'  => '#232323',
            'extra_class'   => ''
		), $atts));

        if( ! (boolean) $visibility ) return '';

        $class = array();

        $class[] = $tab_id = 'tab-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( (boolean) $active ) {
            $class[] = 'active';
        }

        $item = '';

        if( $color != '#999' ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s > a { color: %s!important;}', $tab_id, esc_html( $color ) );
        }
        if( $hov_color != '#666666' ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s > a:hover { color: %s!important;}', $tab_id, esc_html( $hov_color ) );
        }
        if( $active_color != '#232323' ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s.active > a { color: %s!important; border-bottom-color: %s!important;}', $tab_id, esc_html( $active_color ), esc_html( $active_color ) );
        }

        if( $fastwp_conrad_shortcode_tabs_type == 'h-tabs' || $fastwp_conrad_shortcode_tabs_type == 'v-tabs' ) {
            $item .= '<li%s>
                        <a href="#tabs-1-panel-' . ( $pid = uniqid() ) . '">%s</a>
                        <div class="tab-content">%s</div>
                    </li>';
        } else if( $fastwp_conrad_shortcode_tabs_type == 'multi_open_tabs' ) {
            $item .= '<li%s>
						<a href="#accordion-2-panel-' . ( $pid = uniqid() ) . '"><span class="icon-' . ( (boolean) $active ? 'minus' : 'plus' ) . '"></span>%s</a>
						<div id="accordion-2-panel-' . $pid . '">
							<div class="accordion-content">
								<p>%s</p>
							</div>
						</div>
					</li>';
        } else {
            $item .= '<li%s>
                        <a href="#accordion-1-panel-' . ( $pid = uniqid() ) . '">%s</a>
						<div id="accordion-1-panel-' . $pid . '">
							<div class="accordion-content">
								<p>%s</p>
							</div>
						</div>
                    </li>';
        }

		return sprintf( $item, ( !empty( $class ) ? ' class="' . implode( ' ', $class ) . '"' : '' ), esc_html( $title ), wp_kses( $content, fastwp_conrad_utils::allowed_tags() ) );

    }

static function ConradGalleryContainer($atts, $content){

		extract(shortcode_atts(array(
            'columns'       => 3,
            'masonry'       => true,
            'margins'       => true,
            'padding_top'   => false,
            'padding_bottom'=> false,
			'extra_class'	=> ''
		), $atts));

        global $global_gallery_item;
        $global_gallery_item = 0;

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( !(boolean) $margins ) {
            $class[] = 'no-margins';
        }

        if( !(boolean) $padding_top ) {
            $class[] = 'no-padding-top';
        }

        if( !(boolean) $padding_bottom ) {
            $class[] = 'no-padding-bottom';
        }

        if( (boolean) $masonry ) {
            $class[] = 'portfolio-5';
        } else {
            $class[] = 'portfolio-3';
        }


		return sprintf( '<div class="section-block%s">
		<div class="row">
    		<div class="column width-12">
        		<div class="row content-grid-%s%s">
                %s
                </div>
            </div>
        </div>
        </div>', ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), ( in_array( (int) $columns, array( 1, 2, 3, 4, 5 ) ) ? (int) $columns : 3 ), ( (boolean) $masonry ? ' masonry-grid' : '' ), do_shortcode( $content ) );

    }

static function ConradGalleryItem($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
            'title'         => 'Title',
            'link'          => '',
            'image'         => '',
            'images'        => '',
            'background'    => '#000000',
            'opacity'       => 0.8,
            'hover_speed'   => 700,
            'effect'        => 'easeInOut',
            'animation'     => 'overlay-fade-out',
            'portrait'      => false,
            'large'         => false,
            'wide'          => false,
            'rich'          => false,
            'image_type'    => 'image',
            'caption'       => '',
            'caption_color' => '',
            'visibility'    => true,
            'extra_class'   => ''
		), $atts));

        if( ( ( empty( $image ) || !is_numeric( $image ) ) && $image_type != 'slider' ) || ( $image_type == 'slider' && empty( $images ) ) ) {
            $visibility = false;
        }

        if( ! (boolean) $visibility ) return '';

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        global $global_gallery_item;
        $global_gallery_item++;

        if( $global_gallery_item == 1 ) {
            $class[] = 'grid-sizer';
        }

        if( (boolean) $portrait ) {
            $class[] = 'fwp_tall';
        }

        if( (boolean) $large ) {
            $class[] = 'fwp_large';
        }

        if( (boolean) $wide ) {
            $class[] = 'fwp_wide';
        }

        if( $image_type != 'slider' ) {
            $image = wp_get_attachment_image_src( $image, 'full' );
            $image = '<img src="' . $image[0] . '" alt="" />';
        }

        if( !(boolean) $rich && $image_type != 'slider' ) {

            if( !empty( $caption_color ) ) {
                $class[] = $gi_id = 'gi' . rand( 1000, 9999 );

                $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .caption-below.color-white { color: %s; }', $gi_id, esc_html( $caption_color ) );
            }

            $item_markup = sprintf( '<div class="grid-item%s">
            				<div class="thumbnail">
            				    %s
            				</div>
                            %s
            			</div>', ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), $image, ( !empty( $caption ) ?  '<div class="caption-below color-white">' . esc_html( $caption ) . '</div>' : '' ) );

        } else {

            $item_markup = '<div class="grid-item' . ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ) . '">';

            if( $image_type == 'slider' ) {

            $item_markup .= '<div class="tm-slider-container content-slider">
        	                <ul class="tms-slides">';

            $slides = explode( ',', $images );

            foreach( $slides as $slide ) {

            $slide_img = wp_get_attachment_image_src( $slide, 'full' );

            $item_markup .= sprintf( '<li class="tms-slide" data-image>
        	                    <img data-src="%s" src="%s" alt=""/>
        	                </li>', $slide_img[0], get_template_directory() . '/assets/images/blank.png' );
            }

            $item_markup .= '</ul>
        					</div>';

            } else {

            $url = fastwp_conrad_utils::url_from_vc( $link );

            $item_markup .= sprintf( '<div class="thumbnail %s" data-hover-easing="%s" data-hover-speed="%s" data-hover-bkg-color="%s" data-hover-bkg-opacity="%s">
            					<a class="overlay-link" href="%s" target="%s">
            						%s
            						<span class="overlay-info">
            							<span>
            								<span>
            									%s
            								</span>
            							</span>
            						</span>
            					</a>
            				</div>
                            %s', esc_html( $animation ), esc_html( $effect ), (int) $hover_speed, substr( $background, 1 ), esc_html( $opacity ), $url['url'], $url['target'], $image, esc_html( $title ), ( !empty( $caption ) ? '<div class="caption-below color-white">' . esc_html( $caption ) . '</div>' : '' ) );

            }

            $item_markup .= '</div>';

            $effects    = array('linear', 'swing', 'easeInQuad', 'easeOutQuad', 'easeInOutQuad', 'easeInCubic',
                                'easeOutCubic', 'easeInOutCubic', 'easeInQuart', 'easeOutQuart', 'oeaseInOutQuart',
                                'oeaseInQuint', 'oeaseOutQuint', 'easeInExpo', 'easeOutExpo', 'easeInOutExpo',
                                'easeInSine', 'easeOutSine', 'easeInOutSine', 'easeInOutQuint', 'easeInCirc',
                                'easeOutCirc', 'easeInOutCirc', 'easeInOutQuint', 'easeInElastic', 'easeOutElastic',
                                'easeInOutElastic', 'easeInBack', 'easeOutBack', 'easeInOutBack', 'easeInOutBounce'
                                );

            $animations = array(
                                'overlay-fade-out', 'overlay-fade-in', 'img-scale-in', 'overlay-fade-img-scale-in', 'overlay-fade-img-scale-out',
                                'overlay-slide-in-top', 'overlay-slide-in-left', 'overlay-slide-in-right', 'overlay-slide-in-bottom', 'overlay-img-slide-up',
                                'overlay-img-slide-left', 'overlay-img-slide-right', 'overlay-img-slide-down', 'overlay-scale-in', 'overlay-scale-in img-scale-in'
                                );

            $effect = !empty( $effect ) && in_array( $effect, $effects ) ? $effect : 'easeInOut';
            $animation = !empty( $animation ) && in_array( $animation, $animations ) ? $animation : 'overlay-fade-out';

        }

        return $item_markup;

    }

static function ConradThumbnail($atts, $content){

        global $fastwp_conrad_custom_shortcode_css;
        extract(shortcode_atts(array(
            'title'         => '',
            'link'          => '',
            'image'         => '',
            'background'    => '#000000',
            'opacity'       => 0.8,
            'hover_speed'   => 700,
            'effect'        => '',
            'animation'     => '',
            'rich'          => false,
            'visibility'    => true,
            'extra_class'   => ''
        ), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $item_markup = '<div class="thumbnail %s%s" data-hover-easing="%s" data-hover-speed="%s" data-hover-bkg-color="%s" data-hover-bkg-opacity="%s">
                                                    <a class="overlay-link" href="%s" target="%s">
                                                        %s
                                                        <span class="overlay-info">
                                                            <span>
                                                                <span>
                                                                    %s
                                                                </span>
                                                            </span>
                                                        </span>
                                                    </a>
                                                </div>';

        $effects = array(  'linear', 'swing', 'easeInQuad', 'easeOutQuad', 'easeInOutQuad', 'easeInCubic',
                            'easeOutCubic', 'easeInOutCubic', 'easeInQuart', 'easeOutQuart', 'oeaseInOutQuart',
                            'oeaseInQuint', 'oeaseOutQuint', 'easeInExpo', 'easeOutExpo', 'easeInOutExpo',
                            'easeInSine', 'easeOutSine', 'easeInOutSine', 'easeInOutQuint', 'easeInCirc',
                            'easeOutCirc', 'easeInOutCirc', 'easeInOutQuint', 'easeInElastic', 'easeOutElastic',
                            'easeInOutElastic', 'easeInBack', 'easeOutBack', 'easeInOutBack', 'easeInOutBounce'
                        );

        $animations = array(
                            'overlay-fade-out', 'overlay-fade-in', 'img-scale-in', 'overlay-fade-img-scale-in', 'overlay-fade-img-scale-out',
                            'overlay-slide-in-top', 'overlay-slide-in-left', 'overlay-slide-in-right', 'overlay-slide-in-bottom', 'overlay-img-slide-up',
                            'overlay-img-slide-left', 'overlay-img-slide-right', 'overlay-img-slide-down', 'overlay-scale-in', 'overlay-scale-in img-scale-in'
                            );

        $effect = !empty( $effect ) && in_array( $effect, $effects ) ? $effect : 'easeInOut';
        $animation = !empty( $animation ) && in_array( $animation, $animations ) ? $animation : 'overlay-fade-out';

        $url = fastwp_conrad_utils::url_from_vc( $link );

        $image = wp_get_attachment_image_src( $image, 'full' );
        $image = '<img src="' . $image[0] . '" alt="" />';

        return sprintf( $item_markup, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), esc_html( $animation ), esc_html( $effect ), (int) $hover_speed, substr( $background, 1 ), esc_html( $opacity ), $url['url'], $url['target'], $image, esc_html( $title ) );


    }

static function ConradTeamSingle($atts, $content){

        global $fastwp_conrad_custom_shortcode_css;
        extract(shortcode_atts(array(
            'name'          => '',
            'position'      => '',
            'image'         => '',
            'bio'           => '',
            'social_list'   => '',
            'link'          => '',
            'background'    => '#000000',
            'opacity'       => 0.6,
            'hover_speed'   => 500,
            'effect'        => 'easeInOut',
            'animation'     => 'img-scale-in',
            'extra_class'   => '',
            'extra_class'   => ''
        ), $atts));

        $class = array();
        $icon_markup = '<li><a href="%s" class="icon-%s small"></a></li>';
        $items_output = '';

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if($social_list != ''){
            $content = strip_tags($social_list);
            $social_icons = str_replace("\r\n", "\n", $content);
            $social_icons = explode("\n",$social_icons);
            $i = 0;
            foreach($social_icons as $social_icon){
                if(trim($social_icon) == '') continue;
                if(substr_count($social_icon, '|') != 0){
                    list($icon, $icon_link) = explode('|', $social_icon);
                $items_output .= sprintf($icon_markup, esc_url( trim( $icon_link ) ), esc_attr( trim( $icon ) ) );
                $i++;
                }
            }

        }

        $team_item_markup = '<div class="team-content%s">
                                <div class="thumbnail %s" data-hover-easing="%s" data-hover-speed="%s" data-hover-bkg-color="%s" data-hover-bkg-opacity="%s">
                                    <a class="overlay-link fade-location" href="%s" target="%s">
                                        %s
                                        <span class="overlay-info">
                                            <span>
                                                <span>
                                                    %s
                                                </span>
                                            </span>
                                        </span>
                                    </a>
                                </div>
                                <div class="team-content-info">
                                    <h5 class="mb-5">%s</h5>
                                    <h6 class="occupation mb-20">%s</h6>
                                    <p>%s</p>
                                    <ul class="social-list list-horizontal no-margin-bottom social-list-icons">
                                       %s
                                    </ul>
                                </div>
                            </div>';

        $effects = array(  'linear', 'swing', 'easeInQuad', 'easeOutQuad', 'easeInOutQuad', 'easeInCubic',
                            'easeOutCubic', 'easeInOutCubic', 'easeInQuart', 'easeOutQuart', 'oeaseInOutQuart',
                            'oeaseInQuint', 'oeaseOutQuint', 'easeInExpo', 'easeOutExpo', 'easeInOutExpo',
                            'easeInSine', 'easeOutSine', 'easeInOutSine', 'easeInOutQuint', 'easeInCirc',
                            'easeOutCirc', 'easeInOutCirc', 'easeInOutQuint', 'easeInElastic', 'easeOutElastic',
                            'easeInOutElastic', 'easeInBack', 'easeOutBack', 'easeInOutBack', 'easeInOutBounce'
                        );

        $animations = array(
                            'overlay-fade-out', 'overlay-fade-in', 'img-scale-in', 'overlay-fade-img-scale-in', 'overlay-fade-img-scale-out',
                            'overlay-slide-in-top', 'overlay-slide-in-left', 'overlay-slide-in-right', 'overlay-slide-in-bottom', 'overlay-img-slide-up',
                            'overlay-img-slide-left', 'overlay-img-slide-right', 'overlay-img-slide-down', 'overlay-scale-in', 'overlay-scale-in img-scale-in'
                            );

        $effect = !empty( $effect ) && in_array( $effect, $effects ) ? $effect : 'easeInOut';
        $animation = !empty( $animation ) && in_array( $animation, $animations ) ? $animation : 'overlay-fade-out';

        $url = fastwp_conrad_utils::url_from_vc( $link );
        $image = wp_get_attachment_image_src( $image, 'full' );
        $image = '<img src="' . $image[0] . '" alt="" />';

        return sprintf( $team_item_markup, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), esc_html( $animation ), esc_html( $effect ), (int) $hover_speed, substr( $background, 1 ), esc_html( $opacity ), $url['url'], $url['target'], $image, $url['title'], esc_html( $name ), esc_html( $position ), wp_kses( $bio, fastwp_conrad_utils::allowed_tags() ), $items_output );

    }


static function ConradProgressBarsContainer($atts, $content){

		extract(shortcode_atts(array(
			'extra_class'	=> ''
		), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

		return sprintf( '<div class="progress-bar-group%s">%s</div>', ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), do_shortcode( $content ) );

    }

static function ConradProgressBarsItem($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
            'title'         => 'Title',
            'percent'       => '50',
            'style'         => '',
            'size'          => '',
            'bg_color'      => '',
            'hbg_color'      => '',
            'visibility'    => true,
            'extra_class'   => ''
		), $atts));

        if( ! (boolean) $visibility ) return '';

        $class = $pb_class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( !empty( $size ) ) {
            $pb_class[] = esc_attr( $size );
        }

        if( !empty( $style ) ) {
            $pb_class[] = esc_attr( $style );
        }

        $pb_class[] = $pb_id = 'pb-' . rand( 1000, 9999 );

        if( !empty( $bg_color ) ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .bar{ background: %s; border-color: %s; }', $pb_id, esc_html( $bg_color ), esc_html( $bg_color ) );
        }

        if( !empty( $hbg_color ) ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s{ background: %s; }', $pb_id, esc_html( $hbg_color ) );
        }

        $item_markup = '<span class="progress-bar-label%s">%s - %s</span>
                        <div class="progress-bar%s">
                        	<div class="bar percent-%s horizon"
                        		data-animate-in="transX:-300;duration:1000ms;easing:easeIn;">
                        	</div>
                        </div>';

		return sprintf( $item_markup, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), esc_html( $title ), (int) $percent . '%', ( !empty( $pb_class ) ? ' ' . implode( ' ', $pb_class ) : '' ), (int) $percent );

    }

static function ConradPriceTableContainer($atts, $content){

		extract(shortcode_atts(array(
            'columns'       => 2,
			'extra_class'	=> ''
		), $atts));


		return sprintf( '<div class="pricing-table columns-%s rounded medium%s">%s</div>', ( in_array( (int) $columns, array( 1, 2, 3, 4, 5 ) ) ? $columns : 2 ), ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), do_shortcode( $content ) );

    }

static function ConradPriceTableItem($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
            'title'         => 'Title',
            'currency'      => '$',
            'price'         => '9.99',
            'interval'      => 'month',
            'link'          => '',
            'button_size'   => '',
            'color_scheme'  => '',
            'color_button'  => '',
            'currency_pos'  => '',
            'selected'      => false,
            'visibility'    => true,
            'extra_class'   => ''
		), $atts));

        if( ! (boolean) $visibility ) return '';

        $class = array();

		$class[] = $table_id = 'fwp-pricetable-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( (boolean) $selected ) {
            $class[] = 'callout';
        }

        $url = fastwp_conrad_utils::url_from_vc( $link );

        $item_markup = '<div class="pricing-table-column %s">
                    	<div class="pricing-table-header%s">
                    		<h2 class="weight-bold">%s</h2>
                    	</div>
                    	<div class="pricing-table-price bkg-grey-ultra-light color-charcoal">
                    		<h4>
                    			%s
                    			<span class="interval">/%s</span>
                    		</h4>
                    	</div>';

                $list = explode( ',', $content );

                if( count( $list ) > 0 ) {
                    $item_markup .= '<ul class="pricing-table-options">';
                    foreach( explode( ';', $content ) as $item ) {
                        $item_markup .= '<li>' . esc_html( $item ) . '</li>';
                    }
                    $item_markup .= '</ul>';
                }

                $a_button  = '';

                if( !empty( $url['title'] ) ) {

                $styles = array(
                                'bkg-turquoise'         => 'bkg-turquoise border-hover-turquoise color-white color-hover-turquoise',
                                'bkg-red-light'         => 'bkg-red-light border-hover-red-light color-white color-hover-red-light',
                                'bkg-charcoal-light'    => 'bkg-charcoal-light border-hover-charcoal-light color-white color-hover-charcoal-light',
                                'bkg-green-light'       => 'bkg-green-light border-hover-green-light color-white color-hover-green-light',
                                'bkg-navy-light'        => 'bkg-navy-light border-hover-navy-light color-white color-hover-navy-light',
                                'bkg-orange-light'      => 'bkg-orange-light border-hover-orange-light color-white color-hover-orange-light',
                                'bkg-facebook'          => 'bkg-facebook border-hover-facebook color-white color-hover-facebook',
                                'bkg-pinterest'         => 'bkg-pinterest border-hover-pinterest color-white color-hover-pinterest',
                                'white'                 => 'border-white bkg-hover-white color-white color-hover-purple fade-location',
                                'gray'                  => 'border-grey bkg-hover-grey color-hover-white',
                                'default'               => 'bkg-grey-light bkg-hover-grey color-white color-hover-white'
                                );

                $btn_class   = array();
                $btn_class[] = !empty( $color_button ) && in_array( $color_button, array_keys( $styles ) ) ? $styles[$color_button] : $styles['default'];
                $btn_class[] = in_array( $button_size, array( 'small', 'medium', 'large', 'xlarge' ) ) ? $button_size : '';

                $a_button  = sprintf( '<a href="%s" target="%s" class="%s rounded button">%s</a>', esc_url( $url['url'] ), esc_html( $url['target'] ), implode( ' ', array_filter( $btn_class ) ), esc_html( $url['title'] ) );

                $item_markup .= '<div class="pricing-table-footer">
                                    %s
                                </div>';

                }

               $item_markup .= '</div>';


		return sprintf( $item_markup, implode( ' ', $class ), ( !empty( $color_scheme ) && in_array( $color_scheme, array( 'bkg-purple', 'bkg-turquoise', 'bkg-green', 'bkg-blue', 'bkg-navy', 'bkg-yellow', 'bkg-orange', 'bkg-orange-light', 'bkg-red', 'bkg-white', 'bkg-grey', 'bkg-grey-light', 'bkg-grey-ultralight', 'bkg-charcoal', 'bkg-charcoal-light', 'bkg-black', 'bkg-base' ) ) ? ' ' . $color_scheme : '' ), esc_html( $title ), ( $currency_pos != 'suffix' ? '<span class="currency">' . esc_html( $currency ) . '</span>' : '' ) . esc_html( $price ) . ( $currency_pos == 'suffix' ? '<span class="currency">' . esc_html( $currency ) . '</span>' : '' ), esc_html( $interval ), $a_button );

    }

static function ConradSliderContainer($atts, $content){

        extract(shortcode_atts(array(
            'featured_media'=> true,
            'speed'         => 900,
            'home_slider'   => false,
            'full_width'    => true,
            'full_height'   => false,
            'height'        => '',
            'width'         => '',
            'show_progress_bar' => true,
            'auto_advance'  => false,
            'slide_speed'   => 700,
            'slide_interval'=> 6000,
            'extra_class'   => ''
        ), $atts));

        $class = $sl_class = $c_attrs = array();

        if( (boolean) $featured_media ) {
            $class[] = 'featured-media';
        }

        if( !empty( $extra_class ) ) {
            $class[] = sanitize_html_class( $extra_class );
        }

        if( (boolean) $home_slider ) {
            $sl_class[] = 'homepage-slider';
        }

        if( (boolean) $full_height ) {
            $sl_class[] = 'window-height';
        }

        if( (boolean) $full_width ) {
            $sl_class[] = 'full-width-slider';
        } else {
            $sl_class[] = 'content-slider';
        }

        if( !(boolean) $full_height && !empty( $height ) ) {
            $c_attrs[] = 'data-height="' . (int) $height . '"';
        }

        if( !(boolean) $full_height && !empty( $height ) ) {
            $c_attrs[] = 'data-height="' . (int) $height . '"';
        }

        if( !(boolean) $full_width && !empty( $width ) ) {
            $c_attrs[] = 'data-width="' . (int) $width . '"';
        }

        $c_attrs[] = 'data-progress-bar="' . ( (boolean) $show_progress_bar ? 'true' : 'false' ) . '"';
        if( (boolean) $auto_advance ) $c_attrs[] = 'data-auto-advance="true"';
        if( !empty( $slide_interval ) ) $c_attrs[] = 'auto-advance-interval="' . (int) $slide_interval . '"';
        if( !empty( $slide_speed ) ) $c_attrs[] = 'data-speed="' . (int) $slide_speed . '"';



        return sprintf( '<div class="tm-slider-container%s%s" data-speed="%s"%s>
						        <ul class="tms-slides">
                                    %s
                                </ul>
                            </div>', ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), ( !empty( $sl_class ) ? ' ' . implode( ' ', $sl_class ) : '' ), (int) $speed, ( !empty( $c_attrs ) ? ' ' . implode( ' ', $c_attrs ) : '' ), do_shortcode( $content ) );

    }

static function ConradSliderItem($atts, $content){

        extract(shortcode_atts(array(
            'animation'         => 'slideLeftRight',
            'type'              => 'image',
            'image'             => '',
            'retina_image'      => '',
            'video'             => '',
            'video_self_mp4'    => '',
            'video_self_webm'   => '',
            'video_self_ogg'    => '',
            'slide1_text'       => '',
            'slide1_tag'        => 'h1',
            'slide1_delay'      => 300,
            'slide2_text'       => '',
            'slide2_tag'        => 'h1',
            'slide2_delay'      => 300,
            'slide3_text'       => '',
            'slide3_tag'        => 'h1',
            'slide3_delay'      => 300,
            'a_tag'             => '',
            'video_fallback_img'=> '',
            'video_fallback_retina_img' => '',
            'is_scroll_link'    => false,
            'use_content'       => false,
            'extra_class'       => ''
        ), $atts));

        $animations = array( 'slideLeftRight', 'slideTopBottom', 'scaleIn', 'scaleOut', 'fade' );

        if( $type == 'video' ) {
            $data_type = 'data-video';
        } else if( $type == 'video-background' ) {
            $data_type = 'data-video data-video-bkg';
        } else {
            $data_type = 'data-image data-force-fit';
        }

        if( (boolean) $use_content ) {

        $slide_content = '';

        if( function_exists( 'fastwp_conrad_dec' ) ) {
            $slide_content = fastwp_conrad_dec( $content );
        }

        } else {

        $slides     = array();
        if( !empty( $slide1_text ) ) {
            $slides[] = array( 'text' => esc_html( $slide1_text ), 'tag' => ( in_array( $slide1_tag, array( 'h1', 'h2' ) ) ? $slide1_tag : 'h1' ), 'delay' => (int) $slide1_delay );
        }
        if( !empty( $slide2_text ) ) {
            $slides[] = array( 'text' => esc_html( $slide2_text ), 'tag' => ( in_array( $slide2_tag, array( 'h1', 'h2' ) ) ? $slide2_tag : 'h1' ), 'delay' => (int) $slide2_delay );
        }
        if( !empty( $slide3_text ) ) {
            $slides[] = array( 'text' => esc_html( $slide3_text ), 'tag' => ( in_array( $slide3_tag, array( 'h1', 'h2' ) ) ? $slide3_tag : 'h1' ), 'delay' => (int) $slide3_delay );
        }
        $text_slide = $a_text = '';

        if( !empty( $slides ) ) {
            $i = 1;
            foreach( $slides as $slide ) {
                $text_slide .= '<' . $slide['tag'] . ' class="tms-caption title-xlarge color-white weight-bold lspacing-medium ' . ( $i == count( $slides ) ? 'mb-30' : 'no-margins' ) . '"
				                    data-animate-in="opacity:0;transX:' . ( $i%2 ? '40px' : '-40px' ) . ';duration:600ms;delay:' . (int) $slide['delay'] . ';easing:easeFastSlow;">
                                    ' . ( $slide['tag'] == 'h2' ? '<span class="transparent-element">' : '' ) . esc_html( $slide['text'] ) . ( $slide['tag'] == 'h2' ? '</span>' : '' ) . '
                                </' . $slide['tag'] . '>
                                <div class="clear"></div>';
                $i++;
            }
        }

        $link = fastwp_conrad_utils::url_from_vc( $a_tag );

        if( !empty( $link['title'] ) ) {
            $a_text = '<a href="' . esc_url( $link['url'] ) . '" target="' . $link['target'] . '" data-offset="-60" class="' . ( (boolean) $is_scroll_link ? 'scroll-link ' : '' ) . 'tms-caption animated-link text-xlarge color-white"
			                data-animate-in="opacity:0;transX:-40px;duration:500ms;delay:800ms;easing:easeFastSlow;"
							data-no-scale>
                            <span class="text-line bkg-white"></span>' . esc_html( $link['title'] ) . '</a>';
        }

        $slide_content = '<div class="row">
                        <div class="column width-12 left">';
        $slide_content .= $text_slide . $a_text;
        $slide_content .= '</div>
                        </div>';

        }

        if( $type == 'video' ) {

            $attachment = '<iframe src="' . esc_url( $video ) . '"></iframe>';

        } else if( $type == 'video-background' ) {

            $attachment = '<video poster="' . get_template_directory_uri() . '/assets/images/blank.png">';
            if( !empty( $video_self_mp4 ) ) {
                $attachment .= sprintf( '<source type="video/mp4" src="%s" />', esc_url( $video_self_mp4 ) );
            }
            if( !empty( $video_self_webm ) ) {
                $attachment .= sprintf( '<source type="video/webm" src="%s" />', esc_url( $video_self_webm ) );
            }
            if( !empty( $video_self_ogg ) ) {
                $attachment .= sprintf( '<source type="video/ogg" src="%s" />', esc_url( $video_self_ogg ) );
            }
			$attachment .= '</video>';

            $fb_image = wp_get_attachment_image_src( $video_fallback_img, 'full' );
            $fb_image = $fb_image[0];

            $fb_retina_image = wp_get_attachment_image_src( $video_fallback_retina_img , 'full');
            $fb_retina_image = $fb_retina_image[0];

            $retina_attr = '';
            if( fastwp_conrad_utils::is_retina_ready( $fb_image, $fb_retina_image ) ) {
                $retina_attr = ' data-retina';
            }

            $attachment .= '<img data-src="' . $fb_image . '"' . $retina_attr . ' src="' . get_template_directory_uri() . '/assets/images/blank.png" alt=""/>';

        } else {

            $attachment = '';

            if( isset( $image ) && is_numeric( $image ) ) {
                $alt_attr = get_post_meta($image, '_wp_attachment_image_alt', true);
                $image = wp_get_attachment_image_src($image,'full');
                $image = $image[0];

                $retina_image = wp_get_attachment_image_src( $retina_image ,'full');
                $retina_image = $retina_image[0];

                $retina_attr = '';
                if( fastwp_conrad_utils::is_retina_ready( $image, $retina_image ) ) {
                    $retina_attr = ' data-retina';
                }

                $attachment = '<img data-src="' . $image . '"' . $retina_attr . ' src="' . get_template_directory_uri() . '/assets/images/blank.png" alt="" />';
           }

        }

        $item_markup = '<li class="tms-slide%s" %s data-animation="%s">
								<div class="tms-content">
									<div class="tms-content-inner">
									        %s
										</div>
									</div>
								%s
							</li>';

        return sprintf( $item_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), $data_type, ( in_array( $animation, $animations ) ? $animation : 'slideLeftRight' ), $slide_content, $attachment );

    }

static function ConradTeamContainer($atts, $content){

        extract(shortcode_atts(array(
            'title'         => 'The Team',
            'title_tag'     => 'h2',
            'title_bold'    => true,
            'title_mb'      => 'mb-30',
            'pclass'        => 'lead',
            'size'          => 2,
            'description'   => '',
            'desc_layout'   => '',
            'desc_align'    => '',
            'extra_class'   => ''
        ), $atts));


        $tag_class = $p_class = array();

        if( (boolean) $title_bold ) {
            $tag_class[] = 'weight-bold';
        }

        if( !empty( $title_mb ) ) {
            $tag_class[]   = esc_attr( $title_mb );
        }

        if( !empty( $pclass ) ) {
            $p_class[] = esc_html( $pclass );
        }

        if( !in_array( $title_tag, array( 'h1', 'h2', 'h3', 'h4', 'h5', 'h6' ) ) ) {
            $title_tag  = 'h2';
        }

        $desc_pos   = ( $desc_layout == 'above' ? array( 12, 12 ) : array( 4, 8 ) );
        $desc_align = ( in_array( $desc_align, array( 'center', 'right' ) ) ? ' ' . $desc_align : '' );

        return sprintf( '<section class="section-block">
                    <div class="row%s">
                        <div class="column%s width-%s">
                            <%s%s>%s</%s>
                            <p%s>%s</p>
                            <div class="slider-aux-nav mb-50">
                                <a href="#" class="previous-team-slider color-charcoal color-hover-turquoise"><span class="text-line bkg-charcoal"></span>' . esc_html__( 'Prev', 'conrad' ) . '</a>
                                <a href="#" class="next-team-slider color-charcoal color-hover-turquois"><span class="text-line bkg-charcoal"></span>' . esc_html__( 'Next', 'conrad' ) . '</a>
                            </div>
                        </div>
                        <div class="column width-%s slider-column no-padding">
                            <div id="team-slider-1" class="tm-slider-container team-slider team-slider-1" data-carousel-visible-slides="%s" data-height="500">
                                <ul class="tms-slides">%s</ul>
                            </div>
                        </div>
                    </div>
                    </section>', ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), $desc_align, $desc_pos[0], $title_tag, ( !empty( $tag_class ) ? ' class="' . implode( ' ', $tag_class ) . '"' : '' ), esc_html( $title ), $title_tag, ( !empty( $p_class ) ? ' class="' . implode( ' ', $p_class ) . '"' : '' ), wp_kses( $description, fastwp_conrad_utils::allowed_tags() ), $desc_pos[1], ( in_array( $size, array( '2', '3', '4', '5' ) ) ? $size : 2 ), do_shortcode( $content ) );

    }

static function ConradTeamItem($atts, $content){

        extract(shortcode_atts(array(
            'name'          => '',
            'position'      => '',
            'bio'           => '',
            'image'         => '',
            'extra_class'   => '',
            'social_list'   => '',
        ), $atts));

        $item_markup = '<li class="tms-slide%s">
                        <div class="team-content">
                            <div class="thumbnail">
                                <img data-src="%s" src="%s" alt="%s"/>
                            </div>
                            <div class="team-content-info">
                                <h5 class="mb-5">%s</h5>
                                <h6 class="occupation mb-20">%s</h6>
                                <p>%s</p>
                                <ul class="social-list list-horizontal social-list-icons">%s</ul>
                            </div>
                        </div>
                    </li>';

        $alt_attr = $icon_markup = $items_output = '';

        if( isset( $image ) && is_numeric( $image ) ) {
            $alt_attr = get_post_meta($image, '_wp_attachment_image_alt', true);
            $image = wp_get_attachment_image_src($image,'full');
            $image = $image[0];
        }

        $icon_markup = '<li><a href="%s" class="icon-%s small"></a></li>';

        if($social_list != ''){
            $content = strip_tags($social_list);
            $social_icons = str_replace("\r\n", "\n", $content);
            $social_icons = explode("\n",$social_icons);
            $i = 0;
            foreach($social_icons as $social_icon){
                if(trim($social_icon) == '') continue;
                if(substr_count($social_icon, '|') != 0){
                    list($icon, $link) = explode('|', $social_icon);
                $items_output .= sprintf($icon_markup, esc_url( trim( $link ) ), esc_attr( trim( $icon ) ) );
                $i++;
                }
            }

        }

        return sprintf( $item_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), esc_url( $image ), esc_url( $image ), esc_attr( $alt_attr ), esc_html( $name ), esc_html( $position ), wp_kses( $bio, fastwp_conrad_utils::allowed_tags() ), $items_output  );

    }

static function ConradSocialProfilesContainer($atts, $content){

		extract(shortcode_atts(array(
			'extra_class'	=> ''
		), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

		return sprintf( '<div class="social-list list-horizontal%s">%s</div>', ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), do_shortcode( $content ) );

    }

static function ConradSocialProfilesItem($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
            'profile1_url'  => '',
            'profile1_icon' => '',
            'profile2_url'  => '',
            'profile2_icon' => '',
            'profile3_url'  => '',
            'profile3_icon' => '',
            'profile4_url'  => '',
            'profile4_icon' => '',
            'profile5_url'  => '',
            'profile5_icon' => '',
            'visibility'    => true
		), $atts));

        if( ! (boolean) $visibility ) return '';

        $social_profiles = array();
        if( !empty( $profile1_url ) || !empty( $profile1_icon ) ) {
            $social_profiles[] = array( 'url' => $profile1_url, 'icon' => $profile1_icon );
        }
        if( !empty( $profile2_url ) || !empty( $profile2_icon ) ) {
            $social_profiles[] = array( 'url' => $profile2_url, 'icon' => $profile2_icon );
        }
        if( !empty( $profile3_url ) || !empty( $profile3_icon ) ) {
            $social_profiles[] = array( 'url' => $profile3_url, 'icon' => $profile3_icon );
        }
        if( !empty( $profile4_url ) || !empty( $profile4_icon ) ) {
            $social_profiles[] = array( 'url' => $profile4_url, 'icon' => $profile4_icon );
        }
        if( !empty( $profile1_url ) || !empty( $profile5_icon ) ) {
            $social_profiles[] = array( 'url' => $profile5_url, 'icon' => $profile5_icon );
        }

        $items = '';
        foreach( $social_profiles as $profile ) {
            $items .= sprintf( '<a href="%s" class="%s small"></a>', esc_url( $profile['url'] ), esc_attr( $profile['icon'] ) );
        }

		return $items;

    }

static function ConradClientsContainer($atts, $content){

        global $global_clients_container;
        extract(shortcode_atts(array(
            'type'          => 'text',
            'items_per_row' => 4,
            'title'         => 'Clients',
            'title_tag'     => 'h5',
            'title_mb'      => '',
            'title_mb_m'    => 'mb-mobile-30',
            'title_position'=> 'side',
            'color_scheme'  => 'bkg-purple',
            'content_color' => 'color-white',
            'extra_class'   => ''
        ), $atts));

        $items_per_row = in_array( (int) $items_per_row, array( 1, 2, 3, 4, 5, 6 ) ) ? $items_per_row : 4;

        $global_clients_container = $type;

        if( $type == 'logos' ) {


        return sprintf( '<div class="row logos-1 content-grid-%s%s">
                            %s
		                </div>', $items_per_row, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), do_shortcode( $content ) );

        } else {


        $container_width    = 12;
        $title_markup       = '';

        if( !empty( $title ) ) {
            $container_width= 10;
            $tclass         = array();
            if( !in_array( $title_tag, array( 'h1', 'h2', 'h3', 'h4', 'h5', 'h6' ) ) ) {
                $title_tag  = 'h5';
            }
            if( !empty( $title_mb ) ) {
                $tclass[]   = esc_attr( $title_mb );
            }
            if( !empty( $title_mb_m ) ) {
                $tclass[]   = esc_attr( $title_mb_m );
            }
            $title_markup   = sprintf( '<div class="column width-2">
                                    <%s%s>%s</%s>
                                </div>', $title_tag, ( !empty( $tclass ) ? ' class="' . implode( ' ', $tclass ) . '"' : '' ), esc_html( $title ), $title_tag );
        }

        if( $title_position == 'top' ) {
            $container_width= 12;
        }

        return sprintf( '<div class="section-block clients-1 replicable-content %s %s%s">
                            <div class="row">
                                %s
                                <div class="column width-%s">
                                    <div class="row content-grid-%s equalize">
                                    %s
                                    </div>
                                </div>
                            </div>
                        </div>', esc_html( $color_scheme ), esc_html( $content_color ), ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), $title_markup, $container_width, $items_per_row, do_shortcode( $content ) );

    }

    }

static function ConradClientsItem($atts, $content){

        global $global_clients_container;
        extract(shortcode_atts(array(
            'client_name'       => 'Client Name',
            'client_occupation' => 'Client Occupation',
            'client_logo'       => '',
            'client_logo_link'  => '',
            'extra_class'       => ''
        ), $atts));

        if( $global_clients_container == 'logos' ) {

        $url = fastwp_conrad_utils::url_from_vc( $client_logo_link );

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_html( $extra_class );
        }

        if( empty( $url['url'] ) ) {
            $class[] = 'cursor-default';
        }

        $image = '';
        if( isset( $client_logo ) && is_numeric( $client_logo ) ) {
            $image = wp_get_attachment_image_src( $client_logo,'full' );
            $image = $image[0];
        }

        $item_markup = '<div class="grid-item%s">
                            <a href="%s" target="%s">
    		                    <img src="%s" alt="" />
    		                </a>
                        </div>';


        return sprintf( $item_markup, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), esc_url( $url['url'] ), esc_attr( $url['target'] ), $image );

        } else {

        $item_markup = '<div class="grid-item%s">
                            <h5 class="client-name">%s</h5>
                            <span class="client-description font-alt-1">%s</span>
                        </div>';


        return sprintf( $item_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), esc_html( $client_name ), esc_html( $client_occupation ) );

        }

    }

static function ConradTestimonialsContainer($atts, $content){

        extract(shortcode_atts(array(
            'bullets_color' => '',
            'extra_class'   => ''
        ), $atts));


        $bullets = '';
        if( !empty( $bullets_color ) ) {
            switch( $bullets_color ) {
                case 'gray': $bullets = ' gray-bullets'; break;
                case 'white': $bullets = ' white-bullets'; break;
                case 'black': $bullets = ' black-bullets'; break;
            }
        }


        return sprintf( '<div id="testimonial-slider-1" class="testimonial-slider tm-slider-container%s%s">
                                <ul class="tms-slides">
                                    %s
                                </ul>
                            </div>', ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), $bullets, do_shortcode( $content ) );

    }

static function ConradTestimonialsItem($atts, $content){

        extract(shortcode_atts(array(
            'size'          => 12,
            'name'          => 'Name of reviewer',
            'text_size'     => '',
            'color'         => '',
            'extra_class'   => ''
        ), $atts));

        $item_markup = '<li class="tms-slide" data-image>
                            <div class="tms-content-scalable">
                                <div class="row">
                                    <div class="column width-%s%s">
                                        <blockquote class="center%s">
                                        <p>%s
                                            <cite>%s</cite>
                                        </p>
                                        </blockquote>
                                    </div>
                                </div>
                            </div>
                        </li>';


        return sprintf( $item_markup, ( in_array( (int) $size, array( 4, 6, 12 ) ) ? $size : 6 ), ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), ( !empty( $text_size ) ? ' ' . esc_html( $text_size ) : '' ), $content , esc_html( $name ) );

    }

static function ConradCountersContainer($atts, $content){

        extract(shortcode_atts(array(
            'size'          => 5,
            'extra_class'   => ''
        ), $atts));

        return sprintf( '<div class="stats-1 stats-1-about-1">
                            <div class="stat-content">
                                <div class="stat-content-inner">
                                    <div class="row content-grid-%s%s">
                                    %s
                                    </div>
                                </div>
                            </div>
                        </div>', ( in_array( (int) $size, array( 1, 2, 3, 4, 5, 6) ) ? $size : 5 ), ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), do_shortcode( $content ) );

    }

static function ConradCountersItem($atts, $content){

        extract(shortcode_atts(array(
            'data_from'     => 100,
            'data_to'       => 300,
            'title'         => 'Title',
            'style'         => 'large',
            'margin_bottom' => '',
            'suffix'		=> '',
            'extra_class'   => ''
        ), $atts));

        $counter_class = array();

        if( !empty( $margin_bottom ) ) {
            $counter_class[] = esc_attr( $margin_bottom );
        }

        if( !empty( $style ) ) {
            $counter_class[] = esc_attr( $style );
        }

        $item_markup = '<div class="grid-item%s">
                            <div class="stat">
                                <div class="stat-inner">
                                    <p class="counter%s"><span class="stat-counter" data-count-from="%s" data-count-to="%s">%s</span>%s</p>
                                    <p class="description">%s</p>
                                </div>
                            </div>
                        </div>';

        return sprintf( $item_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), ( !empty( $counter_class ) ? ' ' . implode( ' ',  $counter_class ) : '' ), (int) $data_from, (int) $data_to, (int) $data_to,
        	(!empty ( $suffix ) ? esc_html ( $suffix ) : '' ), ( $title ) );

    }

static function ConradAwardsContainer($atts, $content){

        extract(shortcode_atts(array(
            'size'          => 4,
            'extra_class'   => ''
        ), $atts));

        do_action('fastwp_conrad_enqueue_script', 'plugins');

        return sprintf( '<div class="row%s content-grid-%s">%s</div>', ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), ( in_array( (int) $size, array( 4, 6, 12 ) ) ? $size : 6 ), do_shortcode( $content ) );

    }

static function ConradAwardsItem($atts, $content){

        extract(shortcode_atts(array(
            'image'         => '',
            'url'           => '',
            'target'        => '',
            'extra_class'   => '',
            'extra_id'      => '',
        ), $atts));

        $module_output      = '';
        $module_markup      = '<div class="grid-item %s">%s</div>';
        $item_anchor_markup = '<a href="%s" target="%s"><img src="%s" alt="Awards"></a>';
        $item_markup        = '<img src="%s" alt="Awards">';
        $items_output       = '';

        if( isset( $image ) && is_numeric( $image ) ) {
            $image = wp_get_attachment_image_src($image,'full');
            $image = $image[0];
        }

        $url_args       = vc_build_link($url );
        $url            = ( isset( $url_args['url'] ) ) ? $url_args['url'] : '';
        $target         = ( isset( $url_args['target'] ) ) ? trim( $url_args['target'] ) : '_self';
        $items_output   = ($url == '') ? sprintf($item_markup,$image) : sprintf($item_anchor_markup, $url, $target, $image);

        return sprintf( $module_markup, $extra_class, $items_output );

}

static function ConradFeatureBoxesContainer($atts, $content){

        extract(shortcode_atts(array(
            'extra_class'   => ''
        ), $atts));

        do_action('fastwp_conrad_enqueue_script', 'plugins');

        return sprintf( '<div class="row%s">%s</div>', ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), do_shortcode( $content ) );

    }

static function ConradFeatureBoxesItem($atts, $content){

        global $fastwp_conrad_custom_shortcode_css;
        extract(shortcode_atts(array(
            'title'         => '',
            'title_color'   => '',
            'content_color' => '',
            'icon'          => '',
            'icon_color'    => '',
            'icon_bgcolor'  => '',
            'feature_content' => '',
            'size'          => 6,
            'animation'     => true,
            'anim_direction'=>'left',
            'anim_delay'    => 0,
            'visibility'    => true,
            'extra_class'   => ''
        ), $atts));

        if( ! (boolean) $visibility ) return '';

        $class = array();

        $class[] = $box_id = 'fwp-feature-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $animation_markup = '';

        if( (boolean) $animation ) {
            $anim_px = '-30';
            if( $anim_direction != 'right' ) {
                $anim_px = '30';
            }
            $animation_markup = ' data-animate-in="transX:' . $anim_px . 'px;' . ( !empty( $anim_delay ) ? 'delay:' . (int) $anim_delay . 'ms;"' : '"' );
        }

        $item_markup = '<div class="column width-%s %s">
                        <div class="feature-column center horizon"' . $animation_markup . ' data-threshold="1">
                            <span class="feature-icon %s icon-circled medium %s"></span>
                            <div class="feature-text">
                                <h5 class="font-alt-1">%s</h5>
                                <p>%s</p>
                            </div>
                        </div>
                    </div>';

        $fastwp_conrad_custom_shortcode_css .= sprintf('.%s .font-alt-1 {color:%s;} .%s .feature-text p {color:%s;} .%s .feature-icon {background-color:%s;}', $box_id, esc_html( $title_color ), $box_id, esc_html( $content_color ), $box_id, esc_html( $icon_bgcolor ) );

        // do_action('fastwp_conrad_enqueue_script', '');

        return sprintf( $item_markup, ( in_array( (int) $size, array( 4, 6, 12 ) ) ? $size : 6 ), implode( ' ', $class ), esc_attr( $icon ), esc_attr( $icon_color ), esc_html( $title ), esc_html( $feature_content ) );

    }

static function ConradHeroTitle($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
			'title'			=> 'Title',
            'info'          => '',
            'background'    => '',
            'retina_bg'     => '',
            'slides'        => array(),
			'extra_class'	=> ''
		), $atts));

        $markup = '
                <section class="section-block featured-media%s">
					<div class="tm-slider-container full-width-slider">
						<ul class="tms-slides">
                            %s
						</ul>
					</div>
				</section>';

        $rslide = '';

        if( !empty( $slides ) ) {
            $sslides    = is_array( $slides ) ? $slides : explode( ',', $slides );
            $titles     = explode( ';', $title );
            $subtitles  = explode( ';',  $info );
            $slides     = array();
            $i = 0;
            foreach( $sslides as $slide ) {
                $slides[] = array( 'title' => ( isset( $titles[$i] ) ? $titles[$i] : '' ),  'background' => $slide, 'info' => ( isset( $subtitles[$i] ) ? $subtitles[$i] : '' ), );
                $i++;
            }
        } else {
            $slides = array( array( 'title' => $title, 'background' => $background, 'retina_background' => $retina_bg, 'info' => $info ) );
        }

        foreach( $slides as $slide ) {

        if( !is_array( $slide ) ) {

        }

        $slide_markup = '
                <li class="tms-slide" data-image data-force-fit>
				    <div class="tms-content">
					    <div class="tms-content-inner">
						    <div class="row">
							    <div class="column width-12 left">
								    <h1 class="tms-caption title-xlarge color-white weight-bold lspacing-medium no-margins"
									        data-animate-in="opacity:0;transX:40px;duration:600ms;delay:0;easing:easeFastSlow;">
									    %s
									</h1>';

                                    if( !empty( $slide['info'] ) ) {
                                    $slide_markup .= sprintf( '<div class="clear"></div>

                                    <div class="tms-caption title-medium color-white weight-bold lspacing-medium no-margins"
						                    data-animate-in="opacity:0;transX:-40px;duration:600ms;delay:300ms;easing:easeFastSlow;">
								        <span class="post-date transparent-element">%s</span>
						            </div>', esc_html( $slide['info'] ) );
                                    }

								$slide_markup .= '</div>
							</div>
						</div>
					</div>
					%s
				</li>';

            $image = $retina_attr = '';
            if( is_numeric( $slide['background'] ) ) {
                $image = wp_get_attachment_image_src( $slide['background'], 'full' );
                $image = '<img data-src="' . $image[0] . '"' . $retina_attr . ' src="' . fastwp_conrad_main_theme_url . '/assets/images/blank.png" alt=""/>';
            } else if( filter_var( $slide['background'], FILTER_VALIDATE_URL ) ) {
                if( isset( $slide['retina_background'] ) && fastwp_conrad_utils::is_retina_ready( $slide['background'], $slide['retina_background'] ) ) {
                    $retina_attr = ' data-retina';
                }
                $image = '<img data-src="' . esc_url( $slide['background'] ) . '"' . $retina_attr . ' src="' . fastwp_conrad_main_theme_url . '/assets/images/blank.png" alt=""/>';
            }
            $rslide .= sprintf( $slide_markup, esc_html( $slide['title'] ), $image );
        }

		return sprintf( $markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), $rslide );

    }

static function ConradHeroVideo($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
			'video'			=> '',
			'extra_class'	=> ''
		), $atts));

        $video_url = '';

        if( preg_match( '/http(s)?:\/\/(www.)?youtube.com\/embed/i', $video ) ) {
    	    preg_match( '/http(s)?:\/\/(www.)?youtube.com\/embed\/([a-z0-9]+)/i', $video, $vid );
            if( isset( $vid[3] ) ) {
                $video_url = 'https://www.youtube.com/embed/' . $vid[3] . '?modestbranding=1&amp;autohide=1&amp;showinfo=0&amp;controls=0&amp;autoplay=1';
            }
    	} else if( preg_match( '/http(s)?:\/\/(www.)?youtube.com/i', $video ) ) {
    	    preg_match( '/http(s)?:\/\/(www.)?youtube.com\/watch\?v=([a-z0-9]+)/i', $video, $vid );
            if( isset( $vid[3] ) ) {
                $video_url = 'https://www.youtube.com/embed/' . $vid[3] . '?modestbranding=1&amp;autohide=1&amp;showinfo=0&amp;controls=0&amp;autoplay=1';
            }
    	} else if( preg_match( '/http(s)?:\/\/(www.)?youtu.be/i', $video ) ) {
    	    preg_match( '/http(s)?:\/\/(www.)?youtu.be\/([a-z0-9]+)/i', $video, $vid );
            if( isset( $vid[3] ) ) {
                $video_url = 'https://www.youtube.com/embed/' . $vid[3] . '?modestbranding=1&amp;autohide=1&amp;showinfo=0&amp;controls=0&amp;autoplay=1';
            }
        } else if( preg_match( '/http(s)?:\/\/(www.)?player.vimeo.com\/video/i', $video ) ) {
    	    preg_match( '/http(s)?:\/\/(www.)?player.vimeo.com\/video\/([a-z0-9]+)/i', $video, $vid );
            if( isset( $vid[3] ) ) {
                $video_url = 'https://player.vimeo.com/video/' . $vid[3] . '?title=0&amp;byline=0&amp;portrait=0&amp;color=3fc5e5&amp;autoplay=1';
            }
    	} else if( preg_match( '/http(s)?:\/\/(www.)?vimeo.com/i', $video ) ) {
    	    preg_match( '/http(s)?:\/\/(www.)?vimeo.com\/([a-z0-9]+)/i', $video, $vid );
            if( isset( $vid[3] ) ) {
                $video_url = 'https://player.vimeo.com/video/' . $vid[3] . '?title=0&amp;byline=0&amp;portrait=0&amp;color=3fc5e5&amp;autoplay=1';
            }
        }

        if( empty( $video_url ) ) {
            return '';
        }

        $markup = '
                <div class="section-block featured-media%s">
					<div class="video-container no-margin-bottom">
						<iframe src="%s" width="1110" height="624"></iframe>
					</div>
				</div>';

		return sprintf( $markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), esc_url( $video_url ) );

    }

static function ConradParallaxHero($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
			'background'    => '',
            'use_content'   => false,
            'title'         => '',
            'tag'           => '',
            'link'          => '',
            'is_scroll_link'=> false,
			'extra_class'	=> ''
		), $atts));

        $image_url = '';
        if( is_numeric( $background ) ) {
            $image = wp_get_attachment_image_src( $background, 'full' );
            $image_url = $image[0];
        }

        if( !in_array( $tag, array( 'h1', 'h2', 'h3', 'h4', 'h5', 'h6' ) ) ) {
            $tag = 'h1';
        }

        if( (boolean) $use_content ) {
            $content_markup = wp_kses( $content, fastwp_conrad_utils::allowed_tags() );
        } else {

            $url = fastwp_conrad_utils::url_from_vc( $link );

           if( !empty( $url['title'] ) ) {
                $link = sprintf( '<a href="%s" target="%s" data-offset="-60" class="%sanimated-link text-xlarge color-white"
    											data-animate-in="opacity:0;transX:-40px;duration:500ms;delay:800ms;easing:easeFastSlow;"
    											data-no-scale>
                                                <span class="text-line bkg-white"></span>%s
                                    </a>', $url['url'], $url['target'], ( (boolean) $is_scroll_link ? 'scroll-link ' : '' ), $url['title'] );
            } else {
                $link = '';
            }

            $content_markup = sprintf( '<%s data-parallax="true" data-speed="0.2" data-direction="up" class="title-xlarge color-white weight-bold lspacing-medium mb-30"
											data-animate-in="opacity:0;transX:40px;duration:600ms;delay:0;easing:easeFastSlow;">
											%s
										</%s>
										<div class="clear"></div>
										%s', $tag, wp_kses( $title, fastwp_conrad_utils::allowed_tags() ), $tag, $link );

        }

        $hero_markup = '<section class="section-block featured-media%s">
					<div class="parallax fixed-height window-height" data-src="%s">
						<div class="tmp-content">
							<div class="tmp-content-inner center">
								<div class="row">
									<div class="column width-12">
	                                    %s
									</div>
								</div>
							</div>
						</div>
					</div>
				</section>';

		return sprintf( $hero_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ), $image_url, $content_markup );

    }

static function ConradButton($atts, $content){

        extract(shortcode_atts(array(
            'url'          => '',
            'border'       => '',
            'border_style' => '',
            'dsbld'        => false,
            'shadow'       => '',
            'border'       => '',
            'icon'         => '',
            'size'         => 'medium',
            'btn_class'    => 'bkg-turquoise',
            'extra_class'  => ''
        ), $atts));

        $class = array();

        $class[] = 'button';
        $class[] = $button_id = 'fwp-button-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        switch( $border ) {
            case 'rounded': $class[] = 'rounded'; break;
            case 'pill': $class[] = 'pill'; break;
        }

        if( (boolean) $dsbld ) {
            $class[] = 'disabled';
        }

        switch( $shadow ) {
            case 'soft': $class[] = 'shadow'; break;
            case 'hard': $class[] = 'hard-shadow'; break;
            default: break;
        }

        if( $border_style == 'dotted' ) {
            $class[] = 'border-gray dotted';
        } else if( $border_style == 'dashed' ) {
            $class[] = 'dashed';
        }

        $styles = array('bkg-turquoise'         => 'bkg-turquoise border-hover-turquoise color-white color-hover-turquoise',
                        'bkg-red-light'         => 'bkg-red-light border-hover-red-light color-white color-hover-red-light',
                        'bkg-charcoal-light'    => 'bkg-charcoal-light border-hover-charcoal-light color-white color-hover-charcoal-light',
                        'bkg-green-light'       => 'bkg-green-light border-hover-green-light color-white color-hover-green-light',
                        'bkg-navy-light'        => 'bkg-navy-light border-hover-navy-light color-white color-hover-navy-light',
                        'bkg-orange-light'      => 'bkg-orange-light border-hover-orange-light color-white color-hover-orange-light',
                        'bkg-facebook'          => 'bkg-facebook border-hover-facebook color-white color-hover-facebook',
                        'bkg-pinterest'         => 'bkg-pinterest border-hover-pinterest color-white color-hover-pinterest',
                        'white'                 => 'border-white bkg-hover-white color-white color-hover-purple fade-location',
                        'gray'                  => 'border-grey bkg-hover-grey color-hover-white',
                        'default'               => ''
                        );

        $class[] = in_array( $btn_class, array_keys( $styles ) ) ? $styles[$btn_class] : $styles['bkg-turquoise'];

        if( in_array( $size, array( 'small', 'medium', 'large', 'xlarge' ) ) ) {
            $class[] = $size;
        }

        $link = fastwp_conrad_utils::url_from_vc( $url );

        $item_markup = '<a href="%s" class="%s" target="%s">%s%s</a>';

        $icon_tag = '';
        if( !empty( $icon ) ) {
            $icon_tag = '<span class="' . esc_html( $icon ) . '"></span>';
        }


        return sprintf( $item_markup, $link['url'], implode( ' ', $class ), $link['target'], $icon_tag, $link['title'] );

    }

static function ConradIconButton($atts, $content){

        extract(shortcode_atts(array(
            'url'          => '',
            'icon_type'    => 'boxed',
            'icon'         => 'icon-heart',
            'size'         => 'small',
            'lightbox_link'=> false,
            'btn_class'    => 'bkg-turquoise',
            'extra_class'  => ''
        ), $atts));

        $class = array();

        // $class[] = $button_id = 'fwp-ibutton-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $icon_types = array( 'circled' => 'icon-circled', 'boxed' => 'rounded icon-boxed' );

        $class[] = esc_html( $icon );
        $class[] = in_array( $icon_type, array_keys( $icon_types ) ) ? $icon_types[$icon_type] : 'rounded icon-boxed';
        $class[] = in_array( $size, array( 'small', 'medium', 'large', 'xlarge' ) ) ? $size : 'small';

        if( (boolean) $lightbox_link ) {
            $class[] = 'lightbox-link';
        }

        $styles = array(
                        'bkg-dribbble'          => 'bkg-dribbble color-white color-dribbble-hover border-hover-dribbble',
                        'bkg-linkedin'          => 'bkg-linkedin color-white color-linkedin-hover border-hover-linkedin',
                        'bkg-pinterest'         => 'bkg-pinterest color-white color-hover-pinterest border-hover-pinterest',
                        'bkg-facebook'          => 'bkg-facebook color-white color-hover-facebook border-hover-facebook',
                        'bkg-twitter'           => 'bkg-twitter color-white color-hover-twitter border-hover-twitter',
                        'bkg-google'            => 'bkg-gplus color-white color-gplus-hover border-hover-gplus',
                        'bkg-flickr'            => 'bkg-flickr color-white color-flickr-hover border-hover-flickr',
                        'bkg-vimeo'             => 'bkg-vimeo color-white color-vimeo-hover border-hover-vimeo',
                        'bkg-youtube'           => 'bkg-youtube color-white color-youtube-hover border-hover-youtube',
                        'bkg-turquoise'         => 'bkg-turquoise color-white color-hover-turquoise border-hover-turquoise',
                        'bkg-hover-charcoal'    => 'color-white color-hover-white bkg-hover-charcoal',
                        'default'               => 'color-grey squared'
                        );

        $class[] = in_array( $btn_class, array_keys( $styles ) ) ? $styles[$btn_class] : $styles['bkg-turquoise'];

        $link = fastwp_conrad_utils::url_from_vc( $url );

        $item_markup = '<a href="%s" class="%s" target="%s">%s</a>';


        return sprintf( $item_markup, $link['url'], implode( ' ', $class ), $link['target'], $link['title'] );

    }

static function ConradBlockquote($atts, $content){

        global $fastwp_conrad_custom_shortcode_css;
        
        extract(shortcode_atts(array(
            'author'       => 'Author',
            'author_image' => '',
            'text'         => 'Cite here ...',
            'type'         => 'border',
            'align'        => 'left',
            'text_color'   => '',
            'extra_class'  => ''
        ), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( in_array( $align, array( 'left', 'center', 'right' ) ) ) {
            $class[] = $align;
        }

        $quote_id = 'fwp_quote_'.rand(10,9999);

        switch( $type ) {
            case 'image':
            $image = wp_get_attachment_image_src( $author_image, 'full' );
            $blockquote = sprintf( '<blockquote id="%s" class="avatar%s">
								<span>
									<img src="%s" alt="" />
								</span>
								<p>%s</p>
								<cite>%s</cite>
							</blockquote>', ( !empty( $text_color ) ? $quote_id : '' ), ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), ( isset( $image[0] ) ? $image[0] : '' ), wp_kses( $text, fastwp_conrad_utils::allowed_tags() ), esc_html( $author ) );
            break;

            case 'simple':
            $blockquote = '<blockquote id="%s" class="large%s">
    						<p>%s
    						    <cite>%s</cite>
    					    </p>
			                </blockquote>';
            $blockquote = sprintf( $blockquote, ( !empty( $text_color ) ? $quote_id : '' ), ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), wp_kses( $text, fastwp_conrad_utils::allowed_tags() ), esc_html( $author ) );
            break;

            case 'border':
            case 'icon':
            default:
            $blockquote = sprintf( '%s
								<p>%s</p>
								<cite>%s</cite>
							</blockquote>', ( $type != 'border' ? '<blockquote %s class="icon%s">
								<span class="icon-quote"></span>' : '<blockquote %s class="border%s">' ), wp_kses( $text, fastwp_conrad_utils::allowed_tags() ), esc_html( $author ) );
            $blockquote = sprintf( $blockquote, ( !empty( $text_color ) ? 'id="'.$quote_id.'"' : '' ), ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ) );
            break;
        }

        $fastwp_conrad_custom_shortcode_css .= sprintf( '#%s > * {color:%s}', $quote_id, esc_attr( $text_color ) );

        return $blockquote;

    }

static function ConradPostsList($atts, $content){

         extract(shortcode_atts(array(
         	'items'			    => 3,
         	'include'			=> '',
         	'exclude'			=> '',
            'extra_class'       => ''
         ), $atts));

        $args = array(
            'numberposts' 		=> (int) $items,
            'posts_per_page' 	=> (int) $items,
            'post_status' 		=> 'publish',
            'post_type'			=> 'post',
            'suppress_filters'	=> '0',
        );

        if( $include != '' ) {
            $args['include'] = $include;
            $args['orderby'] = 'post__in';
        }

        if( $exclude != '' ) {
            $args['exclude'] = $exclude;
        }

        $items = get_posts( $args );

        $list_markup = '';

        if( !empty( $items ) ) {

        $list_markup .= '<ul class="list-group large%s">';

        foreach( $items as $post ) {
            $list_markup .= sprintf( '<li>
                				<a href="%s">%s</a>
                				<span class="post-info"><span class="post-date">%s</span></span>
                			</li>', get_the_permalink( $post->ID ), $post->post_title, date( 'd M Y', strtotime( $post->post_date ) ) );
        }

        $list_markup .= '</ul>';

        }


        return sprintf( $list_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ) );

    }

static function ConradProjectsList($atts, $content){

         extract(shortcode_atts(array(
         	'items'			    => 6,
         	'include'			=> '',
         	'exclude'			=> '',
            'extra_class'       => ''
         ), $atts));

        $args = array(
            'numberposts' 		=> (int) $items,
            'posts_per_page' 	=> (int) $items,
            'post_status' 		=> 'publish',
			'post_type'			=> 'fwp_portfolio',
            'suppress_filters'	=> '0',
        );

        if( $include != '' ) {
            $args['include'] = $include;
            $args['orderby'] = 'post__in';
        }

        if( $exclude != '' ) {
            $args['exclude'] = $exclude;
        }

        $items = get_posts( $args );

        $list_markup = '';

        if( !empty( $items ) ) {

        $list_markup .= '<ul%s>';

        foreach( $items as $item ) {
            $list_markup .= sprintf( '<li>
                				<a href="%s">%s</a>
                			</li>', get_the_permalink( $item->ID ), $item->post_title );
        }

        $list_markup .= '</ul>';

        }


        return sprintf( $list_markup, ( !empty( $extra_class ) ? ' class="' . sanitize_html_class( $extra_class ) . '"' : '' ) );

    }

static function ConradLatestProjects($atts, $content){

         extract(shortcode_atts(array(
            'title'             => 'Latest projects',
         	'items'			    => 5,
         	'include'			=> '',
         	'exclude'			=> '',
            'extra_class'       => ''
         ), $atts));

        $args = array(
            'numberposts' 		=> (int) $items,
            'posts_per_page' 	=> (int) $items,
            'post_status' 		=> 'publish',
			'post_type'			=> 'fwp_portfolio',
            'suppress_filters'	=> '0',
        );

        if( $include != '' ) {
            $args['include'] = $include;
            $args['orderby'] = 'post__in';
        }

        if( $exclude != '' ) {
            $args['exclude'] = $exclude;
        }

        $items = get_posts( $args );

        $list_markup = '';

        $head_markup = '<div class="no-padding bkg-red">
        	<div class="row small no-padding-bottom">
        		<div class="column width-12">
        			<p class="lead pull-left clear-float-on-mobile color-white">' . esc_html( $title ) . '</p>
        			<div class="slider-aux-nav pull-right clear-float-on-mobile mb-mobile-20">
        				<a href="#" class="previous-portfolio-recent-slider color-white color-hover-turquoise"><span class="text-line bkg-white"></span>' . esc_html__( 'Prev', 'conrad' ) . '</a>
        				<a href="#" class="next-portfolio-recent-slider color-white color-hover-turquois"><span class="text-line bkg-white"></span>' . esc_html__( 'Next', 'conrad' ) . '</a>
        			</div>
        		</div>
        	</div>
        </div>';

        if( !empty( $items ) ) {

        $list_markup .= '<div class="portfolio-7 no-padding bkg-charcoal%s">
					<div class="row collapse full-width">
					<div class="column width-12 slider-column no-padding">
					<div id="portfolio-recent-slider-1" class="tm-slider-container portfolio-recent-slider">
					<ul class="tms-slides">';

        foreach( $items as $item ) {
            $image = wp_get_attachment_image_src( get_post_thumbnail_id( $item->ID ), 'full' );
            $list_markup .= sprintf( '<li class="tms-slide">
										<div class="thumbnail overlay-img-slide-down" data-hover-easing="easeInOut" data-hover-speed="700" data-hover-bkg-color="000000" data-hover-bkg-opacity="0.4">
											<a class="overlay-link" href="%s">
												<img data-src="%s" src="images/blank.png" alt=""/>
												<span class="overlay-info">
													<span>
														<span>
															<span class="project-title">%s</span>
														</span>
													</span>
												</span>
											</a>
										</div>
									</li>', get_the_permalink( $item->ID ), $image[0], $item->post_title );
        }

        $list_markup .= '</ul>
		            </div>
					</div>
					</div>
				    </div>';
        }


        return $head_markup . sprintf( $list_markup, ( !empty( $extra_class ) ? ' ' . sanitize_html_class( $extra_class ) : '' ) );

    }

static function ConradPagesSlider($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
         extract(shortcode_atts(array(
         	'include'			=> '',
         	'exclude'			=> '',
            'bg_pos'            => '',
            'bg_vertical_pos'   => '',
            'bg_horizontal_pos' => '',
            'bg_size'           => '',
            'bg_size_percentage'=> '',
            'extra_class'       => ''
         ), $atts));

        $args = array(
            'numberposts' 		=> '-1',
            'posts_per_page' 	=> '-1',
            'post_status' 		=> 'publish',
			'post_type'			=> 'fwp_fs_sections',
            'suppress_filters'	=> '0',
        );

        if( $include != '' ) {
            $args['include'] = $include;
            $args['orderby'] = 'post__in';
        }

        if( $exclude != '' ) {
            $args['exclude'] = $exclude;
        }

        $pages = get_posts( $args );

        $list_markup = '';

        if( !empty( $pages ) ) {

        $class = array();

        $class[] = $section_id = 'fwp-psections-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( $bg_pos == 'custom' ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .background-image{ background-position: %s %s!important; }', $section_id, (int) $bg_vertical_pos . '%', (int) $bg_horizontal_pos . '%' );
        }

        if( $bg_size == 'custom' && !empty( $bg_size_percentage ) ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .background-image{ background-size:%s!important; }', $section_id, (int) $bg_size_percentage. '%' );
        }

        $list_markup .= '<section class="fullscreen-sections-wrapper no-navigation project-5'.( !empty( $class ) ? ' ' . implode( $class ) : '' ).'">';

        $i = 1;
        foreach( $pages as $page ) {

            $image = wp_get_attachment_image_src( get_post_thumbnail_id( $page->ID ), 'full' );
            $bg = get_post_meta( $page->ID, 'background', true );

            $fastwp_conrad_custom_shortcode_css .= sprintf( '.bg-sec-%s {background: %s;}', $page->ID, esc_html( $bg ) );
            $vc_css = get_post_meta($page->ID, '_wpb_shortcodes_custom_css', true );
            if( !empty( $vc_css ) )  {
                $fastwp_conrad_custom_shortcode_css .= esc_html( $vc_css );
            }

            $list_markup .= '<div class="section-block fullscreen-section background-contain background-fixed content-below-on-mobile no-overlay bg-sec-' . $page->ID . '" data-width="1140" data-height="654" data-min-height="300">
						<div class="background-image-wrapper">
							<div class="background-image project-5-1" style="background-image: url(' . $image[0] . ');"></div>
						</div>
						<div class="fullscreen-inner background-on-mobile">
							<div class="row">
                                ' . apply_filters('the_content', $page->post_content) . '
							</div>
						</div>
					</div>';
        $i++;
        }

        $list_markup .= '</section>';

        }

        return $list_markup;

    }

static function ConradLink($atts, $content){

         extract(shortcode_atts(array(
         	'link'          => '',
            'fade_location' => false,
            'lightbox_link' => false,
            'align'         => '',
            'color'         => '',
            'extra_class'   => ''
         ), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( (boolean) $fade_location && !(boolean) $lightbox_link ) {
            $class[] = 'fade-location';
        }

        if( (boolean) $lightbox_link ) {
            $class[] = 'lightbox-link';
        }

        if( in_array( $color, array( 'color-white' ) ) ) {
            $class[] = $color;
            $line_bg = 'bkg-white';
        } else {
            $line_bg = 'bkg-charcoal';
        }

        $url = fastwp_conrad_utils::url_from_vc( $link );

        if( !filter_var( $url['url'], FILTER_VALIDATE_URL ) ) {
            $class[] = 'scroll-link';
        }

        $a_markup = '';
        if( ( $has_align = in_array( $align, array( 'left', 'center', 'right' ) ) ) ) {
            $a_markup .= '<div class="' . $align . '">';
        }

        $a_markup .= '<a class="animated-link%s" href="%s" target="%s"><span class="text-line %s"></span> %s</a>';

        if( $has_align ) {
            $a_markup .= '</div>';
        }

        return sprintf( $a_markup, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), $url['url'], trim( $url['target'] ), $line_bg, $url['title'] );

    }

static function ConradShareCurrentPage($atts, $content){

		extract(shortcode_atts(array(
            'text'          => 'Share',
			'facebook'	    => 1,
			'pinterest'	    => 1,
			'google'		=> 1,
            'twitter'       => 1,
            'targetblank'   => false,
            'separator'     => '<span>/</span>',
            'extra_class'	=> ''
		), $atts));

        $content_markup = '';

        $currentLink = get_permalink();

		$section_markup = '<ul class="social-list list-horizontal share%s">
                            <li class="social-list-label">
                                <span class="stat">
								    <span class="stat-inner">
                                    %s -
                                    </span>
                                </span></li>
                            %s
                        </ul>';

        if( !empty( $alignment ) ) {
            $extra_class .= ' ' . $alignment;
        }

        $target      = (boolean) $targetblank ? '_blank' : '_self';

        foreach( array( 'facebook', 'pinterest', 'google', 'twitter' ) as $social ) {
            if( $social == 'facebook' && (boolean) $facebook ) $content_markup .= sprintf( '<li><a href="https://www.facebook.com/sharer/sharer.php?u=%s" target="%s">Facebook</a>%s</li>', $currentLink, $target, $separator );
            else if( $social == 'twitter' && (boolean) $twitter ) $content_markup .= sprintf( '<li><a href="https://twitter.com/login?redirect_after_login=/home?status=%s" target="%s">Twitter</a>%s</li>', $currentLink, $target, $separator );
            else if( $social == 'google' && (boolean) $google ) $content_markup .= sprintf( '<li><a href="https://plus.google.com/share?url=%s" target="%s">Google+</a>%s</li>', $currentLink, $target, $separator );
            else if( $social == 'pinterest' && (boolean) $pinterest ) $content_markup .= sprintf( '<li><a href="https://www.pinterest.com/join/?next=/pin/create/button/?url=%s" target="%s">Pinterest</a>%s</li>', $currentLink, $target, $separator );
        }

		return sprintf( $section_markup, ( !empty( $extra_class ) ? ' ' . esc_attr( trim( $extra_class ) ) : '' ), esc_html( $text ), $content_markup );

	}

static function ConradTitle($atts, $content){

        extract(shortcode_atts(array(
            'title'         => '',
            'align'         => 'left',
            'align_mobile'  => 'left',
            'tag'           => 'h2',
            'color'         => 'color-charcoal',
            'weight'        => true,
            'xlarge'        => false,
            'margin_top'    => '',
            'margin_bottom' => 'mb-30',
            'extra_class'   => ''
        ), $atts));

        $class = array();

        // $class[] = $button_id = 'fwp-title-' . rand( 1000, 9999 );

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( preg_match( '/mt-(\d{1,3})/', $margin_top ) ) {
            $class[] = $margin_top;
        }

        if( preg_match( '/mb-(\d{1,3})/', $margin_bottom ) ) {
            $class[] = $margin_bottom;
        }

        if( (boolean) $weight ) {
            $class[] = 'weight-bold';
        }

        if( (boolean) $xlarge ) {
            $class[] = 'title-xlarge';
        }

        if( !empty( $color ) ) {
            $class[] = esc_html( $color );
        }

        if( in_array( $align, array( 'left', 'right', 'center' ) ) ) {
            $class[] = $align;
        }

        if( in_array( $align_mobile, array( 'left', 'right', 'center' ) ) ) {
            $class[] = $align_mobile . '-on-mobile';
        }

        if( !in_array( $tag, array( 'h1', 'h2', 'h3', 'h4', 'h5', 'h6' ) ) ) {
            $tag = 'h2';
        }

        return sprintf( '<%s%s>%s</%s>', $tag, ( !empty( $class ) ? ' class="' . implode( ' ', $class ) . '"' : '' ), esc_html( $title ), $tag );

    }

static function ConradMessage($atts, $content){

        extract(shortcode_atts(array(
            'message'         => '',
            'box_style'       => '',
            'dismissable'     => false,
            'extra_class'   => ''
        ), $atts));

        $class = array();

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        $styles = array(
                        'default'       => 'box large bkg-navy color-white rounded',
                        'gray_border'   => 'box large border-grey-light dismissable rounded',
                        'success'       => 'box large success rounded',
                        'info'          => 'box large info rounded',
                        'alert'         => 'box large alert rounded',
                        'warning'       => 'box large warning rounded',

                        );

        if( (boolean) $dismissable ) {
            $class[] = 'dismissable';
        }

        $class[] = in_array( $box_style, array_keys( $styles ) ) ? $styles[$box_style] : $styles['default'];

        return sprintf('<div class="%s">
                                %s
								%s
		                </div>', implode( ' ', $class ), ( (boolean) $dismissable ? '<a href="" class="close icon-cancel"></a>' : '' ), esc_html( $message ) );

    }

static function ConradServices($atts, $content){

        extract(shortcode_atts(array(
            'url'                           => '',
            'text'                          => '',
            'service_number'                => '01',
            'number_color'                  => 'color-charcoal',
            'service_animation'             => 1,
            'service_animation_direction'   => 'left',
            'service_animation_trans'       => '30',
            'service_animation_delay'       => '400',
            'number_animation_direction'    => 'right',
            'number_animation_trans'        => '500',
            'number_animation_delay'        => '400',
            'service_title'                 => 'Title',
            'extra_class'                   => ''
        ), $atts));

        $link = fastwp_conrad_utils::url_from_vc( $url );

        if( (boolean) $service_animation ) {

    switch( $service_animation_direction ) {
        case 'left':
            $service_animation_direction = 'transX:-' . (int) $service_animation_trans . 'px;';
        break;
        case 'top':
            $service_animation_direction = 'transY:-' . (int) $service_animation_trans . 'px;';
        break;
        case 'bottom':
            $service_animation_direction = 'transY:' . (int) $service_animation_trans . 'px;';
        break;
        default:
            $service_animation_direction = 'transX:' . (int) $service_animation_trans . 'px;';
        break;
    }

    switch( $number_animation_direction ) {
        case 'left':
            $number_animation_direction = 'transX:-' . (int) $number_animation_trans . 'px;';
        break;
        case 'top':
            $number_animation_direction = 'transY:-' . (int) $number_animation_trans . 'px;';
        break;
        case 'bottom':
            $number_animation_direction = 'transY:' . (int) $number_animation_trans . 'px;';
        break;
        default:
            $number_animation_direction = 'transX:' . (int) $number_animation_trans . 'px;';
        break;
    }


    if( !empty( $service_animation_delay ) ) {
        $service_animation_delay = 'delay:' . (int) $service_animation_delay . ';';
    }

    if( !empty( $number_animation_delay ) ) {
    $number_animation_delay = 'delay:' . (int) $number_animation_delay . ';';

    }
}


    $final_service_animation = $service_animation_direction.$service_animation_delay;
    $final_number_animation = $number_animation_direction.$number_animation_delay;


    $service_title_markup = ($link['url'] != '' ) ? sprintf( '<a href="%s" target="%s"><h5>%s</h5></a>', esc_url( $link['url'] ), esc_attr( $link['target'] ), esc_html( $link['title'] ) ) : sprintf( '<h5>%s</h5>', esc_html( $link['title'] ) );

    return sprintf( '<div class="row service%s">
                            <div class="column width-2 right left-on-mobile horizon" data-animate-in="%s" data-threshold="1">
                                <span class="text-medium %s">%s<span class="text-line bkg-charcoal"></span></span>
                            </div>
                            <div class="column width-10 horizon" data-animate-in="%s" data-threshold="1">
                                %s
                                <p>%s</p>
                            </div>
                        </div>', ( !empty( $extra_class ) ? ' '.esc_attr( $extra_class ) : '' ), $final_number_animation, esc_attr( $number_color ), esc_html( $service_number ), $final_service_animation, $service_title_markup, wp_kses( $text, fastwp_conrad_utils::allowed_tags() ) );

    }

static function ConradGmap($atts, $content){

        global $fastwp_conrad_custom_js;
		extract(shortcode_atts(array(
			'center'		=> '44.434596, 26.080533',
			'marker_titles'	=> '',
			'marker_addr'	=> '',
			'map_style'		=> 'fastwp',
			'map_zoom'		=> '8',
			'map_izoom'		=> '12',
            'marker_image'  => '',
            'extra_class'   => ''
		), $atts));

		list( $lat, $lng ) = explode( ',', $center );
		$fastwp_conrad_custom_js['gmap_center'] = array( trim( $lat ), trim( $lng ) );
		$titles 	= explode( '|', $marker_titles );
		$addrs 		= explode( '|', $marker_addr );
		$contents 	= explode( '|', $content );
		$markers 	= explode( '|', $marker_image );

        $n_titles = $n_addrs = $n_contents = $n_makers = array();

		for( $i=0; $i < count( $titles ); $i++ ) {
			$n_titles[$i] = esc_html( $titles[$i] );
		}
		for( $i=0; $i < count( $addrs ); $i++ ) {
			$n_addrs[$i] = explode( ',', str_replace( ' ', '', $addrs[$i] ) );
		}
		for( $i=0; $i < count( $contents ); $i++ ) {
			$n_contents[$i] = apply_filters( 'the_content', $contents[$i] );
		}
        for($i=0; $i < count( $markers ); $i++ ) {
            $marker_url = $markers[$i];
            switch( $marker_url ) {
                case 'black':
                case 'default':
                $marker_url = get_template_directory_uri() . '/assets/images/map-marker.png';
                break;
                case 'turquoise':
                $marker_url = get_template_directory_uri() . '/assets/images/map-marker-2.png';
                break;
                default:
                $marker_url = get_template_directory_uri() . '/assets/images/map-marker.png';
                break;
            }
            $n_markers[$i] = esc_url( $marker_url );
        }

		$fastwp_conrad_custom_js['gmap_marker_titles']= $n_titles;
		$fastwp_conrad_custom_js['gmap_marker_addrs'] = $n_addrs;
		$fastwp_conrad_custom_js['gmap_marker_ct'] 	= $n_contents;
		$fastwp_conrad_custom_js['gmap_style'] 		= $map_style;
		$fastwp_conrad_custom_js['gmap_zoom'] 		= $map_zoom;
		$fastwp_conrad_custom_js['gmap_izoom'] 		= $map_izoom;
        $fastwp_conrad_custom_js['gmap_marker']       = $n_markers;

		do_action('fastwp_conrad_enqueue_script', 'custom,http://maps.googleapis.com/maps/api/js?key=' . ( !empty( $fastwp_conrad_data['fwp_gmap_key'] ) ? esc_html( $fastwp_conrad_data['fwp_gmap_key'] ) : '' ) );

		return '<div class="map-container' . ( !empty( $extra_class ) ? ' ' . esc_attr( $extra_class ) : '' ) . '"> <div id="fwp-map"></div></div>';

	}

static function ConradAnimationBox($atts, $content){

		global $fastwp_conrad_custom_shortcode_css;
		extract(shortcode_atts(array(
            'title'         => '',
            'columns'       => 4,
            'offset'        => 0,
            'tag'           => 'h5',
            'title_weight'  => '',
            'text'          => '',
            'title_color'   => '#fff',
            'title_color_mob'=> '#666',
            'text_color'    => '#999999',
            'text_color_mob'=> '#666',
            'background'    => '#232323',
            'background_mob'=> '#fff',
            'border_color'  => '',
            'border_color_mob'=> '',
            'anim_scale'    => 1.3,
            'anim_easing'   => 'easeFastSlow',
            'nopd_mob'      => false,
            'text_align'    => 'left',
            'extra_class'   => ''
		), $atts));

        $class = array();

        $class[] = $ab_id = 'ab_' . rand( 1000, 9999 );

        if( !empty( $offset ) ) {
            $class[] = 'offset-' . (int) $offset;
        }

        if( !empty( $extra_class ) ) {
            $class[] = esc_attr( $extra_class );
        }

        if( in_array( $text_align, array( 'left', 'center', 'right' ) ) ) {
            $class[] = $text_align;
        }

        if( !in_array( $tag, array( 'h1', 'h2', 'h3', 'h4', 'h5', 'h6' ) ) ) {
            $tag = 'h5';
        }

        if( (double) $anim_scale > 2 || (double) $anim_scale < 1 ) {
            $anim_scale = '1.3';
        }

        if( !in_array( $anim_easing, array( 'linear', 'swing', 'easeInOut', 'easeInQuad', 'easeOutQuad', 'easeInOutQuad', 'easeInCubic',
                                            'easeOutCubic', 'easeInOutCubic', 'easeInQuart', 'easeOutQuart', 'oeaseInOutQuart',
                                            'oeaseInQuint', 'oeaseOutQuint', 'easeInExpo', 'easeOutExpo','easeInOutExpo', 'easeInSine',
                                            'easeOutSine', 'easeInOutSine', 'easeInOutQuint', 'easeInCirc', 'easeOutCirc', 'easeInOutCirc',
                                            'easeInOutQuint', 'easeInElastic', 'easeOutElastic', 'easeInOutElastic',
                                            'easeInBack', 'easeOutBack', 'easeInOutBack','easeInOutBounce'
                                        )
                    )
        ) {
            $anim_easing = 'easeFastSlow';
        }

        if( !empty( $title_color ) )$fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .color-white {color: %s!important;}', $ab_id, esc_html( $title_color ) );
        if( !empty( $title_color_mob ) ) $fastwp_conrad_custom_shortcode_css .= sprintf( '@media (max-width: 768px) { .%s .color-white {color: %s!important;} }', $ab_id, esc_html( $title_color_mob ) );
        if( !empty( $text_color ) ) {
            if( strtolower( $text_color ) == '#fff' || strtolower( $text_color ) == '#ffffff' ) {
                $class[] = 'color-white';
            }
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .color-grey-light, .%s .color-grey-light + * {color: %s!important;}', $ab_id, $ab_id, esc_html( $text_color ) );
        }
        if( !empty( $text_color_mob ) ) $fastwp_conrad_custom_shortcode_css .= sprintf( '@media (max-width: 768px) { .%s .color-grey-light, .%s .color-grey-light + * {color: %s!important;} }', $ab_id, $ab_id, esc_html( $text_color_mob ) );
        if( !empty( $background ) ) $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .box {background-color: %s!important;}', $ab_id, esc_html( $background ) );
        if( !empty( $background_mob ) ) $fastwp_conrad_custom_shortcode_css .= sprintf( '@media (max-width: 768px) { .%s .box {background-color: %s!important;} }', $ab_id, esc_html( $background_mob ) );
        if( !empty( $border_color ) ) $fastwp_conrad_custom_shortcode_css .= sprintf( '.%s .box {border-color: %s!important;}', $ab_id, esc_html( $border_color ) );
        if( !empty( $border_color_mob ) ) $fastwp_conrad_custom_shortcode_css .= sprintf( '@media (max-width: 768px) { .%s .box {border-color: %s!important;} }', $ab_id, esc_html( $border_color_mob ) );

        $markup = '<div class="column width-%s horizon%s" data-animate-in="opacity:0;scale:%s;easing:%s;" data-threshold="1">
					<div class="box xlarge no-padding-on-mobile bkg-charcoal%s">
						<%s class="%scolor-white">%s</%s>
						<p class="color-grey-light">%s</p>
					</div>
				</div>';

        $dec_text = '';
        if( function_exists( 'fastwp_conrad_dec' ) ) {
            $dec_text = fastwp_conrad_dec( $text );
        }

		return sprintf( $markup, (int) $columns, ( !empty( $class ) ? ' ' . implode( ' ', $class ) : '' ), $anim_scale, $anim_easing, ( (boolean) $nopd_mob ? ' no-padding-on-mobile' : '' ), $tag, ( $title_weight == 'bold' ? 'weight-bold ' : '' ), esc_html( $title ), $tag, wp_kses( $dec_text, fastwp_conrad_utils::allowed_tags() ) );

    }

}


if(!function_exists('FastWP_Conrad_Shortcode_ConradListContainer')){
     function FastWP_Conrad_Shortcode_ConradListContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradListContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradListItem')){
     function FastWP_Conrad_Shortcode_ConradListItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradListItem($atts, $content);
    }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTabsContainer')){
     function FastWP_Conrad_Shortcode_ConradTabsContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTabsContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTabsAccordionContainer')){
     function FastWP_Conrad_Shortcode_ConradTabsAccordionContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTabsAccordionContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTabsItem')){
     function FastWP_Conrad_Shortcode_ConradTabsItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTabsItem($atts, $content);
    }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradGalleryContainer')){
     function FastWP_Conrad_Shortcode_ConradGalleryContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradGalleryContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradGalleryItem')){
     function FastWP_Conrad_Shortcode_ConradGalleryItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradGalleryItem($atts, $content);
    }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradProgressBarsContainer')){
     function FastWP_Conrad_Shortcode_ConradProgressBarsContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradProgressBarsContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradProgressBarsItem')){
     function FastWP_Conrad_Shortcode_ConradProgressBarsItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradProgressBarsItem($atts, $content);
    }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradPriceTableContainer')){
     function FastWP_Conrad_Shortcode_ConradPriceTableContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradPriceTableContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradPriceTableItem')){
     function FastWP_Conrad_Shortcode_ConradPriceTableItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradPriceTableItem($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradSliderItem')){
     function FastWP_Conrad_Shortcode_ConradSliderItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradSliderItem($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradSliderContainer')){
     function FastWP_Conrad_Shortcode_ConradSliderContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradSliderContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradFeatureBoxesItem')){
     function FastWP_Conrad_Shortcode_ConradFeatureBoxesItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradFeatureBoxesItem($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradFeatureBoxesContainer')){
     function FastWP_Conrad_Shortcode_ConradFeatureBoxesContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradFeatureBoxesContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradAwardsItem')){
     function FastWP_Conrad_Shortcode_ConradAwardsItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradAwardsItem($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradAwardsContainer')){
     function FastWP_Conrad_Shortcode_ConradAwardsContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradAwardsContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradCountersContainer')){
     function FastWP_Conrad_Shortcode_ConradCountersContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradCountersContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradCountersItem')){
     function FastWP_Conrad_Shortcode_ConradCountersItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradCountersItem($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTestimonialsContainer')){
     function FastWP_Conrad_Shortcode_ConradTestimonialsContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTestimonialsContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTestimonialsItem')){
     function FastWP_Conrad_Shortcode_ConradTestimonialsItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTestimonialsItem($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradPortfolio')){
     function FastWP_Conrad_Shortcode_ConradPortfolio($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradPortfolio($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradHeroTitle')){
     function FastWP_Conrad_Shortcode_ConradHeroTitle($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradHeroTitle($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradHeroVideo')){
     function FastWP_Conrad_Shortcode_ConradHeroVideo($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradHeroVideo($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradParallaxHero')){
     function FastWP_Conrad_Shortcode_ConradParallaxHero($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradParallaxHero($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradButton')){
     function FastWP_Conrad_Shortcode_ConradButton($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradButton($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradIconButton')){
     function FastWP_Conrad_Shortcode_ConradIconButton($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradIconButton($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradBlockquote')){
     function FastWP_Conrad_Shortcode_ConradBlockquote($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradBlockquote($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradPostsList')){
     function FastWP_Conrad_Shortcode_ConradPostsList($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradPostsList($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradProjectsList')){
     function FastWP_Conrad_Shortcode_ConradProjectsList($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradProjectsList($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradLatestProjects')){
     function FastWP_Conrad_Shortcode_ConradLatestProjects($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradLatestProjects($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradPagesSlider')){
     function FastWP_Conrad_Shortcode_ConradPagesSlider($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradPagesSlider($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradLink')){
     function FastWP_Conrad_Shortcode_ConradLink($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradLink($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradShareCurrentPage')){
     function FastWP_Conrad_Shortcode_ConradShareCurrentPage($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradShareCurrentPage($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTitle')){
     function FastWP_Conrad_Shortcode_ConradTitle($atts, $content){
         return fastwp_conrad_theme_shortcodes::ConradTitle($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradClientsContainer')){
     function FastWP_Conrad_Shortcode_ConradClientsContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradClientsContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradClientsItem')){
     function FastWP_Conrad_Shortcode_ConradClientsItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradClientsItem($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradTeamContainer')){
     function FastWP_Conrad_Shortcode_ConradTeamContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTeamContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradTeamItem')){
     function FastWP_Conrad_Shortcode_ConradTeamItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTeamItem($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradSocialProfilesContainer')){
     function FastWP_Conrad_Shortcode_ConradSocialProfilesContainer($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradSocialProfilesContainer($atts, $content);
     }
}
if(!function_exists('FastWP_Conrad_Shortcode_ConradSocialProfilesItem')){
     function FastWP_Conrad_Shortcode_ConradSocialProfilesItem($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradSocialProfilesItem($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradMessage')){
     function FastWP_Conrad_Shortcode_ConradMessage($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradMessage($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradLatestPosts')){
     function FastWP_Conrad_Shortcode_ConradLatestPosts($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradLatestPosts($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradGmap')){
     function FastWP_Conrad_Shortcode_ConradGmap($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradGmap($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradServices')){
     function FastWP_Conrad_Shortcode_ConradServices($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradServices($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradThumbnail')){
     function FastWP_Conrad_Shortcode_ConradThumbnail($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradThumbnail($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradTeamSingle')){
     function FastWP_Conrad_Shortcode_ConradTeamSingle($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradTeamSingle($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradMailchimp')){
     function FastWP_Conrad_Shortcode_ConradMailchimp($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradMailchimp($atts, $content);
    }
}

if(!function_exists('FastWP_Conrad_Shortcode_ConradAnimationBox')){
     function FastWP_Conrad_Shortcode_ConradAnimationBox($atts, $content){
        return fastwp_conrad_theme_shortcodes::ConradAnimationBox($atts, $content);
    }
}

global $fastwp_conrad_shortcodes;

$fastwp_conrad_shortcodes = array(
    'fwp_conrad_list_container'             => 'ConradListContainer',
    'fwp_conrad_list_item'                  => 'ConradListItem',
    'fwp_conrad_tabs_accordion_container'   => 'ConradTabsAccordionContainer',
    'fwp_conrad_tabs_container'             => 'ConradTabsContainer',
    'fwp_conrad_tabs_item'                  => 'ConradTabsItem',
    'fwp_conrad_gallery_container'          => 'ConradGalleryContainer',
    'fwp_conrad_gallery_item'               => 'ConradGalleryItem',
    'fwp_conrad_progress_bars_container'    => 'ConradProgressBarsContainer',
    'fwp_conrad_progress_bars_item'         => 'ConradProgressBarsItem',
    'fwp_conrad_price_table_container'      => 'ConradPriceTableContainer',
    'fwp_conrad_price_table_item'           => 'ConradPriceTableItem',
    'fwp_conrad_slider_container'           => 'ConradSliderContainer',
    'fwp_conrad_slider_item'                => 'ConradSliderItem',
    'fwp_conrad_feature_boxes_container'    => 'ConradFeatureBoxesContainer',
    'fwp_conrad_feature_boxes_item'         => 'ConradFeatureBoxesItem',
    'fwp_conrad_awards_container'           => 'ConradAwardsContainer',
    'fwp_conrad_awards_item'                => 'ConradAwardsItem',
    'fwp_conrad_counters_container'         => 'ConradCountersContainer',
    'fwp_conrad_counters_item'              => 'ConradCountersItem',
    'fwp_conrad_testimonials_container'     => 'ConradTestimonialsContainer',
    'fwp_conrad_testimonials_item'          => 'ConradTestimonialsItem',
    'fwp_conrad_team_container'             => 'ConradTeamContainer',
    'fwp_conrad_team_item'                  => 'ConradTeamItem',
    'fwp_conrad_social_profiles_container'  => 'ConradSocialProfilesContainer',
    'fwp_conrad_social_profiles_item'       => 'ConradSocialProfilesItem',
    'fwp_conrad_clients_container'          => 'ConradClientsContainer',
    'fwp_conrad_clients_item'               => 'ConradClientsItem',
    'fwp_conrad_portfolio'                  => 'ConradPortfolio',
    'fwp_conrad_hero_video'                 => 'ConradHeroVideo',
    'fwp_conrad_hero_title'                 => 'ConradHeroTitle',
    'fwp_conrad_parallax_hero'              => 'ConradParallaxHero',
    'fwp_conrad_button'                     => 'ConradButton',
    'fwp_conrad_icon_button'                => 'ConradIconButton',
    'fwp_conrad_blockquote'                 => 'ConradBlockquote',
    'fwp_conrad_posts_list'                 => 'ConradPostsList',
    'fwp_conrad_projects_list'              => 'ConradProjectsList',
    'fwp_conrad_latest_projects'            => 'ConradLatestProjects',
    'fwp_conrad_pages_slider'               => 'ConradPagesSlider',
    'fwp_conrad_link'                       => 'ConradLink',
    'fwp_conrad_shareicons'                 => 'ConradShareCurrentPage',
    'fwp_conrad_title'                      => 'ConradTitle',
    'fwp_conrad_message'                    => 'ConradMessage',
    'fwp-conrad-latest-posts'               => 'ConradLatestPosts',
    'fwp-conrad-map'                        => 'ConradGmap',
    'fwp_conrad_thumbnail'                  => 'ConradThumbnail',
    'fwp_conrad_services'                   => 'ConradServices',
    'fwp_conrad_team_single'                => 'ConradTeamSingle',
    'fwp_conrad_mailchimp'                  => 'ConradMailchimp',
    'fwp_conrad_animationbox'               => 'ConradAnimationBox'
    );