<?php
define('child_theme_url', get_stylesheet_directory_uri());
add_image_size( 'latest-projects', 400, 300, true );

global
	$fastwp_conrad_custom_posts_with_id,
	$fastwp_conrad_custom_taxonomies,
	$fastwp_conrad_data;
	
if(!isset($fastwp_conrad_custom_js)){
	global $fastwp_conrad_custom_js;
	$fastwp_conrad_custom_js = array();
}

global $fastwp_conrad_load_scripts;
$fastwp_conrad_load_scripts = array(
    'custom',
	'wp',
	'jquery.tm.avalanche.min',
	'jquery.tm.counter.min',
	'jquery.tm.equalize.min',
	'jquery.tm.horizon.min',
	'jquery.tm.retinize.min',
	'jquery.tm.snowbridge.min',
	'jquery.tm.summit.min',
	'jquery.tm.swipe.min',
	'template-functions',
	'timber.master.min',
	'timber',
    'http://maps.googleapis.com/maps/api/js?key=' . ( !empty( $fastwp_conrad_data['fwp_gmap_key'] ) ? esc_html( $fastwp_conrad_data['fwp_gmap_key'] ) : '' )
);

global $fastwp_conrad_load_styles;
$fastwp_conrad_load_styles = array(
	'http://fonts.googleapis.com/css?family=Open+Sans:400,700',
	'http://fonts.googleapis.com/css?family=Lato:400,700,900',
    'core.min',
	'wp',
    'skin'
);

global $fastwp_conrad_load_styles_child;
if(!empty($fastwp_conrad_load_styles_child)){
	$fastwp_conrad_load_styles = array_merge($fastwp_conrad_load_styles, $fastwp_conrad_load_styles_child);
}

global $fastwp_conrad_load_scripts_child;
if(!empty($fastwp_conrad_load_scripts_child)){
	$fastwp_conrad_load_scripts = array_merge($fastwp_conrad_load_scripts, $fastwp_conrad_load_scripts_child);
}

$fastpw_conrad_custom_posts = null;

add_action('init', 'fastwp_conrad_theme_init_custom_post_types',1);
function fastwp_conrad_theme_init_custom_post_types(){
	global $fastwp_conrad_data, $fastpw_conrad_custom_posts, $fastwp_conrad_custom_taxonomies ;

$customPortfolioSlug = (isset($fastwp_conrad_data['fastwp_portfolio_slug'])) ? $fastwp_conrad_data['fastwp_portfolio_slug'] : 'project';

global $fastpw_conrad_custom_posts;
$fastpw_conrad_custom_posts = array(
	'fwp_portfolio' => array(
		'name' 				 => esc_html__( 'Portfolio', 'conrad' ),
		'single' 			 => esc_html__( 'Portfolio Item', 'conrad' ),
		'multiple' 			 => esc_html__( 'Portfolio Items', 'conrad' ),
		'settings'	=> array(
			'public'             => true,
			'publicly_queryable' => true,
			'show_ui'            => true,
			'show_in_menu'       => true,
			'query_var'          => true,
			'rewrite'            => array( 'slug' => $customPortfolioSlug ),
			'capability_type'    => 'post',
			'has_archive'        => true,
			'hierarchical'       => false,
			'menu_position'      => null,
			'supports'           => array( 'title', 'excerpt', 'editor', 'author', 'thumbnail')
		)
	),
	'fwp_fs_sections' => array(
		'name' 				 => esc_html__( 'Full Screen Sections', 'conrad' ),
		'single' 			 => esc_html__( 'Full Screen Section', 'conrad' ),
		'multiple' 			 => esc_html__( 'Full Screen Sections', 'conrad' ),
		'settings'	=> array(
			'public'             => true,
			'publicly_queryable' => true,
			'show_ui'            => true,
			'show_in_menu'       => true,
			'query_var'          => true,
			'rewrite'            => array( 'slug' => 'fs_sections' ),
			'capability_type'    => 'post',
			'has_archive'        => true,
			'hierarchical'       => false,
			'menu_position'      => null,
            'menu_icon'         => 'dashicons-screenoptions',
			'supports'           => array( 'title', 'excerpt', 'editor', 'author', 'thumbnail')
		)
	),
);

$fastwp_conrad_custom_taxonomies = array(
	'portfolio-category' => array(
		'post_type' => 'fwp_portfolio',
		'settings' => array(
		    'hierarchical'        => true,
		    'show_ui'             => true,
		    'show_admin_column'   => true,
		    'query_var'           => true,
			'show_in_nav_menus'	  => false,
		    'rewrite'             => array( 'slug' => 'portfolio-category' )
		 )
	 ),
);

do_action('fastwp_conrad_custom_tax_set');

}

global $fastwp_conrad_required_plugins;
$fastwp_conrad_required_plugins = array(
	array(
        'name'				=> esc_html__( 'WPBakery Visual Composer' , 'conrad' ), // The plugin name
        'slug'				=> 'js_composer', // The plugin slug (typically the folder name)
        'source'			=> get_template_directory_uri() . '/fastwp/plugins/js_composer.zip', // The plugin source
        'required'			=> true, // If false, the plugin is only 'recommended' instead of required
        'version'			=> '4.7', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
        'force_activation'	=> false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
        'force_deactivation'=> false, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
        'external_url'		=> '', // If set, overrides default API URL and points to an external URL
    ),
	array(
        'name'			    => esc_html__( 'FastWP Conrad Theme extension', 'conrad' ), // The plugin name
        'slug'			    => 'fastwp-conrad-theme-extension', // The plugin slug (typically the folder name)
        'source'			=> get_template_directory_uri() . '/fastwp/plugins/fastwp-conrad-theme-extension.zip', // The plugin source
        'required'			=> true, // If false, the plugin is only 'recommended' instead of required
        'version'			=> '1.0', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
        'force_activation'	=> false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
        'force_deactivation'=> true, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
        'external_url'		=> '', // If set, overrides default API URL and points to an external URL
    ),
	array(
        'name'			    => esc_html__( 'FastWP Redux extension for Conrad Theme', 'conrad' ), // The plugin name
        'slug'			    => 'fastwp-conrad-redux-extension', // The plugin slug (typically the folder name)
        'source'			=> get_template_directory_uri() . '/fastwp/plugins/fastwp-conrad-redux-extension.zip', // The plugin source
        'required'			=> true, // If false, the plugin is only 'recommended' instead of required
        'version'			=> '1.0', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
        'force_activation'	=> false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
        'force_deactivation'=> true, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
        'external_url'		=> '', // If set, overrides default API URL and points to an external URL
    ),
    array(
        'name'			    => esc_html__( 'Zilla-likes for Conrad Theme', 'conrad' ), // The plugin name
        'slug'			    => 'zilla-likes', // The plugin slug (typically the folder name)
        'source'			=> get_template_directory_uri() . '/fastwp/plugins/zilla-likes.zip', // The plugin source
        'required'			=> true, // If false, the plugin is only 'recommended' instead of required
        'version'			=> '1.0', // E.g. 1.0.0. If set, the active plugin must be this version or higher, otherwise a notice is presented
        'force_activation'	=> false, // If true, plugin is activated upon theme activation and cannot be deactivated until theme switch
        'force_deactivation'=> false, // If true, plugin is deactivated upon theme switch, useful for theme-specific plugins
        'external_url'		=> '', // If set, overrides default API URL and points to an external URL
    ),
    array(
        'name'      		=> esc_html__( 'Contact Form 7' , 'conrad' ),
        'slug'      		=> 'contact-form-7',
        'required'  		=> true,
        'force_activation'  => false,
    ),
    array(
        'name'      		=> esc_html__( 'MailChimp for WordPress', 'conrad'),
        'slug'      		=> 'mailchimp-for-wp',
        'required'  		=> true,
        'force_activation'  => false,
    )
);

$fastwp_conrad_custom_posts_with_id = array( 'fwp_portfolio' => array( 'thumb' ), 'fwp_fs_sections' => array( 'thumb' ) );
$themeUrl 	= defined('child_theme_url') ? child_theme_url : get_template_directory_uri();

require_once get_template_directory() . '/extend/extend.actions.php';
require_once get_template_directory() . '/extend/extend.filters.php';
require_once get_template_directory() . '/extend/extend.shortcodes.basic.php';
require_once get_template_directory() . '/extend/extend.shortcodes.complex.php';
require_once get_template_directory() . '/extend/extend.shortcodes.php';
require_once get_template_directory() . '/extend/extend.visual-composer.php';
require_once get_template_directory() . '/extend/extend.visual-composer.filters.php';
require_once get_template_directory() . '/extend/extend.blog.php';