<?php
class fastwp_conrad_ui {
	static function getMenu($id = 0, $class = 'menu', $echo = true, $skipUl = true){
		$menu_params = array(
			'container'		=> null,
			'menu_class' 	=> $class,
			'menu_id' 		=> $id,
			'echo'			=> $echo,
			'fallback_cb'   => array('Walker_Menu_FastWP','do_default_page_menu'),
	        'walker'  		=> new Walker_Menu_FastWP()
	    );

		$nav_menu_id = apply_filters( 'fastwp_conrad_filter_menu_id', $id );
		if( (int) $nav_menu_id === 0 ){
			$menu_params['theme_location'] = 'primary';
		} else {
			$menu_params['menu'] = $nav_menu_id;
		}

        $menu = wp_nav_menu( $menu_params );
	    if($skipUl){
       		return preg_replace( array( '#^<ul[^>]*>#', '#</ul>$#' ), '', $menu );
	    } else {
	    	return $menu;
	    }
    }

	static function getAffixSize(){
		global $fastwp_conrad_data;
		$c_page_tpl		= ( is_page() || is_single() ) ? basename( get_page_template() ) : '';
		if( $c_page_tpl == 'template-one-page.php' ) {
			return ( isset( $fastwp_conrad_data['fwp_affix_onepage'] ) && is_numeric( $fastwp_conrad_data['fwp_affix_onepage'] ) ) ? $fastwp_conrad_data['fwp_affix_onepage'] : 50;
		} else if( is_front_page() || is_home() ){
			return ( isset( $fastwp_conrad_data['fwp_affix_home'] ) && is_numeric( $fastwp_conrad_data['fwp_affix_home'] ) ) ? $fastwp_conrad_data['fwp_affix_home'] : 0;
		} else if( is_page() ) {
			return ( isset( $fastwp_conrad_data['fwp_affix_page'] ) && is_numeric( $fastwp_conrad_data['fwp_affix_page'] ) ) ? $fastwp_conrad_data['fwp_affix_page'] : 0;
		} else {
			return ( isset( $fastwp_conrad_data['fwp_affix_blog'] ) && is_numeric( $fastwp_conrad_data['fwp_affix_blog'] ) )? $fastwp_conrad_data['fwp_affix_blog'] : 0;
		}
		return 0;
	}

	static function displayMenu($nav_menu_id = 0, $class = 'menu', $echo = true){
		global $post, $fastwp_conrad_data, $fastwp_conrad_custom_shortcode_css;

        $type = isset( $fastwp_conrad_data['fwp_menu_location'] ) ? $fastwp_conrad_data['fwp_menu_location'] : '';
		$_settings_logo = isset( $fastwp_conrad_data['fwp_logo'] ) ? $fastwp_conrad_data['fwp_logo'] : null;
		$_settings_megamenu = isset( $fastwp_conrad_data['fwp_navigation_megamenu'] ) ? $fastwp_conrad_data['fwp_navigation_megamenu'] : 0;
		$_settings_menutype = isset( $fastwp_conrad_data['fwp_navigation_style2'] ) && in_array( $fastwp_conrad_data['fwp_navigation_style2'], array( '0', '1', '2', '3', '4' ) ) ? $fastwp_conrad_data['fwp_navigation_style2'] : 0;
        $_settings_dimensions = isset( $fastwp_conrad_data['fwp_logo_dimensions'] ) ? $fastwp_conrad_data['fwp_logo_dimensions'] : array();
        if( isset( $post->ID ) ) {
            $override_menu = get_post_meta( $post->ID, 'fwp_navigation_style', true );
            if( in_array( $override_menu, array( '0', '1', '2', '3', '4' ) ) ) $_settings_menutype = (int) $override_menu;
        }
        if( is_home() && isset( $fastwp_conrad_data['fwp_blog_navigation'] ) && in_array( $fastwp_conrad_data['fwp_blog_navigation'], array( '0', '1', '2', '3', '4' ) ) ) {
            $_settings_menutype = $fastwp_conrad_data['fwp_blog_navigation'];
        }
        $_settings_menutype = apply_filters( 'fastwp_conrad_filter_menu_class_id', $_settings_menutype );

		if( !empty( $_settings_logo['url'] ) ) {
		    $logo = '<img src="' . esc_url( $_settings_logo['url'] ) . '" alt="" />';
            if( isset( $_settings_dimensions['width'] ) && isset( $_settings_dimensions['height'] ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( '.logo {width: %s!important; height: %s!important}', esc_html( $_settings_dimensions['width'] ), esc_html( $_settings_dimensions['height'] ) );
            }
        } else if( !empty( $fastwp_conrad_data['fwp_text_logo'] ) ) {
            $logo = '<span>' . esc_html( $fastwp_conrad_data['fwp_text_logo'] ) . '</span>';
            $fastwp_conrad_custom_shortcode_css .= '.logo {width: auto!important;}';
		} else {
		    $logo = '<img src="' .get_template_directory_uri() . '/assets/images/logo.png" alt="" />';
        }

        switch( $_settings_menutype ) {
            case 1:
            case 2:
            case 3:
            case 4:
            $menu_class = 'header-' . $_settings_menutype;
            break;
            default:
            $menu_class = 'header-1 header-1-static';
            break;
        }

        $menu_markup = '<header class="%s header header-fixed-on-mobile" data-helper-in-threshold="300" data-helper-out-threshold="500" data-sticky-threshold="300" data-bkg-threshold="300" data-compact-threshold="300">
			<div class="header-inner">
				<div class="row nav-bar reveal-side-navigation">
					<div class="column width-12 nav-bar-inner">
						<div class="logo">
							<a href="%s">%s</a>
						</div>
						<div id="side-nav-show" class="navigation-show hide">
							<a href="%s" onClick="return false;">
								<span class="icon-menu medium"></span>
							</a>
						</div>
						<nav class="navigation">%s</nav>

					</div>
				</div>
			</div>
		</header>';

		$nav_menu_id = apply_filters( 'fastwp_conrad_filter_menu_id', $nav_menu_id );

		if($_settings_megamenu === '1') {
			$MegaMenu = new fastwp_conrad_megamenu();
			$items = $MegaMenu->megamenu(false, $nav_menu_id);
		} else {
			$items =  fastwp_conrad_UI_getMenu( $nav_menu_id, $class, false, false );
		}

        $menu = sprintf( $menu_markup, trim( $menu_class ), esc_url( home_url( '/' ) ), $logo,  esc_url( home_url( '/' ) ), $items );

		if( $echo == false ) return $menu;
		echo $menu;
	}

	static function getPreloaderMarkup(){
		global $fastwp_conrad_data;
        if( !empty( $fastwp_conrad_data['preloader_color'] ) ) {
            global $fastwp_conrad_custom_shortcode_css;
            $fastwp_conrad_custom_shortcode_css .= sprintf( '.container1 > div, .container2 > div, .container3 > div{ background-color: %s; }', esc_html( $fastwp_conrad_data['preloader_color'] ) );
        }
		return '<div class="fakeloader"></div>';
    }

	static function showPreloader($forceVisible = false){
		global $fastwp_conrad_data;
		$forceVisible = (
				$forceVisible == true ||
				(
					isset($fastwp_conrad_data['show_preloader']) &&
					$fastwp_conrad_data['show_preloader'] == 1 &&
					(
						is_front_page() ||
						!isset($fastwp_conrad_data['disable_inner_preloader']) ||
						(isset($fastwp_conrad_data['disable_inner_preloader']) && $fastwp_conrad_data['disable_inner_preloader'] != 1)
					) && (
						fastwp_conrad_UI_getPreloaderStatusForCurrentPage()
					)
				)) ? true : false;

		if( $forceVisible == true ) {
			echo fastwp_conrad_UI_getPreloaderMarkup();
			do_action('fastwp_conrad_after_preloader');
		}
	}

	static function getPreloaderStatusForCurrentPage(){
		return true;
	}

	static function getNavMenuItems($showHome = '0'){
		/* Get data */
		$menu_locations 	= get_nav_menu_locations();
		$menu_query_args 	= array('order'=>'ASC', 'orderby'=>'menu_order', 'post_type'=>'nav_menu_item', 'post_status'=>'publish', 'output_key'=>'menu_order', 'nopaging'=>true, 'update_post_term_cache'=>false );
		$primary_menu		= (isset($menu_locations) && isset($menu_locations['primary']))? $menu_locations['primary'] : 0;

		$primary_menu       = apply_filters('fastwp_conrad_filter_menu_id', $primary_menu);
		$menu_items 		= wp_get_nav_menu_items($primary_menu, $menu_query_args );
		/* Add home button if needed */
		if($showHome === '1'){
			$menu_home_item 		= new stdClass;
			$menu_home_item->title 	= esc_html__('Home' ,'conrad');
			$menu_home_item->url 	= home_url('/');
			$menu_home_item->type 	= null;
			$menu_home_item->object_id 	= null;
			$menu_home_item->menutype 	= null;
			$menu_items 			= array_merge(array($menu_home_item), $menu_items);
		}

		return $menu_items;
	}

	static function displayMultipage($menu_after_first_section=false, $skipMenu = false){
		global $fastwp_conrad_custom_shortcode_css;

		do_action('fastwp_before_generate_sections');
		$menu = ($skipMenu == true)? '' : sprintf('<header>%s</header>',fastwp_conrad_UI_displayMenu('','nav navbar-nav', false));
		$sections_and_pages = fastwp_conrad_UI_getNavMenuItems(0);
		if(!is_array($sections_and_pages)){
			do_action('_fastwp_no_sections_defined');
			return;
		}
		$sections_and_pages = apply_filters('fwp_filter_sections', $sections_and_pages);

		/* Remove from list individual pages */
		$sections = array();
		for($i=0;$i<count($sections_and_pages);$i++){
			$type = get_post_meta( $sections_and_pages[$i]->ID, '_menu_item_menutype', true );
			if(isset($type) && $type != '' && $type != 'page'){
				$sections[] = $sections_and_pages[$i];
			}
		}

		$sections_and_pages = $sections;
		$content = '';
		$demo_found = false;
		for($i=0;$i<count($sections_and_pages);$i++){

			if(($i==0 && $menu_after_first_section==false) || ($i==1 && $menu_after_first_section==true)){
				$content .= $menu;
			}
			if($sections_and_pages[$i]->xfn == 'demo'){
				if(isset($_REQUEST['demo_id'])&&!empty($_REQUEST['demo_id'])){
		    		if($_REQUEST['demo_id'] != $sections_and_pages[$i]->object_id) {
		    			continue;
		    		}
		    	} else {
		    		if($demo_found == false){
		    			$demo_found = true;
		    		} else {
		    			continue;
		    		}
		    	}
	    	}

	    	/* Get Visual Composer meta style just if composer is installed and enabled */
	    	if(defined('WPB_VC_VERSION')){
				$fastwp_conrad_custom_shortcode_css 	.= get_post_meta( $sections_and_pages[$i]->object_id, '_wpb_shortcodes_custom_css', true );
				$fastwp_conrad_custom_shortcode_css 	.= get_post_meta( $sections_and_pages[$i]->object_id, '_wpb_post_custom_css', true );
			}
			/* Get page template name */
			$template 				= get_post_meta( $sections_and_pages[$i]->object_id, '_wp_page_template', true );
			/* Get section page object */
			$section_page 			= get_page($sections_and_pages[$i]->object_id);
			$section_attribute		= '';
			if($template == 'template-page-boxed.php'){
				$content_template 	= '<div class="container"><div class="row">%s</div></div>';
			} else if( $template == 'template-page-landingpage.php' ) {

			$section_attribute 	= ' data-width="2500" data-height="1667"';
			$meta               = fastwp_conrad_meta::get ( $sections_and_pages[$i]->object_id );
			$sectionBgImg 		= isset( $meta['fwp_fs_section_image'] ) ? $meta['fwp_fs_section_image'] : '' ;
			$sectionBgColor 	= isset( $meta['fwp_fs_section_color'] ) ? $meta['fwp_fs_section_color'] : '' ;
			$sectionMbBgColor 	= isset( $meta['fwp_fs_section_mobile_color'] ) ? $meta['fwp_fs_section_mobile_color'] : '' ;
            $final_id           = '';

			if (!empty( $sectionMbBgColor ) ) {
				$inner_id = 'fwp-inner-'.rand(1000,9999);
				$fastwp_conrad_custom_shortcode_css .= sprintf( '@media only screen and (max-width: 768px) {#%s {background-color:%s} }', $inner_id, esc_attr( $sectionMbBgColor ) );
				$final_id = ' id="' . $inner_id .'"';
			}

			if( !empty( $sectionBgImg['url'] ) ) {
				$content_template = '<div class="background-image-wrapper">
										<div class="background-image fs-section-3 background-cover background-fixed" style="background-image: url(\'' . esc_url( $sectionBgImg['url'] ) . '\');"></div>
									</div>
									<div' . $final_id .' class="fullscreen-inner">
										%s
									</div>';
			} else {
				$content_template = '<div' . $final_id .' class="fullscreen-inner">%s</div>';
			}

			} else {
				$content_template 	= '%s';
			}

			$section_ori_class		= ($template === 'template-page-nobg.php')? "clearfix no-bg-color" : "clearfix";
			$section_id 			= FastWP::getMenuSectionId($sections_and_pages[$i]);
			$section_class			= apply_filters('fastwp_conrad_page_class', $section_ori_class, $sections_and_pages[$i]->object_id);
			$section_class 			= apply_filters('fastwp_conrad_page_section_class', $section_class);
			$section_content 		= sprintf($content_template, apply_filters('the_content',$section_page->post_content));
			$section_content		= apply_filters('fastwp_filter_section_content', $section_content, $sections_and_pages[$i]);
			$temp_section 			= '';
			$temp_section 			= sprintf('<section id="%s"%s class="%s">%s</section>', $section_id, $section_attribute, $section_class, $section_content);
			$content 				.= apply_filters('fastwp_filter_section_output', $temp_section);

			if (!empty( $sectionBgColor ) ) {
				$fastwp_conrad_custom_shortcode_css .= sprintf( '#%s {background-color:%s} ', $section_id, esc_attr( $sectionBgColor ) );
			}

			do_action('fastwp_conrad_after_page_content', $sections_and_pages[$i]->object_id, '#'.$section_id);
		}

		do_action('fastwp_sections_generated');

		echo $content;
	}

	static function add_custom_css(){

		global $fastwp_conrad_custom_shortcode_css, $fastwp_conrad_data;

		$fastwp_conrad_custom_shortcode_css .= (isset($fastwp_conrad_data['custom_css']))? $fastwp_conrad_data['custom_css'] : '';

		if(isset($fastwp_conrad_data['nav_bg_color']) && !empty($fastwp_conrad_data['nav_bg_color'])){
			if(is_array($fastwp_conrad_data['nav_bg_color'])){
				$fastwp_conrad_data['nav_bg_color'] = FastWP::hex2rgba($fastwp_conrad_data['nav_bg_color']['color'],$fastwp_conrad_data['nav_bg_color']['alpha']);
			}
			$fastwp_conrad_custom_shortcode_css .= sprintf('nav.navbar.affix { background-color:%s;}', $fastwp_conrad_data['nav_bg_color']);

		}

        if( !empty( $fastwp_conrad_data['body_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['body_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['body_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['body_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['body_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['body_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['body_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['body_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['body_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['body_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['body_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['body_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['body_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'body{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['blog_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['blog_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['blog_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['blog_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['blog_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['blog_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['blog_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['blog_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['blog_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['blog_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['blog_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['blog_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['blog_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'body.blog. body.single{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['h1_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['h1_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['h1_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h1_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['h1_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h1_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['h1_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h1_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['h1_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h1_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['h1_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h1_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['h1_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'h1{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['h2_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['h2_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['h2_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h2_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['h2_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h2_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['h2_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h2_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['h2_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h2_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['h2_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h2_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['h2_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'h2{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['h3_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['h3_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['h3_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h3_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['h3_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h3_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['h3_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h3_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['h3_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h3_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['h3_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h3_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['h3_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'h3{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['h4_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['h4_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['h4_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h4_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['h4_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h4_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['h4_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h4_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['h4_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h4_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['h4_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h4_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['h4_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'h4{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['h5_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['h5_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['h5_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h5_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['h5_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h5_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['h5_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h5_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['h5_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h5_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['h5_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h5_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['h5_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'h5{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }
        if( !empty( $fastwp_conrad_data['h6_font'] ) ) {
            $body_font = array();
            $body_font[] = !empty( $fastwp_conrad_data['h6_font']['font-family'] ) ? 'font-family: ' . $fastwp_conrad_data['h6_font']['font-family'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h6_font']['font-weight'] ) ? 'font-weight: ' . $fastwp_conrad_data['h6_font']['font-weight'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h6_font']['text-align'] ) ? 'text-align: ' . $fastwp_conrad_data['h6_font']['text-align'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h6_font']['font-size'] ) ? 'font-size: ' . $fastwp_conrad_data['h6_font']['font-size'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h6_font']['line-height'] ) ? 'line-height: ' . $fastwp_conrad_data['h6_font']['line-height'] . '!important' : '';
            $body_font[] = !empty( $fastwp_conrad_data['h6_font']['color'] ) ? 'color: ' . $fastwp_conrad_data['h6_font']['color'] . '!important' : '';
            if( !empty( $body_font ) ) {
                $fastwp_conrad_custom_shortcode_css .= sprintf( 'h6{%s}', implode( '; ', array_filter( $body_font ) ) );
            }
        }

		if ( ! empty( $fastwp_conrad_custom_shortcode_css ) ) {
			echo '<style type="text/css" data-type="vc-shortcodes-custom-css">' . $fastwp_conrad_custom_shortcode_css . '</style>';
		}

		$fastwp_conrad_custom_shortcode_css = '';

	}

	static function alert($type, $message) {
		return sprintf('<div class="alert alert-%s" role="alert">%s</div>', $type, $message);
	}
}

class Walker_Menu_FastWP extends Walker {
   var $db_fields = array(
        'parent' => 'menu_item_parent',
        'id'     => 'db_id'
    );

	function display_element ($element, &$children_elements, $max_depth, $depth = 0, $args, &$output) {
        $element->hasChildren = isset($children_elements[$element->ID]) && !empty($children_elements[$element->ID]);
        return parent::display_element($element, $children_elements, $max_depth, $depth, $args, $output);
    }

	function start_lvl( &$output, $depth = 0, $args = array() ) {
		$output .= '<ul class="'.fastwp_conrad_menu_child_class.' menu vertical nested level-'.($depth + 1).'" role="menu">';
	}
	function end_lvl( &$output, $depth = 0, $args = array() ) {
		$output .= '</ul>';
	}

    function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
    	global $fastwp_conrad_demo_found;
    	$c_page_tpl		= (is_page() || is_single())? basename(get_page_template()) : '';
    	if(isset($_REQUEST['demo_id'])&&!empty($_REQUEST['demo_id'])){
    		if($_REQUEST['demo_id'] != $item->object_id && $item->xfn == 'demo') {
    			return;
    		}
    	} else {
    		if($item->xfn == 'demo'){
		    	if($fastwp_conrad_demo_found == false){
		    		$fastwp_conrad_demo_found = true;
		    	} else {
		    		return;
		    	}
	    	}
	    }
    	if( isset( $item->post_status ) && isset( $item->ID ) && !isset( $item->object_id ) ) {
    		$item->object_id= $item->ID;
    		$item->title 	= $item->post_title;
    		$item->url 		= get_permalink($item->ID);
    	}
		$type 				= get_post_meta( $item->ID, '_menu_item_menutype', true );
		$onepage_separator 	= false;
		$onepage_section 	= false;
		if( isset( $type ) && $type != '' && $type != 'page' ) {
			$onepage_section= true;
			if( $type == 'separator' ) {
				$onepage_separator = true;
			}
		}
		if( $onepage_separator === true ) return;

		$class = $liclass = '';

		$class = ( $item->object_id === get_the_ID() ) ? ' active ' : '';
		if( isset( $item->hasChildren ) && $item->hasChildren ) {
			$class .= 'animsition-link ';
		}

        if( !$item->menu_item_parent ) {
            $liclass .= 'navLink ';
        }
        if( $item->current || $item->current_item_parent ) {
            $liclass .= 'current-menu-item';
        }

		$class 	.= (isset($item->classes)) ? implode(' ', $item->classes) :'';
		$class .= $c_page_tpl == 'template-one-page.php' && ( $onepage_section == true && ( !isset( $item->object ) || $item->object != 'custom' ) ) ? ' scroll-link': '';

		$href 	 = ( $onepage_section == true && ( !isset( $item->object ) || $item->object != 'custom' ) ) ? sprintf( '#%s', FastWP::getMenuSectionId( $item ) ) : $item->url;
		if( $href != $item->url ){
			if($c_page_tpl != 'template-one-page.php'){
				$href 	= site_url() . '/' . $href;
			}
		}
		if(substr_count($class,'divider-before')){
        	$output .= '<li class="divider"></li>';
        }

        if( isset( $item->url[0] ) && $item->url[0] == '#' && strlen( $item->url ) > 1 ) {
            if( is_front_page() ) {
                $class .= ' scroll-link';
            } else {
                $href = site_url() . '/' . $item->url;
            }
        }
                 
        $output .= sprintf( "\n<li%s><a href='%s'%s><span>%s</span></a>",
		( !empty( $liclass ) ? ' class="' . trim( $liclass ) . '" ' : '' ),
        $href,
        ' class="' . $class . '" ' .
        ( ( isset( $item->hasChildren ) && $item->hasChildren ) ? ' data-toggle="dropdown"' : '' ) .
        ( ( !empty( $item->target ) ) ? sprintf( ' target="%s" ', $item->target ) : '' ) .
        ( ( isset( $onepage_section ) && $onepage_section == true && ( !isset( $item->hasChildren ) || !$item->hasChildren ) ) ? ' data-scroll="" ' : '' ),
        $item->title
        );

        if(substr_count($class,'divider-after')){
        	$output .= '<li class="divider"></li>';
        }
    }

	public static function do_default_page_menu($args = array()){
		$defaults 	= array('sort_column' => 'menu_order, post_title', 'menu_class' => 'menu', 'echo' => true, 'link_before' => '', 'link_after' => '');
		$args 		= wp_parse_args( $args, $defaults );
		$args 		= apply_filters( 'wp_page_menu_args', $args );
		$menu 		= '';
		$list_args 	= $args;

		if ( !empty( $args['show_home'] ) ) {
			if( true === $args['show_home'] || '1' === $args['show_home'] || 1 === $args['show_home'] )
				$text = esc_html__('Home','conrad');
			else
				$text = $args['show_home'];
			$class = '';
			if( is_front_page() && !is_paged() )
				$class = 'class="current_page_item"';
			$menu .= '<li ' . $class . '><a href="' . esc_url( home_url( '/' ) ) . '">' . $args['link_before'] . $text . $args['link_after'] . '</a></li>';
			// If the front page is a page, add it to the exclude list
			if( get_option('show_on_front') == 'page' ) {
				if( !empty( $list_args['exclude'] ) ) {
					$list_args['exclude'] .= ',';
				} else {
					$list_args['exclude'] = '';
				}
				$list_args['exclude'] .= get_option( 'page_on_front' );
			}
		}

		$list_args['echo'] = false;
		$list_args['title_li'] = '';
		$menu .= str_replace( array( "\r", "\n", "\t" ), '', wp_list_pages( $list_args ) );

		if( $menu ) $menu = '<ul class="nav navbar-nav">' . $menu . '</ul>';

		$menu = '<div class="' . esc_attr($args['menu_class']) . '">' . $menu . "</div>\n";
		$menu = apply_filters( 'wp_page_menu', $menu, $args );
		if( $args['echo'] )
			echo $menu;
		else
			return $menu;
	}
}

