<?php

class fastwp_conrad_utils {

    static function allowed_tags() {
        return array(
        'a' => array(
            'class' => array(),
            'href'  => array(),
            'rel'   => array(),
            'title' => array(),
        ),
        'abbr' => array(
            'title' => array(),
        ),
        'b' => array(),
            'blockquote' => array(
            'cite'  => array(),
        ),
        'cite' => array(
            'title' => array(),
        ),
        'code' => array(),
        'del' => array(
            'datetime' => array(),
            'title' => array(),
        ),
        'dd' => array(),
        'div' => array(
            'class' => array(),
            'title' => array(),
            'style' => array(),
        ),
        'dl' => array(),
        'dt' => array(),
        'em' => array(),
        'h1' => array(
            'class' => array()
        ),
        'h2' => array(
            'class' => array()
        ),
        'h3' => array(
            'class' => array()
        ),
        'h4' => array(
            'class' => array()
        ),
        'h5' => array(
            'class' => array()
        ),
        'h6' => array(
            'class' => array()
        ),
        'i' => array(),
        'img' => array(
            'alt'    => array(),
            'class'  => array(),
            'height' => array(),
            'src'    => array(),
            'width'  => array(),
        ),
        'li' => array(
            'class' => array(),
        ),
        'ol' => array(
            'class' => array(),
        ),
        'p' => array(
            'class' => array(),
        ),
        'q' => array(
            'cite' => array(),
            'title' => array(),
        ),
        'span' => array(
            'class' => array(),
            'title' => array(),
            'style' => array(),
        ),
        'strike' => array(),
        'strong' => array(),
        'ul' => array(
            'class' => array(),
        ),
        );
    }

	static function url_from_vc( $link = '' ){
	    $link = urldecode( $link );
        if( empty( $link ) ) return array( 'title' => '', 'url' => '', 'target' => '' );
        $lnk = array();
        foreach( explode( '|', $link ) as $nlink ) {
            if( !empty( $nlink ) )
            $lnk[strstr($nlink, ':', true)] = substr( strstr($nlink, ':'), 1 );
        }
        return array_merge( array( 'title' => '', 'url' => '', 'target' => '_self' ), $lnk );
    }

    static function hex2rgba($color, $opacity = false) {

    	$default = 'rgb(0,0,0)';

    	if( empty($color ) ) return $default;

        if( $color[0] == '#' ) {
            $color = substr( $color, 1 );
        }

            if ( strlen( $color ) == 6 ) {
                $hex = array( $color[0] . $color[1], $color[2] . $color[3], $color[4] . $color[5] );
            } elseif ( strlen( $color ) == 3 ) {
                $hex = array( $color[0] . $color[0], $color[1] . $color[1], $color[2] . $color[2] );
            } else {
                return $default;
            }

            //Convert hexadec to rgb
            $rgb =  array_map('hexdec', $hex);

            //Check if opacity is set(rgba or rgb)
            if($opacity){
            	if( abs( $opacity ) > 1 ) $opacity = 1.0;
            	$output = 'rgba( ' . implode( ",", $rgb ) . ',' . $opacity . ')';
            } else {
            	$output = 'rgb(' . implode( ",", $rgb ) . ')';
            }

            return $output;
    }

    static function get_template_part( $file = '' ) {
        if( empty( $file ) ) return '';
        ob_start();
        get_template_part( $file );
        $content = ob_get_clean();
        return $content;
    }

    static function is_retina_ready( $image = '', $retina_image = '' ) {
        if( empty( $image ) || empty( $retina_image ) ) {
            return false;
        }
        if( strtok( basename( $retina_image ), '@' ) == strtok( basename( $image ), '.' ) ) {
            return true;
        }
        return false;
    }

    static function get_current_object_id() {
      if( is_single() || is_page() ) {
        return get_the_ID();
      }
      if( is_front_page() && is_home() ) {
        return 0;
      } else if( is_front_page() ) {
        return get_option( 'page_on_front' );
      } else if( is_home() ) {
        return get_option( 'page_for_posts' );
      } else {
        return -1;
      }
    }

}