<?php

do_action('fastwp_conrad_before_header');
get_header();
do_action('fastwp_conrad_before_page_content');

?>

<div class="content clearfix reveal-side-navigation">

<?php

// load all the options
$fastwp_conrad_options = fastwp_conrad_get_option( array( 'fwp_blog_type', 'fwp_blog_title_type', 'fwp_show_blog_herotitle', 'fwp_blog_title_background', 'fwp_blog_title_retina_background', 'fwp_search_blog_title', 'fwp_category_blog_title', 'fwp_tag_blog_title', 'fwp_index_blog_title', 'fwp_blog_sidebar_pos', 'fwp_blog_columns', 'fwp_blog_full_width' ) );

// Switch layouts
if( isset( $_GET['layout_id'] ) ) {
    switch( $_GET['layout_id'] ) {
        case 1:
            $fastwp_conrad_options['fwp_blog_type'] = 'masonry';
            $fastwp_conrad_options['fwp_blog_columns'] = 3;
            $fastwp_conrad_options['fwp_blog_full_width'] = false;
            $fastwp_conrad_options['fwp_blog_sidebar_pos'] = '';
        break;
        case 2:
            $fastwp_conrad_options['fwp_blog_type'] = 'masonry';
            $fastwp_conrad_options['fwp_blog_columns'] = 4;
            $fastwp_conrad_options['fwp_blog_full_width'] = true;
            $fastwp_conrad_options['fwp_blog_sidebar_pos'] = '';
        break;
        case 2:
            $fastwp_conrad_options['fwp_blog_type'] = 'masonry';
            $fastwp_conrad_options['fwp_blog_columns'] = 4;
            $fastwp_conrad_options['fwp_blog_full_width'] = true;
        break;
        case 3:
            $fastwp_conrad_options['fwp_blog_type'] = 'grid';
            $fastwp_conrad_options['fwp_blog_full_width'] = false;
            $fastwp_conrad_options['fwp_blog_sidebar_pos'] = 'right';
        break;
        case 4:
            $fastwp_conrad_options['fwp_blog_type'] = 'grid';
            $fastwp_conrad_options['fwp_blog_full_width'] = false;
            $fastwp_conrad_options['fwp_blog_sidebar_pos'] = '';
        break;
        case 5:
            $fastwp_conrad_options['fwp_blog_type'] = 'masonry';
            $fastwp_conrad_options['fwp_blog_columns'] = 3;
            $fastwp_conrad_options['fwp_blog_full_width'] = false;
            $fastwp_conrad_options['fwp_blog_title_background'] = false;
            $fastwp_conrad_options['fwp_blog_title_type'] = 'color';
            $fastwp_conrad_options['fwp_blog_sidebar_pos'] = '';
        break;
    }
}


// load mandatory scripts for pages
// do_action('fastwp_conrad_enqueue_script', '');

if( !empty( $fastwp_conrad_options['fwp_show_blog_herotitle'] ) ) {

    if( is_search() ) {
        $fastwp_conrad_blog_title = ( !empty( $fastwp_conrad_options['fwp_search_blog_title'] ) ? str_replace( ':TEXT:', get_search_query(), esc_html( $fastwp_conrad_options['fwp_search_blog_title'] ) ) : esc_html__( 'Blog Search', 'conrad' ) );
    } else if( is_category() || is_tax() ) {
        $fastwp_conrad_blog_title = ( !empty( $fastwp_conrad_options['fwp_category_blog_title'] ) ? str_replace( ':NAME:', single_cat_title( '', false ), esc_html( $fastwp_conrad_options['fwp_category_blog_title'] ) ) : esc_html__( 'Blog Category', 'conrad' ) );
    } else if( is_tag() ) {
        $fastwp_conrad_blog_title = ( !empty( $fastwp_conrad_options['fwp_tag_blog_title'] ) ? str_replace( ':NAME:', single_tag_title( '', false ), esc_html( $fastwp_conrad_options['fwp_tag_blog_title'] ) ) : esc_html__( 'Blog Tag', 'conrad' ) );
    } else $fastwp_conrad_blog_title = ( !empty( $fastwp_conrad_options['fwp_index_blog_title'] ) ? esc_html( $fastwp_conrad_options['fwp_index_blog_title'] ) : esc_html__( 'Blog Index', 'conrad' ) );

    $fastwp_conrad_hero_atts = array();
    $fastwp_conrad_hero_atts['title'] = $fastwp_conrad_blog_title;
    if( $fastwp_conrad_options['fwp_blog_title_type'] == 'color' ) {
        echo fastwp_conrad_BlogHeroTitle( $fastwp_conrad_hero_atts );
    } else {
        if( !empty( $fastwp_conrad_options['fwp_blog_title_background']['url'] ) ) {
            $fastwp_conrad_hero_atts['background'] = $fastwp_conrad_options['fwp_blog_title_background']['url'];
        }
        if( !empty( $fastwp_conrad_options['fwp_blog_title_retina_background']['url'] ) ) {
            $fastwp_conrad_hero_atts['retina_bg'] = $fastwp_conrad_options['fwp_blog_title_retina_background']['url'];
        }
        echo fastwp_conrad_BlogHero( $fastwp_conrad_hero_atts );
    }

}

$fastwp_conrad_cclass = array();
if( $fastwp_conrad_options['fwp_blog_type'] == 'masonry' ) {
    $fastwp_conrad_cclass[] = 'blog-masonry';
    if( in_array( $fastwp_conrad_options['fwp_blog_sidebar_pos'], array( 'left', 'right' ) ) || !empty( $fastwp_conrad_options['fwp_blog_full_width'] ) ) {
        $fastwp_conrad_cclass[] = 'full-width';
    }
}

?>

<div class="section-block content-inner row<?php echo ( !empty( $fastwp_conrad_cclass ) ? ' ' . implode( $fastwp_conrad_cclass, ' ' ) : '' ); ?> bkg-white clearfix">

<?php

if ( $fastwp_conrad_options['fwp_blog_sidebar_pos'] == 'left' ) {
    echo '<div id="sidebar" class="column sidebar width-3">';
        get_sidebar();
    echo '</div>';
}

?>

<div class="column width-<?php echo ( in_array( $fastwp_conrad_options['fwp_blog_sidebar_pos'], array( 'left', 'right' ) ) ? 9 : 12 ); ?>">

<?php if( $fastwp_conrad_options['fwp_blog_type'] == 'masonry' && have_posts() ) { ?>

<div class="row content-grid-<?php echo ( in_array( $fastwp_conrad_options['fwp_blog_columns'], array( '3', '4' ) ) ? $fastwp_conrad_options['fwp_blog_columns'] : 3 ); ?> masonry-grid clearfix">
    <?php fastwp_conrad_posts( 'blog-columns' ); ?>
</div>

<?php } else {

    fastwp_conrad_posts( 'blog-wide' );

} ?>

</div>

<?php

if ( $fastwp_conrad_options['fwp_blog_sidebar_pos'] == 'right' ) {
    echo '<div id="sidebar" class="column sidebar width-3">';
        get_sidebar();
    echo '</div>';
}

?>

</div>

<?php

do_action('fastwp_conrad_before_paging_nav');
    echo fastwp_conrad_blog_pagination();
do_action('fastwp_conrad_after_paging_nav');

?>

</div>

<?php

get_footer();