<?php

/**
The template for displaying all single posts
**/

get_header();

// load mandatory scripts for pages
// do_action('fastwp_conrad_enqueue_script', '');

// future use function
do_action('fastwp_conrad_before_page_content');

// load all the options
$fastwp_conrad_options = fastwp_conrad_get_option( array( 'fwp_blog_category_meta', 'fwp_blog_date_meta', 'fwp_blog_comments_meta', 'fwp_blog_name_meta', 'fwp_blog_sidebar_pos', 'fwp_blog_author_meta' ) );

// Start the loop.
while ( have_posts() ) :
the_post();

?>

<div class="content clearfix reveal-side-navigation">

<?php

$fastwp_conrad_hero_atts = array();
$fastwp_conrad_hero_atts['title'] = get_the_title();
$fastwp_conrad_hero_atts['info'] = get_the_date();

if( !empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) {
    $fastwp_conrad_hero_atts['info'] = get_the_time( get_option( 'date_format' ) );
}

$fastwp_conrad_hero_img = get_post_meta( get_the_ID(), 'hero_image', true );

if( empty( $fastwp_conrad_hero_img['url'] ) && has_post_thumbnail() ) {
    $featured_image = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'full' );
    $fastwp_conrad_hero_atts['background'] = $featured_image[0];
} else if( !empty( $fastwp_conrad_hero_img['url'] ) ) $fastwp_conrad_hero_atts['background'] =  $fastwp_conrad_hero_img['url'];

echo fastwp_conrad_BlogHero( $fastwp_conrad_hero_atts );

?>

<div id="post-<?php the_ID(); ?>" <?php post_class( 'section-block row' ); ?>>

    <?php

        if ( $fastwp_conrad_options['fwp_blog_sidebar_pos'] == 'left' ) {
            echo '<div id="sidebar" class="column sidebar width-3">';
                get_sidebar();
            echo '</div>';
        }

    ?>

	<div class="column width-9 content-inner blog-single-post">
		<article class="post">
			<div class="post-media">
                <?php
                $fastwp_conrad_post_format = get_post_format();
                if( !empty( $fastwp_conrad_post_format ) && $fastwp_conrad_post_format != 'image' ) {
                    get_template_part( 'extend-helpers/content', $fastwp_conrad_post_format );
                } ?>
			</div>
			<div class="post-info post-info-aside">
				<div class="post-info-inner">
                    <?php if( empty( $fastwp_conrad_options['fwp_blog_name_meta'] ) ) { ?>
					<span class="post-autor"><?php the_author_posts_link(); ?></span>
                    <?php }
                    if( empty( $fastwp_conrad_options['fwp_blog_comments_meta'] ) ) {
                    $fastwp_conrad_comments = wp_count_comments( get_the_ID() )->approved; ?>
                    <span class="post-comment"><a href="#comments" data-offset="-60" class="scroll-link"><?php echo ( $fastwp_conrad_comments > 0 ? sprintf( esc_html__( '%s Comments', 'conrad' ), $fastwp_conrad_comments ) : esc_html__( 'No Comments', 'conrad' ) ); ?></a></span>
                    <?php } ?>
				</div>
                <?php if( function_exists( 'zilla_likes' ) ) echo zilla_likes( '%likes', '', '<div class="post-love">', '</div>' ); ?>
			</div>
			<div class="post-content">
				<div class="post-info">
                    <?php if( empty( $fastwp_conrad_options['fwp_blog_date_meta'] ) ) { ?>
					<span class="post-date hide show-on-mobile"><?php echo get_the_time( get_option( 'date_format' ) ); ?> /</span>
                    <?php }
                    if( empty( $fastwp_conrad_options['fwp_blog_name_meta'] ) ) { ?>
                    <span class="post-autor hide show-on-mobile"><?php the_author_posts_link(); ?></span>
                    <?php }
                    if( empty( $fastwp_conrad_options['fwp_blog_comments_meta'] ) ) { ?>
                    <span class="post-comment hide show-on-mobile">/ <a href="#comments"><?php echo ( $fastwp_conrad_comments > 0 ? sprintf( esc_html__( '%s Comments', 'conrad' ), $fastwp_conrad_comments ) : esc_html__( 'No Comments', 'conrad' ) ); ?></a></span>
                    <?php } ?>
                    <span class="post-love hide show-on-mobile"><?php if( function_exists( 'zilla_likes' ) ) echo '/ ' . zilla_likes( '%likes', '', '<div class="post-love">', '</div>' ); ?></span>
				</div>

                <?php the_content();
                the_tags( esc_html( 'Tags: ', 'conrad' ), ', ', '' );
                wp_link_pages(); ?>

				<ul class="social-list list-horizontal share">
					<li class="social-list-label">
						Share:
					</li>
					<li><a onclick="window.open('https://www.facebook.com/sharer/sharer.php?u=' + location.href, 'sharer', 'width=626,height=436');" href="javascript: void(0)" title="<?php esc_html_e( 'Share on Facebook', 'conrad' ); ?>"><?php echo esc_html_e( 'Facebook', 'conrad' ); ?></a>/</li>
					<li><a onclick="popUp=window.open('https://twitter.com/share?url=' + location.href, 'popupwindow', 'scrollbars=yes,width=800,height=400');popUp.focus();return false;" href="javascript: void(0)" title="<?php esc_html_e( 'Share on Twitter', 'conrad' ); ?>"><?php echo esc_html_e( 'Twitter', 'conrad' ); ?></a>/</li>
					<li><a onclick="popUp=window.open('https://plus.google.com/share?url=' + location.href, 'popupwindow', 'scrollbars=yes,width=800,height=400');popUp.focus();return false;" href="javascript: void(0)" title="<?php esc_html_e( 'Share on Google+', 'conrad' ); ?>"><?php echo esc_html_e( 'Google+', 'conrad' ); ?></a></li>
				</ul>
			</div>
		</article>

        <?php if( empty( $fastwp_conrad_options['fwp_blog_author_meta'] ) ) {
        $author_description = get_the_author_meta( 'description' );

        if( !empty( $author_description ) ) { ?>

		<div id="author" class="post-author">
			<div class="post-author-aside">
				<span class="author-title"><?php esc_html_e( 'Author', 'conrad' ); ?></span>
				<a href="#"><span class="icon-paper"></span><?php echo count_user_posts( get_the_author_meta( 'ID' ) ); ?> <?php esc_html_e( 'Articles', 'conrad' ); ?></a>
			</div>
			<article class="author-bio">
				<div class="author-avatar">
					<?php echo get_avatar( get_the_author_meta( 'ID' ) ); ?>
				</div>
				<div class="author-content">
					<div class="row">
						<div class="column width-12">
							<h5 class="name"><?php echo get_the_author_meta( 'user_firstname' ) . ' ' . get_the_author_meta( 'user_lastname' ); ?></h5>
							<p><?php echo $author_description; ?></p>
						</div>
					</div>
				</div>
			</article>
		</div>

        <?php }
        }

    comments_template(); ?>

	</div>

    <?php

    if ( $fastwp_conrad_options['fwp_blog_sidebar_pos'] == 'right' ) {
        echo '<div id="sidebar" class="column sidebar width-3">';
            get_sidebar();
        echo '</div>';
    }

    ?>

</div>

<?php fastwp_conrad_post_navigation(); ?>

</div>

<?php

endwhile;

do_action('fastwp_conrad_after_page_content');
get_footer();