<?php

/* Template Name: Full Width Hero Image */

global $post;

get_header();
the_post();

do_action('fastwp_conrad_before_page_content');

$fastwp_conrad_meta = fastwp_conrad_meta::get ( get_the_ID () );

$fastwp_conrad_image= wp_get_attachment_image_src( get_post_thumbnail_id(get_the_ID()), 'full' );

$fastwp_conrad_setting_bgcolor 	= isset( $fastwp_conrad_meta["page_hero_bgcolor"] ) ? $fastwp_conrad_meta["page_hero_bgcolor"] : '';
$fastwp_conrad_setting_color 	= isset( $fastwp_conrad_meta["page_hero_txtcolor"] ) ? $fastwp_conrad_meta["page_hero_txtcolor"] : '';
$fastwp_conrad_setting_title 	= isset( $fastwp_conrad_meta["page_hero_title"] ) ? $fastwp_conrad_meta["page_hero_title"] : '';
$fastwp_conrad_setting_type 	= isset( $fastwp_conrad_meta["page_hero_height"] ) ? $fastwp_conrad_meta["page_hero_height"] : '';

$fastwp_conrad_setting_bgcolor = ( $fastwp_conrad_setting_bgcolor != "" ) ? $fastwp_conrad_setting_bgcolor : '#e62739';
$fastwp_conrad_setting_color = ( $fastwp_conrad_setting_color != "" ) ? $fastwp_conrad_setting_color : '#e62739';

$fastwp_conrad_bgcolor= !empty( $fastwp_conrad_image[0] ) ? '' : sprintf( 'background-color: %s;', $fastwp_conrad_setting_bgcolor );
$fastwp_conrad_color = !empty( $fastwp_conrad_image[0] ) ? '' : sprintf('color: %s;', $fastwp_conrad_setting_color);
$fastwp_conrad_image = !empty( $fastwp_conrad_image[0] ) ? $fastwp_conrad_image[0] : '';

$fastwp_conrad_retina_attr = '';
if( isset( $fastwp_conrad_meta['page_hero_retina_image']['url'] ) && fastwp_conrad_utils::is_retina_ready( $fastwp_conrad_image, $fastwp_conrad_meta['page_hero_retina_image']['url'] ) ) {
    $fastwp_conrad_retina_attr = ' data-retina';
}

$fastwp_conrad_portfolioTitle = ( $fastwp_conrad_setting_title != '' ) ? $fastwp_conrad_setting_title : $post->post_title;

switch ( $fastwp_conrad_setting_type ) {
	case '1':
		$fastwp_conrad_class = "intro-title-1";
	break;
	default:
		$fastwp_conrad_class = "intro-title-2";
	break;
}

if( $fastwp_conrad_image != '' ) {
	$fastwp_conrad_class = ' featured-media ';
}

?>

<section id="page-content" class="content reveal-side-navigation">

<!-- Fullscreen Slider Section -->
<section class="section-block <?php echo esc_html( $fastwp_conrad_class ); ?>" style="<?php echo esc_html( $fastwp_conrad_bgcolor ); ?>">
    <?php if( $fastwp_conrad_image != '' ) { ?>
    <div class="tm-slider-container full-width-slider">
    <ul class="tms-slides">
        <li class="tms-slide" data-image data-force-fit>
            <div class="tms-content">
            	<div class="tms-content-inner">
            		<div class="row">
            			<div class="column width-12 left">
            				<h1 class="tms-caption title-xlarge color-white weight-bold lspacing-medium no-margins" data-animate-in="opacity:0;transX:40px;duration:600ms;delay:0;easing:easeFastSlow;" style="<?php echo esc_html( $fastwp_conrad_color ); ?>">
            					<?php echo esc_html( $fastwp_conrad_portfolioTitle ); ?>
            				</h1>
            			</div>
            		</div>
            	</div>
            </div>
            <img data-src="<?php echo esc_url( $fastwp_conrad_image ); ?>"<?php echo $fastwp_conrad_retina_attr; ?> src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7" alt=""/>
        </li>
    </ul>
	</div><?php } else { ?>
	<div class="row">
		<div class="column width-12">
			<div class="title-container">
				<div class="title-container-inner">
					<h1 class="title-xlarge weight-bold horizon" data-animate-in="opacity:0;transX:40px;duration:600ms;delay:0;easing:easeFastSlow;" style="<?php echo esc_html( $fastwp_conrad_color ); ?>">
						<?php echo esc_html( $fastwp_conrad_portfolioTitle ); ?>
					</h1>
				</div>
			</div>
		</div>
	</div>
	<?php } ?>
</section>
<!-- Fullscreen Slider Section End -->
    <?php
    $fastwp_conrad_temp_content = get_the_content();
    $fastwp_conrad_temp_content = apply_filters( 'the_content', $fastwp_conrad_temp_content );
    echo apply_filters( 'fastwp_filter_section_content', $fastwp_conrad_temp_content, $post );

    wp_link_pages();
    ?>
</section>

<?php

do_action('fastwp_conrad_after_page_content');

get_footer();