<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

/**
 * Shortcode attributes
 * @var $atts
 * @var $el_class
 * @var $width
 * @var $css
 * @var $offset
 * @var $content - shortcode content
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_Column_Inner
 */
$el_class = $width = $css = $offset = $ic_align = $ic_align_mobile = $ic_margin_bottom = $ic_animation = $ic_animation_direction = $ic_animation_trans = $ic_animation_delay = $ic_animation_duration = $ic_eq_height = '';
$output = '';
$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

$width = wpb_translateColumnWidthToSpan( $width );
$width = vc_column_offset_class_merge( $offset, $width );

$css_classes = array(
	$this->getExtraClass( $el_class ),
	'wpb_column',
	'vc_column_container',
	$width,
);

if (vc_shortcode_custom_css_has_property( $css, array('border', 'background') )) {
	$css_classes[]='vc_col-has-fill';
}

$wrapper_attributes = array();

/** FASTWP - CUSTOM OPTIONS **/

if( !empty( $ic_align ) ) {
    if( in_array( $ic_align, array( 'left', 'right', 'center' ) ) )
    $css_classes[] = $ic_align;
}

if( !empty( $ic_align_mobile ) ) {
    if( in_array( $ic_align_mobile, array( 'left', 'right', 'center' ) ) )
    $css_classes[] = $ic_align_mobile . '-on-mobile';
}

if( ! (boolean) $ic_margin_bottom ) {
    $css_classes[] = 'fwp-nmb';
}

if( !empty( $ic_animation ) ) {
    $css_classes[] = 'call-to-action-2';
}

/** **/

$css_class = preg_replace( '/\s+/', ' ', apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts ) );
$wrapper_attributes[] = 'class="' . esc_attr( trim( $css_class ) ) . '"';

$output .= '<div ' . implode( ' ', $wrapper_attributes ) . '>';
$output .= '<div class="vc_column-inner ' . esc_attr( trim( vc_shortcode_custom_css_class( $css ) ) ) . '">';
$output .= '<div class="wpb_wrapper">';

/** FASTWP **/

if( (boolean) $ic_animation ) {

    switch( $ic_animation_direction ) {
        case 'left':
            $anim_direction = 'transX:-' . (int) $ic_animation_trans . 'px;';
        break;
        case 'top':
            $anim_direction = 'transY:-' . (int) $ic_animation_trans . 'px;';
        break;
        case 'bottom':
            $anim_direction = 'transY:' . (int) $ic_animation_trans . 'px;';
        break;
        case 'fade_in':
            $animation = 'opacity:0;scale:1.3;easing:easeFastSlow;';
        break;
        default:
            $anim_direction = 'transX:' . (int) $ic_animation_trans . 'px;';
        break;
    }

    if( !isset( $animation ) && !empty( $ic_animation_delay ) ) {
        $anim_direction .= 'delay:' . (int) $ic_animation_delay . ';';
    }

    if( !isset( $animation ) && !empty( $ic_animation_duration ) ) {
        $anim_direction .= 'duration:' . (int) $ic_animation_duration . ';';
    }

    $output .= '<div class="call-to-action-content">
	<div class="call-to-action-content-inner">
	<div class="horizon" data-animate-in="' . ( isset( $animation ) ? $animation : $anim_direction ) . '">';
}

if( (boolean) $ic_eq_height ) {
    $output .= '<div class="hero-content split-hero-content">
	<div class="hero-content-inner">';
}

/** **/

$output .= wpb_js_remove_wpautop( $content );

/** FASTWP **/

if( (boolean) $ic_eq_height ) {
    $output .= '</div>
	</div>';
}

if( (boolean) $ic_animation ) {
    $output .= '</div>
    </div>
    </div>';
}

/** **/

$output .= '</div>';
$output .= '</div>';
$output .= '</div>';

echo $output;
