<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

/**
 * Shortcode attributes
 * @var $atts
 * @var $el_class
 * @var $full_width
 * @var $full_height
 * @var $content_placement
 * @var $parallax
 * @var $parallax_image
 * @var $css
 * @var $el_id
 * @var $video_bg
 * @var $video_bg_url
 * @var $video_bg_parallax
 * @var $content - shortcode content
 * Shortcode class
 * @var $this WPBakeryShortCode_VC_Row
 */
$el_class = $full_height = 	$custom_class = $full_width = $content_placement = $parallax = $parallax_image = $css = $el_id = $video_bg = $video_bg_url = $video_bg_parallax = $extra_classes = $r_width_type = $r_padding = $r_bg_color = $half_section = $hs_image = $hs_image_pos = $hs_c_height = $hs_c_height_mob = $hs_c_height_rem = $r_parallax = $r_parallax_image = $r_overlay = $r_overlay_color = $r_overlay_opacity = $r_overlay_pos = $hs_image_fixed = '';
$output = $after_output = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

wp_enqueue_script( 'wpb_composer_front_js' );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	'vc_row',
	'wpb_row', //deprecated
	'vc_row-fluid',
	$el_class,
	vc_shortcode_custom_css_class( $css ),
);

$wrapper_attributes = array();
// build attributes for wrapper
if ( ! empty( $el_id ) ) {
	$wrapper_attributes[] = 'id="' . esc_attr( $el_id ) . '"';
}
if ( ! empty( $full_width ) ) {
	$wrapper_attributes[] = 'data-vc-full-width="true"';
	$wrapper_attributes[] = 'data-vc-full-width-init="false"';
	if ( 'stretch_row_content' === $full_width ) {
		$wrapper_attributes[] = 'data-vc-stretch-content="true"';
	} elseif ( 'stretch_row_content_no_spaces' === $full_width ) {
		$wrapper_attributes[] = 'data-vc-stretch-content="true"';
		$css_classes[] = 'vc_row-no-padding';
	}
	$after_output .= '<div class="vc_row-full-width"></div>';
}

if ( ! empty( $full_height ) ) {
	$css_classes[] = ' vc_row-o-full-height';
	if ( ! empty( $content_placement ) ) {
		$css_classes[] = ' vc_row-o-content-' . $content_placement;
	}
}

$has_video_bg = ( ! empty( $video_bg ) && ! empty( $video_bg_url ) && vc_extract_youtube_id( $video_bg_url ) );

if ( $has_video_bg ) {
	$parallax = $video_bg_parallax;
	$parallax_image = $video_bg_url;
	$css_classes[] = ' vc_video-bg-container';
	wp_enqueue_script( 'vc_youtube_iframe_api_js' );
}

if ( ! empty( $parallax ) ) {
	wp_enqueue_script( 'vc_jquery_skrollr_js' );
	$wrapper_attributes[] = 'data-vc-parallax="1.5"'; // parallax speed
	$css_classes[] = 'vc_general vc_parallax vc_parallax-' . $parallax;
	if ( false !== strpos( $parallax, 'fade' ) ) {
		$css_classes[] = 'js-vc_parallax-o-fade';
		$wrapper_attributes[] = 'data-vc-parallax-o-fade="on"';
	} elseif ( false !== strpos( $parallax, 'fixed' ) ) {
		$css_classes[] = 'js-vc_parallax-o-fixed';
	}
}

if ( ! empty( $parallax_image ) ) {
	if ( $has_video_bg ) {
		$parallax_image_src = $parallax_image;
	} else {
		$parallax_image_id = preg_replace( '/[^\d]/', '', $parallax_image );
		$parallax_image_src = wp_get_attachment_image_src( $parallax_image_id, 'full' );
		if ( ! empty( $parallax_image_src[0] ) ) {
			$parallax_image_src = $parallax_image_src[0];
		}
	}
	$wrapper_attributes[] = 'data-vc-parallax-image="' . esc_attr( $parallax_image_src ) . '"';
}

if ( ! $parallax && $has_video_bg ) {
	$wrapper_attributes[] = 'data-vc-video-bg="' . esc_attr( $video_bg_url ) . '"';
}

/** FASTWP - CUSTOM OPTIONS **/

if ( !empty( $r_padding ) && $r_padding != 'default' ) {
    $css_classes[] = 'section-block';
    if( $r_padding == 'rc' ) {
        $css_classes[] = 'replicable-content';
    } else if( $r_padding == 'sps' ) {
        $css_classes[] = 'section-small-padding';
    }
}

if( !empty( $r_bg_color ) ) {
    if( in_array( $r_bg_color, array( 'bkg-red', 'bkg-purple', 'bkg-grey-ultralight', 'bkg-charcoal' ) ) ) {
        $css_classes[] = $r_bg_color;
    }
}

if( (boolean) $half_section ) {
    $css_classes[] = 'fwp-hero' . ( $hs_image_pos == 'full' ? ' fwp-hero-full' : '' );
}

/** **/

$css_class = preg_replace( '/\s+/', ' ', apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts ) );
$wrapper_attributes[] = 'class="' . esc_attr( trim( $css_class ) ) . '"';

$output .= '<div '  . implode( ' ', $wrapper_attributes ) . '>';

/** FASTWP **/

if( (boolean) $r_parallax && !empty( $r_parallax_image ) ) {
    $image = wp_get_attachment_image_src( $r_parallax_image, 'full' );
    $output .= sprintf( '<div class="parallax fixed-height" data-src="%s">', $image[0] );
}

if( $r_width_type == 'boxed' ) {
    $output .= '<div class="row">';
}

if( (boolean) $half_section ) {
    $output .= '<div class="section-block ' . ( $hs_image_pos == 'left' ? 'right' : 'left' ) . ' hero-5 color-white ' . ( $hsID = 'half_section' . rand( 1000, 9999 ) ) . '">
    <div class="row">';

    global $fastwp_conrad_custom_shortcode_css;

    if( !empty( $hs_image ) ) {
        $image = wp_get_attachment_image_src( $hs_image, 'full' );
        $fastwp_conrad_custom_shortcode_css .= sprintf( ".%s .row::after{ background-image: url('%s');%s%s }", $hsID, $image[0], ( $hs_image_pos == 'full' ? ' width: 100%;' : '' ), ( (boolean) $hs_image_fixed ? ' background-attachment: fixed;' : '' ) );
	}

    if( (boolean) $r_overlay ) {
        $fastwp_conrad_custom_shortcode_css .= sprintf( ".%s .row:before{ background-color: %s; z-index: 1;%s }", $hsID, fastwp_conrad_utils::hex2rgba( $r_overlay_color, $r_overlay_opacity ), ( $r_overlay_pos == 'full' ? ' width: 100%; left: 0;' : ( $r_overlay_pos == 'right' ? ' right: 0;' : 'left: 0;' ) ) );
    }

    if( $hs_c_height == 'custom' ) {
        $fastwp_conrad_custom_shortcode_css .= sprintf( ".%s { height: %srem; }", $hsID, (int) $hs_c_height_rem );
        if( !empty( $hs_c_height_mob ) ) {
            $fastwp_conrad_custom_shortcode_css .= sprintf( "@media only screen and (max-width: 768px) { .%s > .row::after { min-height: %s; } }", $hsID, ( ( is_numeric( $hs_c_height_mob ) ? (int) $hs_c_height_mob . 'rem' : esc_html( $hs_c_height_mob ) ) ) );
        }
    }
}

$output .= wpb_js_remove_wpautop( $content );

/** FASTWP **/

if( (boolean) $half_section ) {
    $output .= '</div>
    </div>';
}

if( (boolean) $r_parallax && !empty( $r_parallax_image ) ) {
    $output .= '</div>';
}

if( $r_width_type == 'boxed' ) {
    $output .= '</div>';
}

/** **/

$output .= '</div>';

$output .= $after_output;

echo $output;