<?php

/*
Plugin Name: FastWP Conrad Theme extension
Plugin URI: http://themeforest.net/user/FastWP
Description: FastWP Theme extension for FastWP themes. This plugin is required to initialize custom posts, custom taxonomies and theme shortcodes
Author: FastWP
Version: 1.0
Author URI: http://fastwp.net
*/

if(!class_exists('FastWP_Conrad_Functions_Plugin')){
	class FastWP_Conrad_Functions_Plugin {

		/**
		Register custom defined post types.
		**/

		static function register_custom_posts(){
			global $fastpw_conrad_custom_posts;
			if(!isset($fastpw_conrad_custom_posts) || !is_array($fastpw_conrad_custom_posts)) return;
			foreach($fastpw_conrad_custom_posts as $post_type=>$details){
				$args 			= $details['settings'];
				$args['labels'] = array(
					'menu_name' 	=> $details['name'],
					'name'         	=> $details['multiple'],
					'singular_name'	=> $details['single'],
					);

				register_post_type( $post_type, $args );
			}
		}

		/**
		Register custom defined taxonomies.
		**/

		static function register_custom_taxonomy(){
			global $fastwp_conrad_custom_taxonomies;
			
			if(!isset($fastwp_conrad_custom_taxonomies) || !is_array($fastwp_conrad_custom_taxonomies)) return;
			foreach($fastwp_conrad_custom_taxonomies as $slug=>$details){
				$args =  $details['settings'];
	  			register_taxonomy($slug, $details['post_type'], $args);
			}
		}

		/**
		Register custom defined shortcodes.
		**/

		static function register_shortcodes(){
			global $fastwp_conrad_shortcodes;

			if(!isset($fastwp_conrad_shortcodes) || !is_array($fastwp_conrad_shortcodes) || count($fastwp_conrad_shortcodes) < 1) return;
			$class_name = 'fastwp_conrad_theme_shortcodes';
			if(!class_exists($class_name)){ return; }
			foreach($fastwp_conrad_shortcodes as $k=>$v){
				$shortcodeFunction = sprintf("FastWP_Conrad_Shortcode_%s",$v);
				if(function_exists($shortcodeFunction)){
					add_shortcode($k, sprintf("FastWP_Conrad_Shortcode_%s",$v));
				}
			}
		}

	}

	/**
	Register cool stuff here
	**/

	add_action('init', array('FastWP_Conrad_Functions_Plugin', 'register_custom_posts'));
	add_action('fwp_custom_post_set', array('FastWP_Conrad_Functions_Plugin', 'register_custom_posts'),1);
	add_action('init', array('FastWP_Conrad_Functions_Plugin', 'register_custom_taxonomy'));
	add_action('fwp_custom_tax_set', array('FastWP_Conrad_Functions_Plugin', 'register_custom_taxonomy'),1);
	add_action('init', array('FastWP_Conrad_Functions_Plugin', 'register_shortcodes'));
	add_action('fwp_custom_shortcodes_set', array('FastWP_Conrad_Functions_Plugin', 'register_shortcodes'),1);

}

/**
Functions used in theme
**/

if( !function_exists( 'fastwp_conrad_dec' ) ) {
    function fastwp_conrad_dec( $content ) {
        return urldecode( base64_decode( $content ) );
    }
}